import { Configuration } from '../configuration';
import { AuthenticationV1TokenRequest } from '../models/AuthenticationV1TokenRequest';
import { CoreV1Event } from '../models/CoreV1Event';
import { CoreV1EventList } from '../models/CoreV1EventList';
import { EventsV1Event } from '../models/EventsV1Event';
import { EventsV1EventList } from '../models/EventsV1EventList';
import { V1APIGroup } from '../models/V1APIGroup';
import { V1APIGroupList } from '../models/V1APIGroupList';
import { V1APIResourceList } from '../models/V1APIResourceList';
import { V1APIService } from '../models/V1APIService';
import { V1APIServiceList } from '../models/V1APIServiceList';
import { V1APIVersions } from '../models/V1APIVersions';
import { V1Binding } from '../models/V1Binding';
import { V1CSIDriver } from '../models/V1CSIDriver';
import { V1CSIDriverList } from '../models/V1CSIDriverList';
import { V1CSINode } from '../models/V1CSINode';
import { V1CSINodeList } from '../models/V1CSINodeList';
import { V1CertificateSigningRequest } from '../models/V1CertificateSigningRequest';
import { V1CertificateSigningRequestList } from '../models/V1CertificateSigningRequestList';
import { V1ClusterRole } from '../models/V1ClusterRole';
import { V1ClusterRoleBinding } from '../models/V1ClusterRoleBinding';
import { V1ClusterRoleBindingList } from '../models/V1ClusterRoleBindingList';
import { V1ClusterRoleList } from '../models/V1ClusterRoleList';
import { V1ComponentStatus } from '../models/V1ComponentStatus';
import { V1ComponentStatusList } from '../models/V1ComponentStatusList';
import { V1ConfigMap } from '../models/V1ConfigMap';
import { V1ConfigMapList } from '../models/V1ConfigMapList';
import { V1ControllerRevision } from '../models/V1ControllerRevision';
import { V1ControllerRevisionList } from '../models/V1ControllerRevisionList';
import { V1CronJob } from '../models/V1CronJob';
import { V1CronJobList } from '../models/V1CronJobList';
import { V1CustomResourceDefinition } from '../models/V1CustomResourceDefinition';
import { V1CustomResourceDefinitionList } from '../models/V1CustomResourceDefinitionList';
import { V1DaemonSet } from '../models/V1DaemonSet';
import { V1DaemonSetList } from '../models/V1DaemonSetList';
import { V1DeleteOptions } from '../models/V1DeleteOptions';
import { V1Deployment } from '../models/V1Deployment';
import { V1DeploymentList } from '../models/V1DeploymentList';
import { V1EndpointSlice } from '../models/V1EndpointSlice';
import { V1EndpointSliceList } from '../models/V1EndpointSliceList';
import { V1Endpoints } from '../models/V1Endpoints';
import { V1EndpointsList } from '../models/V1EndpointsList';
import { V1Eviction } from '../models/V1Eviction';
import { V1HorizontalPodAutoscaler } from '../models/V1HorizontalPodAutoscaler';
import { V1HorizontalPodAutoscalerList } from '../models/V1HorizontalPodAutoscalerList';
import { V1Ingress } from '../models/V1Ingress';
import { V1IngressClass } from '../models/V1IngressClass';
import { V1IngressClassList } from '../models/V1IngressClassList';
import { V1IngressList } from '../models/V1IngressList';
import { V1Job } from '../models/V1Job';
import { V1JobList } from '../models/V1JobList';
import { V1Lease } from '../models/V1Lease';
import { V1LeaseList } from '../models/V1LeaseList';
import { V1LimitRange } from '../models/V1LimitRange';
import { V1LimitRangeList } from '../models/V1LimitRangeList';
import { V1LocalSubjectAccessReview } from '../models/V1LocalSubjectAccessReview';
import { V1MutatingWebhookConfiguration } from '../models/V1MutatingWebhookConfiguration';
import { V1MutatingWebhookConfigurationList } from '../models/V1MutatingWebhookConfigurationList';
import { V1Namespace } from '../models/V1Namespace';
import { V1NamespaceList } from '../models/V1NamespaceList';
import { V1NetworkPolicy } from '../models/V1NetworkPolicy';
import { V1NetworkPolicyList } from '../models/V1NetworkPolicyList';
import { V1Node } from '../models/V1Node';
import { V1NodeList } from '../models/V1NodeList';
import { V1PersistentVolume } from '../models/V1PersistentVolume';
import { V1PersistentVolumeClaim } from '../models/V1PersistentVolumeClaim';
import { V1PersistentVolumeClaimList } from '../models/V1PersistentVolumeClaimList';
import { V1PersistentVolumeList } from '../models/V1PersistentVolumeList';
import { V1Pod } from '../models/V1Pod';
import { V1PodDisruptionBudget } from '../models/V1PodDisruptionBudget';
import { V1PodDisruptionBudgetList } from '../models/V1PodDisruptionBudgetList';
import { V1PodList } from '../models/V1PodList';
import { V1PodTemplate } from '../models/V1PodTemplate';
import { V1PodTemplateList } from '../models/V1PodTemplateList';
import { V1PriorityClass } from '../models/V1PriorityClass';
import { V1PriorityClassList } from '../models/V1PriorityClassList';
import { V1ReplicaSet } from '../models/V1ReplicaSet';
import { V1ReplicaSetList } from '../models/V1ReplicaSetList';
import { V1ReplicationController } from '../models/V1ReplicationController';
import { V1ReplicationControllerList } from '../models/V1ReplicationControllerList';
import { V1ResourceQuota } from '../models/V1ResourceQuota';
import { V1ResourceQuotaList } from '../models/V1ResourceQuotaList';
import { V1Role } from '../models/V1Role';
import { V1RoleBinding } from '../models/V1RoleBinding';
import { V1RoleBindingList } from '../models/V1RoleBindingList';
import { V1RoleList } from '../models/V1RoleList';
import { V1RuntimeClass } from '../models/V1RuntimeClass';
import { V1RuntimeClassList } from '../models/V1RuntimeClassList';
import { V1Scale } from '../models/V1Scale';
import { V1Secret } from '../models/V1Secret';
import { V1SecretList } from '../models/V1SecretList';
import { V1SelfSubjectAccessReview } from '../models/V1SelfSubjectAccessReview';
import { V1SelfSubjectRulesReview } from '../models/V1SelfSubjectRulesReview';
import { V1Service } from '../models/V1Service';
import { V1ServiceAccount } from '../models/V1ServiceAccount';
import { V1ServiceAccountList } from '../models/V1ServiceAccountList';
import { V1ServiceList } from '../models/V1ServiceList';
import { V1StatefulSet } from '../models/V1StatefulSet';
import { V1StatefulSetList } from '../models/V1StatefulSetList';
import { V1Status } from '../models/V1Status';
import { V1StorageClass } from '../models/V1StorageClass';
import { V1StorageClassList } from '../models/V1StorageClassList';
import { V1SubjectAccessReview } from '../models/V1SubjectAccessReview';
import { V1TokenReview } from '../models/V1TokenReview';
import { V1ValidatingWebhookConfiguration } from '../models/V1ValidatingWebhookConfiguration';
import { V1ValidatingWebhookConfigurationList } from '../models/V1ValidatingWebhookConfigurationList';
import { V1VolumeAttachment } from '../models/V1VolumeAttachment';
import { V1VolumeAttachmentList } from '../models/V1VolumeAttachmentList';
import { V1alpha1CSIStorageCapacity } from '../models/V1alpha1CSIStorageCapacity';
import { V1alpha1CSIStorageCapacityList } from '../models/V1alpha1CSIStorageCapacityList';
import { V1alpha1ClusterRole } from '../models/V1alpha1ClusterRole';
import { V1alpha1ClusterRoleBinding } from '../models/V1alpha1ClusterRoleBinding';
import { V1alpha1ClusterRoleBindingList } from '../models/V1alpha1ClusterRoleBindingList';
import { V1alpha1ClusterRoleList } from '../models/V1alpha1ClusterRoleList';
import { V1alpha1PriorityClass } from '../models/V1alpha1PriorityClass';
import { V1alpha1PriorityClassList } from '../models/V1alpha1PriorityClassList';
import { V1alpha1Role } from '../models/V1alpha1Role';
import { V1alpha1RoleBinding } from '../models/V1alpha1RoleBinding';
import { V1alpha1RoleBindingList } from '../models/V1alpha1RoleBindingList';
import { V1alpha1RoleList } from '../models/V1alpha1RoleList';
import { V1alpha1RuntimeClass } from '../models/V1alpha1RuntimeClass';
import { V1alpha1RuntimeClassList } from '../models/V1alpha1RuntimeClassList';
import { V1alpha1StorageVersion } from '../models/V1alpha1StorageVersion';
import { V1alpha1StorageVersionList } from '../models/V1alpha1StorageVersionList';
import { V1alpha1VolumeAttachment } from '../models/V1alpha1VolumeAttachment';
import { V1alpha1VolumeAttachmentList } from '../models/V1alpha1VolumeAttachmentList';
import { V1beta1CSIStorageCapacity } from '../models/V1beta1CSIStorageCapacity';
import { V1beta1CSIStorageCapacityList } from '../models/V1beta1CSIStorageCapacityList';
import { V1beta1CronJob } from '../models/V1beta1CronJob';
import { V1beta1CronJobList } from '../models/V1beta1CronJobList';
import { V1beta1EndpointSlice } from '../models/V1beta1EndpointSlice';
import { V1beta1EndpointSliceList } from '../models/V1beta1EndpointSliceList';
import { V1beta1Event } from '../models/V1beta1Event';
import { V1beta1EventList } from '../models/V1beta1EventList';
import { V1beta1FlowSchema } from '../models/V1beta1FlowSchema';
import { V1beta1FlowSchemaList } from '../models/V1beta1FlowSchemaList';
import { V1beta1PodDisruptionBudget } from '../models/V1beta1PodDisruptionBudget';
import { V1beta1PodDisruptionBudgetList } from '../models/V1beta1PodDisruptionBudgetList';
import { V1beta1PodSecurityPolicy } from '../models/V1beta1PodSecurityPolicy';
import { V1beta1PodSecurityPolicyList } from '../models/V1beta1PodSecurityPolicyList';
import { V1beta1PriorityLevelConfiguration } from '../models/V1beta1PriorityLevelConfiguration';
import { V1beta1PriorityLevelConfigurationList } from '../models/V1beta1PriorityLevelConfigurationList';
import { V1beta1RuntimeClass } from '../models/V1beta1RuntimeClass';
import { V1beta1RuntimeClassList } from '../models/V1beta1RuntimeClassList';
import { V2beta1HorizontalPodAutoscaler } from '../models/V2beta1HorizontalPodAutoscaler';
import { V2beta1HorizontalPodAutoscalerList } from '../models/V2beta1HorizontalPodAutoscalerList';
import { V2beta2HorizontalPodAutoscaler } from '../models/V2beta2HorizontalPodAutoscaler';
import { V2beta2HorizontalPodAutoscalerList } from '../models/V2beta2HorizontalPodAutoscalerList';
import { VersionInfo } from '../models/VersionInfo';
import { AdmissionregistrationApiRequestFactory, AdmissionregistrationApiResponseProcessor } from "../apis/AdmissionregistrationApi";
export interface AdmissionregistrationApiGetAPIGroupRequest {
}
export declare class ObjectAdmissionregistrationApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: AdmissionregistrationApiRequestFactory, responseProcessor?: AdmissionregistrationApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: AdmissionregistrationApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { AdmissionregistrationV1ApiRequestFactory, AdmissionregistrationV1ApiResponseProcessor } from "../apis/AdmissionregistrationV1Api";
export interface AdmissionregistrationV1ApiCreateMutatingWebhookConfigurationRequest {
    /**
     *
     * @type V1MutatingWebhookConfiguration
     * @memberof AdmissionregistrationV1ApicreateMutatingWebhookConfiguration
     */
    body: V1MutatingWebhookConfiguration;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApicreateMutatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApicreateMutatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AdmissionregistrationV1ApicreateMutatingWebhookConfiguration
     */
    fieldManager?: string;
}
export interface AdmissionregistrationV1ApiCreateValidatingWebhookConfigurationRequest {
    /**
     *
     * @type V1ValidatingWebhookConfiguration
     * @memberof AdmissionregistrationV1ApicreateValidatingWebhookConfiguration
     */
    body: V1ValidatingWebhookConfiguration;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApicreateValidatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApicreateValidatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AdmissionregistrationV1ApicreateValidatingWebhookConfiguration
     */
    fieldManager?: string;
}
export interface AdmissionregistrationV1ApiDeleteCollectionMutatingWebhookConfigurationRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AdmissionregistrationV1ApideleteCollectionMutatingWebhookConfiguration
     */
    body?: V1DeleteOptions;
}
export interface AdmissionregistrationV1ApiDeleteCollectionValidatingWebhookConfigurationRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AdmissionregistrationV1ApideleteCollectionValidatingWebhookConfiguration
     */
    body?: V1DeleteOptions;
}
export interface AdmissionregistrationV1ApiDeleteMutatingWebhookConfigurationRequest {
    /**
     * name of the MutatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApideleteMutatingWebhookConfiguration
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteMutatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApideleteMutatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteMutatingWebhookConfiguration
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AdmissionregistrationV1ApideleteMutatingWebhookConfiguration
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteMutatingWebhookConfiguration
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AdmissionregistrationV1ApideleteMutatingWebhookConfiguration
     */
    body?: V1DeleteOptions;
}
export interface AdmissionregistrationV1ApiDeleteValidatingWebhookConfigurationRequest {
    /**
     * name of the ValidatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApideleteValidatingWebhookConfiguration
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteValidatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApideleteValidatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AdmissionregistrationV1ApideleteValidatingWebhookConfiguration
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AdmissionregistrationV1ApideleteValidatingWebhookConfiguration
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AdmissionregistrationV1ApideleteValidatingWebhookConfiguration
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AdmissionregistrationV1ApideleteValidatingWebhookConfiguration
     */
    body?: V1DeleteOptions;
}
export interface AdmissionregistrationV1ApiGetAPIResourcesRequest {
}
export interface AdmissionregistrationV1ApiListMutatingWebhookConfigurationRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AdmissionregistrationV1ApilistMutatingWebhookConfiguration
     */
    watch?: boolean;
}
export interface AdmissionregistrationV1ApiListValidatingWebhookConfigurationRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AdmissionregistrationV1ApilistValidatingWebhookConfiguration
     */
    watch?: boolean;
}
export interface AdmissionregistrationV1ApiPatchMutatingWebhookConfigurationRequest {
    /**
     * name of the MutatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApipatchMutatingWebhookConfiguration
     */
    name: string;
    /**
     *
     * @type any
     * @memberof AdmissionregistrationV1ApipatchMutatingWebhookConfiguration
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApipatchMutatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApipatchMutatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AdmissionregistrationV1ApipatchMutatingWebhookConfiguration
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AdmissionregistrationV1ApipatchMutatingWebhookConfiguration
     */
    force?: boolean;
}
export interface AdmissionregistrationV1ApiPatchValidatingWebhookConfigurationRequest {
    /**
     * name of the ValidatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApipatchValidatingWebhookConfiguration
     */
    name: string;
    /**
     *
     * @type any
     * @memberof AdmissionregistrationV1ApipatchValidatingWebhookConfiguration
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApipatchValidatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApipatchValidatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AdmissionregistrationV1ApipatchValidatingWebhookConfiguration
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AdmissionregistrationV1ApipatchValidatingWebhookConfiguration
     */
    force?: boolean;
}
export interface AdmissionregistrationV1ApiReadMutatingWebhookConfigurationRequest {
    /**
     * name of the MutatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApireadMutatingWebhookConfiguration
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApireadMutatingWebhookConfiguration
     */
    pretty?: string;
}
export interface AdmissionregistrationV1ApiReadValidatingWebhookConfigurationRequest {
    /**
     * name of the ValidatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApireadValidatingWebhookConfiguration
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApireadValidatingWebhookConfiguration
     */
    pretty?: string;
}
export interface AdmissionregistrationV1ApiReplaceMutatingWebhookConfigurationRequest {
    /**
     * name of the MutatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceMutatingWebhookConfiguration
     */
    name: string;
    /**
     *
     * @type V1MutatingWebhookConfiguration
     * @memberof AdmissionregistrationV1ApireplaceMutatingWebhookConfiguration
     */
    body: V1MutatingWebhookConfiguration;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceMutatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceMutatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceMutatingWebhookConfiguration
     */
    fieldManager?: string;
}
export interface AdmissionregistrationV1ApiReplaceValidatingWebhookConfigurationRequest {
    /**
     * name of the ValidatingWebhookConfiguration
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceValidatingWebhookConfiguration
     */
    name: string;
    /**
     *
     * @type V1ValidatingWebhookConfiguration
     * @memberof AdmissionregistrationV1ApireplaceValidatingWebhookConfiguration
     */
    body: V1ValidatingWebhookConfiguration;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceValidatingWebhookConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceValidatingWebhookConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AdmissionregistrationV1ApireplaceValidatingWebhookConfiguration
     */
    fieldManager?: string;
}
export declare class ObjectAdmissionregistrationV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: AdmissionregistrationV1ApiRequestFactory, responseProcessor?: AdmissionregistrationV1ApiResponseProcessor);
    /**
     * create a MutatingWebhookConfiguration
     * @param param the request object
     */
    createMutatingWebhookConfiguration(param: AdmissionregistrationV1ApiCreateMutatingWebhookConfigurationRequest, options?: Configuration): Promise<V1MutatingWebhookConfiguration>;
    /**
     * create a ValidatingWebhookConfiguration
     * @param param the request object
     */
    createValidatingWebhookConfiguration(param: AdmissionregistrationV1ApiCreateValidatingWebhookConfigurationRequest, options?: Configuration): Promise<V1ValidatingWebhookConfiguration>;
    /**
     * delete collection of MutatingWebhookConfiguration
     * @param param the request object
     */
    deleteCollectionMutatingWebhookConfiguration(param?: AdmissionregistrationV1ApiDeleteCollectionMutatingWebhookConfigurationRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ValidatingWebhookConfiguration
     * @param param the request object
     */
    deleteCollectionValidatingWebhookConfiguration(param?: AdmissionregistrationV1ApiDeleteCollectionValidatingWebhookConfigurationRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a MutatingWebhookConfiguration
     * @param param the request object
     */
    deleteMutatingWebhookConfiguration(param: AdmissionregistrationV1ApiDeleteMutatingWebhookConfigurationRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ValidatingWebhookConfiguration
     * @param param the request object
     */
    deleteValidatingWebhookConfiguration(param: AdmissionregistrationV1ApiDeleteValidatingWebhookConfigurationRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: AdmissionregistrationV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind MutatingWebhookConfiguration
     * @param param the request object
     */
    listMutatingWebhookConfiguration(param?: AdmissionregistrationV1ApiListMutatingWebhookConfigurationRequest, options?: Configuration): Promise<V1MutatingWebhookConfigurationList>;
    /**
     * list or watch objects of kind ValidatingWebhookConfiguration
     * @param param the request object
     */
    listValidatingWebhookConfiguration(param?: AdmissionregistrationV1ApiListValidatingWebhookConfigurationRequest, options?: Configuration): Promise<V1ValidatingWebhookConfigurationList>;
    /**
     * partially update the specified MutatingWebhookConfiguration
     * @param param the request object
     */
    patchMutatingWebhookConfiguration(param: AdmissionregistrationV1ApiPatchMutatingWebhookConfigurationRequest, options?: Configuration): Promise<V1MutatingWebhookConfiguration>;
    /**
     * partially update the specified ValidatingWebhookConfiguration
     * @param param the request object
     */
    patchValidatingWebhookConfiguration(param: AdmissionregistrationV1ApiPatchValidatingWebhookConfigurationRequest, options?: Configuration): Promise<V1ValidatingWebhookConfiguration>;
    /**
     * read the specified MutatingWebhookConfiguration
     * @param param the request object
     */
    readMutatingWebhookConfiguration(param: AdmissionregistrationV1ApiReadMutatingWebhookConfigurationRequest, options?: Configuration): Promise<V1MutatingWebhookConfiguration>;
    /**
     * read the specified ValidatingWebhookConfiguration
     * @param param the request object
     */
    readValidatingWebhookConfiguration(param: AdmissionregistrationV1ApiReadValidatingWebhookConfigurationRequest, options?: Configuration): Promise<V1ValidatingWebhookConfiguration>;
    /**
     * replace the specified MutatingWebhookConfiguration
     * @param param the request object
     */
    replaceMutatingWebhookConfiguration(param: AdmissionregistrationV1ApiReplaceMutatingWebhookConfigurationRequest, options?: Configuration): Promise<V1MutatingWebhookConfiguration>;
    /**
     * replace the specified ValidatingWebhookConfiguration
     * @param param the request object
     */
    replaceValidatingWebhookConfiguration(param: AdmissionregistrationV1ApiReplaceValidatingWebhookConfigurationRequest, options?: Configuration): Promise<V1ValidatingWebhookConfiguration>;
}
import { ApiextensionsApiRequestFactory, ApiextensionsApiResponseProcessor } from "../apis/ApiextensionsApi";
export interface ApiextensionsApiGetAPIGroupRequest {
}
export declare class ObjectApiextensionsApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: ApiextensionsApiRequestFactory, responseProcessor?: ApiextensionsApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: ApiextensionsApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { ApiextensionsV1ApiRequestFactory, ApiextensionsV1ApiResponseProcessor } from "../apis/ApiextensionsV1Api";
export interface ApiextensionsV1ApiCreateCustomResourceDefinitionRequest {
    /**
     *
     * @type V1CustomResourceDefinition
     * @memberof ApiextensionsV1ApicreateCustomResourceDefinition
     */
    body: V1CustomResourceDefinition;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApicreateCustomResourceDefinition
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiextensionsV1ApicreateCustomResourceDefinition
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof ApiextensionsV1ApicreateCustomResourceDefinition
     */
    fieldManager?: string;
}
export interface ApiextensionsV1ApiDeleteCollectionCustomResourceDefinitionRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof ApiextensionsV1ApideleteCollectionCustomResourceDefinition
     */
    body?: V1DeleteOptions;
}
export interface ApiextensionsV1ApiDeleteCustomResourceDefinitionRequest {
    /**
     * name of the CustomResourceDefinition
     * @type string
     * @memberof ApiextensionsV1ApideleteCustomResourceDefinition
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApideleteCustomResourceDefinition
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiextensionsV1ApideleteCustomResourceDefinition
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof ApiextensionsV1ApideleteCustomResourceDefinition
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof ApiextensionsV1ApideleteCustomResourceDefinition
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof ApiextensionsV1ApideleteCustomResourceDefinition
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof ApiextensionsV1ApideleteCustomResourceDefinition
     */
    body?: V1DeleteOptions;
}
export interface ApiextensionsV1ApiGetAPIResourcesRequest {
}
export interface ApiextensionsV1ApiListCustomResourceDefinitionRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof ApiextensionsV1ApilistCustomResourceDefinition
     */
    watch?: boolean;
}
export interface ApiextensionsV1ApiPatchCustomResourceDefinitionRequest {
    /**
     * name of the CustomResourceDefinition
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinition
     */
    name: string;
    /**
     *
     * @type any
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinition
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinition
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinition
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinition
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinition
     */
    force?: boolean;
}
export interface ApiextensionsV1ApiPatchCustomResourceDefinitionStatusRequest {
    /**
     * name of the CustomResourceDefinition
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinitionStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinitionStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinitionStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinitionStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinitionStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof ApiextensionsV1ApipatchCustomResourceDefinitionStatus
     */
    force?: boolean;
}
export interface ApiextensionsV1ApiReadCustomResourceDefinitionRequest {
    /**
     * name of the CustomResourceDefinition
     * @type string
     * @memberof ApiextensionsV1ApireadCustomResourceDefinition
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApireadCustomResourceDefinition
     */
    pretty?: string;
}
export interface ApiextensionsV1ApiReadCustomResourceDefinitionStatusRequest {
    /**
     * name of the CustomResourceDefinition
     * @type string
     * @memberof ApiextensionsV1ApireadCustomResourceDefinitionStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApireadCustomResourceDefinitionStatus
     */
    pretty?: string;
}
export interface ApiextensionsV1ApiReplaceCustomResourceDefinitionRequest {
    /**
     * name of the CustomResourceDefinition
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinition
     */
    name: string;
    /**
     *
     * @type V1CustomResourceDefinition
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinition
     */
    body: V1CustomResourceDefinition;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinition
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinition
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinition
     */
    fieldManager?: string;
}
export interface ApiextensionsV1ApiReplaceCustomResourceDefinitionStatusRequest {
    /**
     * name of the CustomResourceDefinition
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinitionStatus
     */
    name: string;
    /**
     *
     * @type V1CustomResourceDefinition
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinitionStatus
     */
    body: V1CustomResourceDefinition;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinitionStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinitionStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof ApiextensionsV1ApireplaceCustomResourceDefinitionStatus
     */
    fieldManager?: string;
}
export declare class ObjectApiextensionsV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: ApiextensionsV1ApiRequestFactory, responseProcessor?: ApiextensionsV1ApiResponseProcessor);
    /**
     * create a CustomResourceDefinition
     * @param param the request object
     */
    createCustomResourceDefinition(param: ApiextensionsV1ApiCreateCustomResourceDefinitionRequest, options?: Configuration): Promise<V1CustomResourceDefinition>;
    /**
     * delete collection of CustomResourceDefinition
     * @param param the request object
     */
    deleteCollectionCustomResourceDefinition(param?: ApiextensionsV1ApiDeleteCollectionCustomResourceDefinitionRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a CustomResourceDefinition
     * @param param the request object
     */
    deleteCustomResourceDefinition(param: ApiextensionsV1ApiDeleteCustomResourceDefinitionRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: ApiextensionsV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind CustomResourceDefinition
     * @param param the request object
     */
    listCustomResourceDefinition(param?: ApiextensionsV1ApiListCustomResourceDefinitionRequest, options?: Configuration): Promise<V1CustomResourceDefinitionList>;
    /**
     * partially update the specified CustomResourceDefinition
     * @param param the request object
     */
    patchCustomResourceDefinition(param: ApiextensionsV1ApiPatchCustomResourceDefinitionRequest, options?: Configuration): Promise<V1CustomResourceDefinition>;
    /**
     * partially update status of the specified CustomResourceDefinition
     * @param param the request object
     */
    patchCustomResourceDefinitionStatus(param: ApiextensionsV1ApiPatchCustomResourceDefinitionStatusRequest, options?: Configuration): Promise<V1CustomResourceDefinition>;
    /**
     * read the specified CustomResourceDefinition
     * @param param the request object
     */
    readCustomResourceDefinition(param: ApiextensionsV1ApiReadCustomResourceDefinitionRequest, options?: Configuration): Promise<V1CustomResourceDefinition>;
    /**
     * read status of the specified CustomResourceDefinition
     * @param param the request object
     */
    readCustomResourceDefinitionStatus(param: ApiextensionsV1ApiReadCustomResourceDefinitionStatusRequest, options?: Configuration): Promise<V1CustomResourceDefinition>;
    /**
     * replace the specified CustomResourceDefinition
     * @param param the request object
     */
    replaceCustomResourceDefinition(param: ApiextensionsV1ApiReplaceCustomResourceDefinitionRequest, options?: Configuration): Promise<V1CustomResourceDefinition>;
    /**
     * replace status of the specified CustomResourceDefinition
     * @param param the request object
     */
    replaceCustomResourceDefinitionStatus(param: ApiextensionsV1ApiReplaceCustomResourceDefinitionStatusRequest, options?: Configuration): Promise<V1CustomResourceDefinition>;
}
import { ApiregistrationApiRequestFactory, ApiregistrationApiResponseProcessor } from "../apis/ApiregistrationApi";
export interface ApiregistrationApiGetAPIGroupRequest {
}
export declare class ObjectApiregistrationApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: ApiregistrationApiRequestFactory, responseProcessor?: ApiregistrationApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: ApiregistrationApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { ApiregistrationV1ApiRequestFactory, ApiregistrationV1ApiResponseProcessor } from "../apis/ApiregistrationV1Api";
export interface ApiregistrationV1ApiCreateAPIServiceRequest {
    /**
     *
     * @type V1APIService
     * @memberof ApiregistrationV1ApicreateAPIService
     */
    body: V1APIService;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApicreateAPIService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiregistrationV1ApicreateAPIService
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof ApiregistrationV1ApicreateAPIService
     */
    fieldManager?: string;
}
export interface ApiregistrationV1ApiDeleteAPIServiceRequest {
    /**
     * name of the APIService
     * @type string
     * @memberof ApiregistrationV1ApideleteAPIService
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApideleteAPIService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiregistrationV1ApideleteAPIService
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof ApiregistrationV1ApideleteAPIService
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof ApiregistrationV1ApideleteAPIService
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof ApiregistrationV1ApideleteAPIService
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof ApiregistrationV1ApideleteAPIService
     */
    body?: V1DeleteOptions;
}
export interface ApiregistrationV1ApiDeleteCollectionAPIServiceRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof ApiregistrationV1ApideleteCollectionAPIService
     */
    body?: V1DeleteOptions;
}
export interface ApiregistrationV1ApiGetAPIResourcesRequest {
}
export interface ApiregistrationV1ApiListAPIServiceRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApilistAPIService
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof ApiregistrationV1ApilistAPIService
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof ApiregistrationV1ApilistAPIService
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof ApiregistrationV1ApilistAPIService
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof ApiregistrationV1ApilistAPIService
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof ApiregistrationV1ApilistAPIService
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiregistrationV1ApilistAPIService
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof ApiregistrationV1ApilistAPIService
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof ApiregistrationV1ApilistAPIService
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof ApiregistrationV1ApilistAPIService
     */
    watch?: boolean;
}
export interface ApiregistrationV1ApiPatchAPIServiceRequest {
    /**
     * name of the APIService
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIService
     */
    name: string;
    /**
     *
     * @type any
     * @memberof ApiregistrationV1ApipatchAPIService
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIService
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIService
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof ApiregistrationV1ApipatchAPIService
     */
    force?: boolean;
}
export interface ApiregistrationV1ApiPatchAPIServiceStatusRequest {
    /**
     * name of the APIService
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIServiceStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof ApiregistrationV1ApipatchAPIServiceStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIServiceStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIServiceStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof ApiregistrationV1ApipatchAPIServiceStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof ApiregistrationV1ApipatchAPIServiceStatus
     */
    force?: boolean;
}
export interface ApiregistrationV1ApiReadAPIServiceRequest {
    /**
     * name of the APIService
     * @type string
     * @memberof ApiregistrationV1ApireadAPIService
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApireadAPIService
     */
    pretty?: string;
}
export interface ApiregistrationV1ApiReadAPIServiceStatusRequest {
    /**
     * name of the APIService
     * @type string
     * @memberof ApiregistrationV1ApireadAPIServiceStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApireadAPIServiceStatus
     */
    pretty?: string;
}
export interface ApiregistrationV1ApiReplaceAPIServiceRequest {
    /**
     * name of the APIService
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIService
     */
    name: string;
    /**
     *
     * @type V1APIService
     * @memberof ApiregistrationV1ApireplaceAPIService
     */
    body: V1APIService;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIService
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIService
     */
    fieldManager?: string;
}
export interface ApiregistrationV1ApiReplaceAPIServiceStatusRequest {
    /**
     * name of the APIService
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIServiceStatus
     */
    name: string;
    /**
     *
     * @type V1APIService
     * @memberof ApiregistrationV1ApireplaceAPIServiceStatus
     */
    body: V1APIService;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIServiceStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIServiceStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof ApiregistrationV1ApireplaceAPIServiceStatus
     */
    fieldManager?: string;
}
export declare class ObjectApiregistrationV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: ApiregistrationV1ApiRequestFactory, responseProcessor?: ApiregistrationV1ApiResponseProcessor);
    /**
     * create an APIService
     * @param param the request object
     */
    createAPIService(param: ApiregistrationV1ApiCreateAPIServiceRequest, options?: Configuration): Promise<V1APIService>;
    /**
     * delete an APIService
     * @param param the request object
     */
    deleteAPIService(param: ApiregistrationV1ApiDeleteAPIServiceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of APIService
     * @param param the request object
     */
    deleteCollectionAPIService(param?: ApiregistrationV1ApiDeleteCollectionAPIServiceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: ApiregistrationV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind APIService
     * @param param the request object
     */
    listAPIService(param?: ApiregistrationV1ApiListAPIServiceRequest, options?: Configuration): Promise<V1APIServiceList>;
    /**
     * partially update the specified APIService
     * @param param the request object
     */
    patchAPIService(param: ApiregistrationV1ApiPatchAPIServiceRequest, options?: Configuration): Promise<V1APIService>;
    /**
     * partially update status of the specified APIService
     * @param param the request object
     */
    patchAPIServiceStatus(param: ApiregistrationV1ApiPatchAPIServiceStatusRequest, options?: Configuration): Promise<V1APIService>;
    /**
     * read the specified APIService
     * @param param the request object
     */
    readAPIService(param: ApiregistrationV1ApiReadAPIServiceRequest, options?: Configuration): Promise<V1APIService>;
    /**
     * read status of the specified APIService
     * @param param the request object
     */
    readAPIServiceStatus(param: ApiregistrationV1ApiReadAPIServiceStatusRequest, options?: Configuration): Promise<V1APIService>;
    /**
     * replace the specified APIService
     * @param param the request object
     */
    replaceAPIService(param: ApiregistrationV1ApiReplaceAPIServiceRequest, options?: Configuration): Promise<V1APIService>;
    /**
     * replace status of the specified APIService
     * @param param the request object
     */
    replaceAPIServiceStatus(param: ApiregistrationV1ApiReplaceAPIServiceStatusRequest, options?: Configuration): Promise<V1APIService>;
}
import { ApisApiRequestFactory, ApisApiResponseProcessor } from "../apis/ApisApi";
export interface ApisApiGetAPIVersionsRequest {
}
export declare class ObjectApisApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: ApisApiRequestFactory, responseProcessor?: ApisApiResponseProcessor);
    /**
     * get available API versions
     * @param param the request object
     */
    getAPIVersions(param?: ApisApiGetAPIVersionsRequest, options?: Configuration): Promise<V1APIGroupList>;
}
import { AppsApiRequestFactory, AppsApiResponseProcessor } from "../apis/AppsApi";
export interface AppsApiGetAPIGroupRequest {
}
export declare class ObjectAppsApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: AppsApiRequestFactory, responseProcessor?: AppsApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: AppsApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { AppsV1ApiRequestFactory, AppsV1ApiResponseProcessor } from "../apis/AppsV1Api";
export interface AppsV1ApiCreateNamespacedControllerRevisionRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApicreateNamespacedControllerRevision
     */
    namespace: string;
    /**
     *
     * @type V1ControllerRevision
     * @memberof AppsV1ApicreateNamespacedControllerRevision
     */
    body: V1ControllerRevision;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApicreateNamespacedControllerRevision
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApicreateNamespacedControllerRevision
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApicreateNamespacedControllerRevision
     */
    fieldManager?: string;
}
export interface AppsV1ApiCreateNamespacedDaemonSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApicreateNamespacedDaemonSet
     */
    namespace: string;
    /**
     *
     * @type V1DaemonSet
     * @memberof AppsV1ApicreateNamespacedDaemonSet
     */
    body: V1DaemonSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApicreateNamespacedDaemonSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApicreateNamespacedDaemonSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApicreateNamespacedDaemonSet
     */
    fieldManager?: string;
}
export interface AppsV1ApiCreateNamespacedDeploymentRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApicreateNamespacedDeployment
     */
    namespace: string;
    /**
     *
     * @type V1Deployment
     * @memberof AppsV1ApicreateNamespacedDeployment
     */
    body: V1Deployment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApicreateNamespacedDeployment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApicreateNamespacedDeployment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApicreateNamespacedDeployment
     */
    fieldManager?: string;
}
export interface AppsV1ApiCreateNamespacedReplicaSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApicreateNamespacedReplicaSet
     */
    namespace: string;
    /**
     *
     * @type V1ReplicaSet
     * @memberof AppsV1ApicreateNamespacedReplicaSet
     */
    body: V1ReplicaSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApicreateNamespacedReplicaSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApicreateNamespacedReplicaSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApicreateNamespacedReplicaSet
     */
    fieldManager?: string;
}
export interface AppsV1ApiCreateNamespacedStatefulSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApicreateNamespacedStatefulSet
     */
    namespace: string;
    /**
     *
     * @type V1StatefulSet
     * @memberof AppsV1ApicreateNamespacedStatefulSet
     */
    body: V1StatefulSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApicreateNamespacedStatefulSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApicreateNamespacedStatefulSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApicreateNamespacedStatefulSet
     */
    fieldManager?: string;
}
export interface AppsV1ApiDeleteCollectionNamespacedControllerRevisionRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteCollectionNamespacedControllerRevision
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteCollectionNamespacedDaemonSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteCollectionNamespacedDaemonSet
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteCollectionNamespacedDeploymentRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteCollectionNamespacedDeployment
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteCollectionNamespacedReplicaSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteCollectionNamespacedReplicaSet
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteCollectionNamespacedStatefulSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteCollectionNamespacedStatefulSet
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteNamespacedControllerRevisionRequest {
    /**
     * name of the ControllerRevision
     * @type string
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteNamespacedControllerRevision
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteNamespacedDaemonSetRequest {
    /**
     * name of the DaemonSet
     * @type string
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteNamespacedDaemonSet
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteNamespacedDeploymentRequest {
    /**
     * name of the Deployment
     * @type string
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteNamespacedDeployment
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteNamespacedReplicaSetRequest {
    /**
     * name of the ReplicaSet
     * @type string
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteNamespacedReplicaSet
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiDeleteNamespacedStatefulSetRequest {
    /**
     * name of the StatefulSet
     * @type string
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AppsV1ApideleteNamespacedStatefulSet
     */
    body?: V1DeleteOptions;
}
export interface AppsV1ApiGetAPIResourcesRequest {
}
export interface AppsV1ApiListControllerRevisionForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistControllerRevisionForAllNamespaces
     */
    watch?: boolean;
}
export interface AppsV1ApiListDaemonSetForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistDaemonSetForAllNamespaces
     */
    watch?: boolean;
}
export interface AppsV1ApiListDeploymentForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistDeploymentForAllNamespaces
     */
    watch?: boolean;
}
export interface AppsV1ApiListNamespacedControllerRevisionRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedControllerRevision
     */
    watch?: boolean;
}
export interface AppsV1ApiListNamespacedDaemonSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedDaemonSet
     */
    watch?: boolean;
}
export interface AppsV1ApiListNamespacedDeploymentRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedDeployment
     */
    watch?: boolean;
}
export interface AppsV1ApiListNamespacedReplicaSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedReplicaSet
     */
    watch?: boolean;
}
export interface AppsV1ApiListNamespacedStatefulSetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistNamespacedStatefulSet
     */
    watch?: boolean;
}
export interface AppsV1ApiListReplicaSetForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistReplicaSetForAllNamespaces
     */
    watch?: boolean;
}
export interface AppsV1ApiListStatefulSetForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AppsV1ApilistStatefulSetForAllNamespaces
     */
    watch?: boolean;
}
export interface AppsV1ApiPatchNamespacedControllerRevisionRequest {
    /**
     * name of the ControllerRevision
     * @type string
     * @memberof AppsV1ApipatchNamespacedControllerRevision
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedControllerRevision
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedControllerRevision
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedControllerRevision
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedControllerRevision
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedControllerRevision
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedControllerRevision
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedDaemonSetRequest {
    /**
     * name of the DaemonSet
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSet
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedDaemonSet
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSet
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedDaemonSet
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedDaemonSetStatusRequest {
    /**
     * name of the DaemonSet
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSetStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedDaemonSetStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedDaemonSetStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedDaemonSetStatus
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedDeploymentRequest {
    /**
     * name of the Deployment
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeployment
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeployment
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedDeployment
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeployment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeployment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeployment
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedDeployment
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedDeploymentScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentScale
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedDeploymentScale
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentScale
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedDeploymentScale
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedDeploymentStatusRequest {
    /**
     * name of the Deployment
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedDeploymentStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedDeploymentStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedDeploymentStatus
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedReplicaSetRequest {
    /**
     * name of the ReplicaSet
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSet
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedReplicaSet
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSet
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedReplicaSet
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedReplicaSetScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetScale
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedReplicaSetScale
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetScale
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedReplicaSetScale
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedReplicaSetStatusRequest {
    /**
     * name of the ReplicaSet
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedReplicaSetStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedReplicaSetStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedReplicaSetStatus
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedStatefulSetRequest {
    /**
     * name of the StatefulSet
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSet
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedStatefulSet
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSet
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedStatefulSet
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedStatefulSetScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetScale
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedStatefulSetScale
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetScale
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedStatefulSetScale
     */
    force?: boolean;
}
export interface AppsV1ApiPatchNamespacedStatefulSetStatusRequest {
    /**
     * name of the StatefulSet
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AppsV1ApipatchNamespacedStatefulSetStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AppsV1ApipatchNamespacedStatefulSetStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AppsV1ApipatchNamespacedStatefulSetStatus
     */
    force?: boolean;
}
export interface AppsV1ApiReadNamespacedControllerRevisionRequest {
    /**
     * name of the ControllerRevision
     * @type string
     * @memberof AppsV1ApireadNamespacedControllerRevision
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedControllerRevision
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedControllerRevision
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedDaemonSetRequest {
    /**
     * name of the DaemonSet
     * @type string
     * @memberof AppsV1ApireadNamespacedDaemonSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedDaemonSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedDaemonSet
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedDaemonSetStatusRequest {
    /**
     * name of the DaemonSet
     * @type string
     * @memberof AppsV1ApireadNamespacedDaemonSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedDaemonSetStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedDaemonSetStatus
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedDeploymentRequest {
    /**
     * name of the Deployment
     * @type string
     * @memberof AppsV1ApireadNamespacedDeployment
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedDeployment
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedDeployment
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedDeploymentScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApireadNamespacedDeploymentScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedDeploymentScale
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedDeploymentScale
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedDeploymentStatusRequest {
    /**
     * name of the Deployment
     * @type string
     * @memberof AppsV1ApireadNamespacedDeploymentStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedDeploymentStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedDeploymentStatus
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedReplicaSetRequest {
    /**
     * name of the ReplicaSet
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSet
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedReplicaSetScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSetScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSetScale
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSetScale
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedReplicaSetStatusRequest {
    /**
     * name of the ReplicaSet
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSetStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedReplicaSetStatus
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedStatefulSetRequest {
    /**
     * name of the StatefulSet
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSet
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSet
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedStatefulSetScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSetScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSetScale
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSetScale
     */
    pretty?: string;
}
export interface AppsV1ApiReadNamespacedStatefulSetStatusRequest {
    /**
     * name of the StatefulSet
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSetStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireadNamespacedStatefulSetStatus
     */
    pretty?: string;
}
export interface AppsV1ApiReplaceNamespacedControllerRevisionRequest {
    /**
     * name of the ControllerRevision
     * @type string
     * @memberof AppsV1ApireplaceNamespacedControllerRevision
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedControllerRevision
     */
    namespace: string;
    /**
     *
     * @type V1ControllerRevision
     * @memberof AppsV1ApireplaceNamespacedControllerRevision
     */
    body: V1ControllerRevision;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedControllerRevision
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedControllerRevision
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedControllerRevision
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedDaemonSetRequest {
    /**
     * name of the DaemonSet
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSet
     */
    namespace: string;
    /**
     *
     * @type V1DaemonSet
     * @memberof AppsV1ApireplaceNamespacedDaemonSet
     */
    body: V1DaemonSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSet
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedDaemonSetStatusRequest {
    /**
     * name of the DaemonSet
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSetStatus
     */
    namespace: string;
    /**
     *
     * @type V1DaemonSet
     * @memberof AppsV1ApireplaceNamespacedDaemonSetStatus
     */
    body: V1DaemonSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDaemonSetStatus
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedDeploymentRequest {
    /**
     * name of the Deployment
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeployment
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeployment
     */
    namespace: string;
    /**
     *
     * @type V1Deployment
     * @memberof AppsV1ApireplaceNamespacedDeployment
     */
    body: V1Deployment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeployment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeployment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeployment
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedDeploymentScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentScale
     */
    namespace: string;
    /**
     *
     * @type V1Scale
     * @memberof AppsV1ApireplaceNamespacedDeploymentScale
     */
    body: V1Scale;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentScale
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedDeploymentStatusRequest {
    /**
     * name of the Deployment
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentStatus
     */
    namespace: string;
    /**
     *
     * @type V1Deployment
     * @memberof AppsV1ApireplaceNamespacedDeploymentStatus
     */
    body: V1Deployment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedDeploymentStatus
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedReplicaSetRequest {
    /**
     * name of the ReplicaSet
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSet
     */
    namespace: string;
    /**
     *
     * @type V1ReplicaSet
     * @memberof AppsV1ApireplaceNamespacedReplicaSet
     */
    body: V1ReplicaSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSet
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedReplicaSetScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetScale
     */
    namespace: string;
    /**
     *
     * @type V1Scale
     * @memberof AppsV1ApireplaceNamespacedReplicaSetScale
     */
    body: V1Scale;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetScale
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedReplicaSetStatusRequest {
    /**
     * name of the ReplicaSet
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetStatus
     */
    namespace: string;
    /**
     *
     * @type V1ReplicaSet
     * @memberof AppsV1ApireplaceNamespacedReplicaSetStatus
     */
    body: V1ReplicaSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedReplicaSetStatus
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedStatefulSetRequest {
    /**
     * name of the StatefulSet
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSet
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSet
     */
    namespace: string;
    /**
     *
     * @type V1StatefulSet
     * @memberof AppsV1ApireplaceNamespacedStatefulSet
     */
    body: V1StatefulSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSet
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSet
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSet
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedStatefulSetScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetScale
     */
    namespace: string;
    /**
     *
     * @type V1Scale
     * @memberof AppsV1ApireplaceNamespacedStatefulSetScale
     */
    body: V1Scale;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetScale
     */
    fieldManager?: string;
}
export interface AppsV1ApiReplaceNamespacedStatefulSetStatusRequest {
    /**
     * name of the StatefulSet
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetStatus
     */
    namespace: string;
    /**
     *
     * @type V1StatefulSet
     * @memberof AppsV1ApireplaceNamespacedStatefulSetStatus
     */
    body: V1StatefulSet;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AppsV1ApireplaceNamespacedStatefulSetStatus
     */
    fieldManager?: string;
}
export declare class ObjectAppsV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: AppsV1ApiRequestFactory, responseProcessor?: AppsV1ApiResponseProcessor);
    /**
     * create a ControllerRevision
     * @param param the request object
     */
    createNamespacedControllerRevision(param: AppsV1ApiCreateNamespacedControllerRevisionRequest, options?: Configuration): Promise<V1ControllerRevision>;
    /**
     * create a DaemonSet
     * @param param the request object
     */
    createNamespacedDaemonSet(param: AppsV1ApiCreateNamespacedDaemonSetRequest, options?: Configuration): Promise<V1DaemonSet>;
    /**
     * create a Deployment
     * @param param the request object
     */
    createNamespacedDeployment(param: AppsV1ApiCreateNamespacedDeploymentRequest, options?: Configuration): Promise<V1Deployment>;
    /**
     * create a ReplicaSet
     * @param param the request object
     */
    createNamespacedReplicaSet(param: AppsV1ApiCreateNamespacedReplicaSetRequest, options?: Configuration): Promise<V1ReplicaSet>;
    /**
     * create a StatefulSet
     * @param param the request object
     */
    createNamespacedStatefulSet(param: AppsV1ApiCreateNamespacedStatefulSetRequest, options?: Configuration): Promise<V1StatefulSet>;
    /**
     * delete collection of ControllerRevision
     * @param param the request object
     */
    deleteCollectionNamespacedControllerRevision(param: AppsV1ApiDeleteCollectionNamespacedControllerRevisionRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of DaemonSet
     * @param param the request object
     */
    deleteCollectionNamespacedDaemonSet(param: AppsV1ApiDeleteCollectionNamespacedDaemonSetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Deployment
     * @param param the request object
     */
    deleteCollectionNamespacedDeployment(param: AppsV1ApiDeleteCollectionNamespacedDeploymentRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ReplicaSet
     * @param param the request object
     */
    deleteCollectionNamespacedReplicaSet(param: AppsV1ApiDeleteCollectionNamespacedReplicaSetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of StatefulSet
     * @param param the request object
     */
    deleteCollectionNamespacedStatefulSet(param: AppsV1ApiDeleteCollectionNamespacedStatefulSetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ControllerRevision
     * @param param the request object
     */
    deleteNamespacedControllerRevision(param: AppsV1ApiDeleteNamespacedControllerRevisionRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a DaemonSet
     * @param param the request object
     */
    deleteNamespacedDaemonSet(param: AppsV1ApiDeleteNamespacedDaemonSetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a Deployment
     * @param param the request object
     */
    deleteNamespacedDeployment(param: AppsV1ApiDeleteNamespacedDeploymentRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ReplicaSet
     * @param param the request object
     */
    deleteNamespacedReplicaSet(param: AppsV1ApiDeleteNamespacedReplicaSetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a StatefulSet
     * @param param the request object
     */
    deleteNamespacedStatefulSet(param: AppsV1ApiDeleteNamespacedStatefulSetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: AppsV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind ControllerRevision
     * @param param the request object
     */
    listControllerRevisionForAllNamespaces(param?: AppsV1ApiListControllerRevisionForAllNamespacesRequest, options?: Configuration): Promise<V1ControllerRevisionList>;
    /**
     * list or watch objects of kind DaemonSet
     * @param param the request object
     */
    listDaemonSetForAllNamespaces(param?: AppsV1ApiListDaemonSetForAllNamespacesRequest, options?: Configuration): Promise<V1DaemonSetList>;
    /**
     * list or watch objects of kind Deployment
     * @param param the request object
     */
    listDeploymentForAllNamespaces(param?: AppsV1ApiListDeploymentForAllNamespacesRequest, options?: Configuration): Promise<V1DeploymentList>;
    /**
     * list or watch objects of kind ControllerRevision
     * @param param the request object
     */
    listNamespacedControllerRevision(param: AppsV1ApiListNamespacedControllerRevisionRequest, options?: Configuration): Promise<V1ControllerRevisionList>;
    /**
     * list or watch objects of kind DaemonSet
     * @param param the request object
     */
    listNamespacedDaemonSet(param: AppsV1ApiListNamespacedDaemonSetRequest, options?: Configuration): Promise<V1DaemonSetList>;
    /**
     * list or watch objects of kind Deployment
     * @param param the request object
     */
    listNamespacedDeployment(param: AppsV1ApiListNamespacedDeploymentRequest, options?: Configuration): Promise<V1DeploymentList>;
    /**
     * list or watch objects of kind ReplicaSet
     * @param param the request object
     */
    listNamespacedReplicaSet(param: AppsV1ApiListNamespacedReplicaSetRequest, options?: Configuration): Promise<V1ReplicaSetList>;
    /**
     * list or watch objects of kind StatefulSet
     * @param param the request object
     */
    listNamespacedStatefulSet(param: AppsV1ApiListNamespacedStatefulSetRequest, options?: Configuration): Promise<V1StatefulSetList>;
    /**
     * list or watch objects of kind ReplicaSet
     * @param param the request object
     */
    listReplicaSetForAllNamespaces(param?: AppsV1ApiListReplicaSetForAllNamespacesRequest, options?: Configuration): Promise<V1ReplicaSetList>;
    /**
     * list or watch objects of kind StatefulSet
     * @param param the request object
     */
    listStatefulSetForAllNamespaces(param?: AppsV1ApiListStatefulSetForAllNamespacesRequest, options?: Configuration): Promise<V1StatefulSetList>;
    /**
     * partially update the specified ControllerRevision
     * @param param the request object
     */
    patchNamespacedControllerRevision(param: AppsV1ApiPatchNamespacedControllerRevisionRequest, options?: Configuration): Promise<V1ControllerRevision>;
    /**
     * partially update the specified DaemonSet
     * @param param the request object
     */
    patchNamespacedDaemonSet(param: AppsV1ApiPatchNamespacedDaemonSetRequest, options?: Configuration): Promise<V1DaemonSet>;
    /**
     * partially update status of the specified DaemonSet
     * @param param the request object
     */
    patchNamespacedDaemonSetStatus(param: AppsV1ApiPatchNamespacedDaemonSetStatusRequest, options?: Configuration): Promise<V1DaemonSet>;
    /**
     * partially update the specified Deployment
     * @param param the request object
     */
    patchNamespacedDeployment(param: AppsV1ApiPatchNamespacedDeploymentRequest, options?: Configuration): Promise<V1Deployment>;
    /**
     * partially update scale of the specified Deployment
     * @param param the request object
     */
    patchNamespacedDeploymentScale(param: AppsV1ApiPatchNamespacedDeploymentScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * partially update status of the specified Deployment
     * @param param the request object
     */
    patchNamespacedDeploymentStatus(param: AppsV1ApiPatchNamespacedDeploymentStatusRequest, options?: Configuration): Promise<V1Deployment>;
    /**
     * partially update the specified ReplicaSet
     * @param param the request object
     */
    patchNamespacedReplicaSet(param: AppsV1ApiPatchNamespacedReplicaSetRequest, options?: Configuration): Promise<V1ReplicaSet>;
    /**
     * partially update scale of the specified ReplicaSet
     * @param param the request object
     */
    patchNamespacedReplicaSetScale(param: AppsV1ApiPatchNamespacedReplicaSetScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * partially update status of the specified ReplicaSet
     * @param param the request object
     */
    patchNamespacedReplicaSetStatus(param: AppsV1ApiPatchNamespacedReplicaSetStatusRequest, options?: Configuration): Promise<V1ReplicaSet>;
    /**
     * partially update the specified StatefulSet
     * @param param the request object
     */
    patchNamespacedStatefulSet(param: AppsV1ApiPatchNamespacedStatefulSetRequest, options?: Configuration): Promise<V1StatefulSet>;
    /**
     * partially update scale of the specified StatefulSet
     * @param param the request object
     */
    patchNamespacedStatefulSetScale(param: AppsV1ApiPatchNamespacedStatefulSetScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * partially update status of the specified StatefulSet
     * @param param the request object
     */
    patchNamespacedStatefulSetStatus(param: AppsV1ApiPatchNamespacedStatefulSetStatusRequest, options?: Configuration): Promise<V1StatefulSet>;
    /**
     * read the specified ControllerRevision
     * @param param the request object
     */
    readNamespacedControllerRevision(param: AppsV1ApiReadNamespacedControllerRevisionRequest, options?: Configuration): Promise<V1ControllerRevision>;
    /**
     * read the specified DaemonSet
     * @param param the request object
     */
    readNamespacedDaemonSet(param: AppsV1ApiReadNamespacedDaemonSetRequest, options?: Configuration): Promise<V1DaemonSet>;
    /**
     * read status of the specified DaemonSet
     * @param param the request object
     */
    readNamespacedDaemonSetStatus(param: AppsV1ApiReadNamespacedDaemonSetStatusRequest, options?: Configuration): Promise<V1DaemonSet>;
    /**
     * read the specified Deployment
     * @param param the request object
     */
    readNamespacedDeployment(param: AppsV1ApiReadNamespacedDeploymentRequest, options?: Configuration): Promise<V1Deployment>;
    /**
     * read scale of the specified Deployment
     * @param param the request object
     */
    readNamespacedDeploymentScale(param: AppsV1ApiReadNamespacedDeploymentScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * read status of the specified Deployment
     * @param param the request object
     */
    readNamespacedDeploymentStatus(param: AppsV1ApiReadNamespacedDeploymentStatusRequest, options?: Configuration): Promise<V1Deployment>;
    /**
     * read the specified ReplicaSet
     * @param param the request object
     */
    readNamespacedReplicaSet(param: AppsV1ApiReadNamespacedReplicaSetRequest, options?: Configuration): Promise<V1ReplicaSet>;
    /**
     * read scale of the specified ReplicaSet
     * @param param the request object
     */
    readNamespacedReplicaSetScale(param: AppsV1ApiReadNamespacedReplicaSetScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * read status of the specified ReplicaSet
     * @param param the request object
     */
    readNamespacedReplicaSetStatus(param: AppsV1ApiReadNamespacedReplicaSetStatusRequest, options?: Configuration): Promise<V1ReplicaSet>;
    /**
     * read the specified StatefulSet
     * @param param the request object
     */
    readNamespacedStatefulSet(param: AppsV1ApiReadNamespacedStatefulSetRequest, options?: Configuration): Promise<V1StatefulSet>;
    /**
     * read scale of the specified StatefulSet
     * @param param the request object
     */
    readNamespacedStatefulSetScale(param: AppsV1ApiReadNamespacedStatefulSetScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * read status of the specified StatefulSet
     * @param param the request object
     */
    readNamespacedStatefulSetStatus(param: AppsV1ApiReadNamespacedStatefulSetStatusRequest, options?: Configuration): Promise<V1StatefulSet>;
    /**
     * replace the specified ControllerRevision
     * @param param the request object
     */
    replaceNamespacedControllerRevision(param: AppsV1ApiReplaceNamespacedControllerRevisionRequest, options?: Configuration): Promise<V1ControllerRevision>;
    /**
     * replace the specified DaemonSet
     * @param param the request object
     */
    replaceNamespacedDaemonSet(param: AppsV1ApiReplaceNamespacedDaemonSetRequest, options?: Configuration): Promise<V1DaemonSet>;
    /**
     * replace status of the specified DaemonSet
     * @param param the request object
     */
    replaceNamespacedDaemonSetStatus(param: AppsV1ApiReplaceNamespacedDaemonSetStatusRequest, options?: Configuration): Promise<V1DaemonSet>;
    /**
     * replace the specified Deployment
     * @param param the request object
     */
    replaceNamespacedDeployment(param: AppsV1ApiReplaceNamespacedDeploymentRequest, options?: Configuration): Promise<V1Deployment>;
    /**
     * replace scale of the specified Deployment
     * @param param the request object
     */
    replaceNamespacedDeploymentScale(param: AppsV1ApiReplaceNamespacedDeploymentScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * replace status of the specified Deployment
     * @param param the request object
     */
    replaceNamespacedDeploymentStatus(param: AppsV1ApiReplaceNamespacedDeploymentStatusRequest, options?: Configuration): Promise<V1Deployment>;
    /**
     * replace the specified ReplicaSet
     * @param param the request object
     */
    replaceNamespacedReplicaSet(param: AppsV1ApiReplaceNamespacedReplicaSetRequest, options?: Configuration): Promise<V1ReplicaSet>;
    /**
     * replace scale of the specified ReplicaSet
     * @param param the request object
     */
    replaceNamespacedReplicaSetScale(param: AppsV1ApiReplaceNamespacedReplicaSetScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * replace status of the specified ReplicaSet
     * @param param the request object
     */
    replaceNamespacedReplicaSetStatus(param: AppsV1ApiReplaceNamespacedReplicaSetStatusRequest, options?: Configuration): Promise<V1ReplicaSet>;
    /**
     * replace the specified StatefulSet
     * @param param the request object
     */
    replaceNamespacedStatefulSet(param: AppsV1ApiReplaceNamespacedStatefulSetRequest, options?: Configuration): Promise<V1StatefulSet>;
    /**
     * replace scale of the specified StatefulSet
     * @param param the request object
     */
    replaceNamespacedStatefulSetScale(param: AppsV1ApiReplaceNamespacedStatefulSetScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * replace status of the specified StatefulSet
     * @param param the request object
     */
    replaceNamespacedStatefulSetStatus(param: AppsV1ApiReplaceNamespacedStatefulSetStatusRequest, options?: Configuration): Promise<V1StatefulSet>;
}
import { AuthenticationApiRequestFactory, AuthenticationApiResponseProcessor } from "../apis/AuthenticationApi";
export interface AuthenticationApiGetAPIGroupRequest {
}
export declare class ObjectAuthenticationApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: AuthenticationApiRequestFactory, responseProcessor?: AuthenticationApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: AuthenticationApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { AuthenticationV1ApiRequestFactory, AuthenticationV1ApiResponseProcessor } from "../apis/AuthenticationV1Api";
export interface AuthenticationV1ApiCreateTokenReviewRequest {
    /**
     *
     * @type V1TokenReview
     * @memberof AuthenticationV1ApicreateTokenReview
     */
    body: V1TokenReview;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AuthenticationV1ApicreateTokenReview
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AuthenticationV1ApicreateTokenReview
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AuthenticationV1ApicreateTokenReview
     */
    pretty?: string;
}
export interface AuthenticationV1ApiGetAPIResourcesRequest {
}
export declare class ObjectAuthenticationV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: AuthenticationV1ApiRequestFactory, responseProcessor?: AuthenticationV1ApiResponseProcessor);
    /**
     * create a TokenReview
     * @param param the request object
     */
    createTokenReview(param: AuthenticationV1ApiCreateTokenReviewRequest, options?: Configuration): Promise<V1TokenReview>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: AuthenticationV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
}
import { AuthorizationApiRequestFactory, AuthorizationApiResponseProcessor } from "../apis/AuthorizationApi";
export interface AuthorizationApiGetAPIGroupRequest {
}
export declare class ObjectAuthorizationApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: AuthorizationApiRequestFactory, responseProcessor?: AuthorizationApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: AuthorizationApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { AuthorizationV1ApiRequestFactory, AuthorizationV1ApiResponseProcessor } from "../apis/AuthorizationV1Api";
export interface AuthorizationV1ApiCreateNamespacedLocalSubjectAccessReviewRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AuthorizationV1ApicreateNamespacedLocalSubjectAccessReview
     */
    namespace: string;
    /**
     *
     * @type V1LocalSubjectAccessReview
     * @memberof AuthorizationV1ApicreateNamespacedLocalSubjectAccessReview
     */
    body: V1LocalSubjectAccessReview;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AuthorizationV1ApicreateNamespacedLocalSubjectAccessReview
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AuthorizationV1ApicreateNamespacedLocalSubjectAccessReview
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AuthorizationV1ApicreateNamespacedLocalSubjectAccessReview
     */
    pretty?: string;
}
export interface AuthorizationV1ApiCreateSelfSubjectAccessReviewRequest {
    /**
     *
     * @type V1SelfSubjectAccessReview
     * @memberof AuthorizationV1ApicreateSelfSubjectAccessReview
     */
    body: V1SelfSubjectAccessReview;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AuthorizationV1ApicreateSelfSubjectAccessReview
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AuthorizationV1ApicreateSelfSubjectAccessReview
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AuthorizationV1ApicreateSelfSubjectAccessReview
     */
    pretty?: string;
}
export interface AuthorizationV1ApiCreateSelfSubjectRulesReviewRequest {
    /**
     *
     * @type V1SelfSubjectRulesReview
     * @memberof AuthorizationV1ApicreateSelfSubjectRulesReview
     */
    body: V1SelfSubjectRulesReview;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AuthorizationV1ApicreateSelfSubjectRulesReview
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AuthorizationV1ApicreateSelfSubjectRulesReview
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AuthorizationV1ApicreateSelfSubjectRulesReview
     */
    pretty?: string;
}
export interface AuthorizationV1ApiCreateSubjectAccessReviewRequest {
    /**
     *
     * @type V1SubjectAccessReview
     * @memberof AuthorizationV1ApicreateSubjectAccessReview
     */
    body: V1SubjectAccessReview;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AuthorizationV1ApicreateSubjectAccessReview
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AuthorizationV1ApicreateSubjectAccessReview
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AuthorizationV1ApicreateSubjectAccessReview
     */
    pretty?: string;
}
export interface AuthorizationV1ApiGetAPIResourcesRequest {
}
export declare class ObjectAuthorizationV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: AuthorizationV1ApiRequestFactory, responseProcessor?: AuthorizationV1ApiResponseProcessor);
    /**
     * create a LocalSubjectAccessReview
     * @param param the request object
     */
    createNamespacedLocalSubjectAccessReview(param: AuthorizationV1ApiCreateNamespacedLocalSubjectAccessReviewRequest, options?: Configuration): Promise<V1LocalSubjectAccessReview>;
    /**
     * create a SelfSubjectAccessReview
     * @param param the request object
     */
    createSelfSubjectAccessReview(param: AuthorizationV1ApiCreateSelfSubjectAccessReviewRequest, options?: Configuration): Promise<V1SelfSubjectAccessReview>;
    /**
     * create a SelfSubjectRulesReview
     * @param param the request object
     */
    createSelfSubjectRulesReview(param: AuthorizationV1ApiCreateSelfSubjectRulesReviewRequest, options?: Configuration): Promise<V1SelfSubjectRulesReview>;
    /**
     * create a SubjectAccessReview
     * @param param the request object
     */
    createSubjectAccessReview(param: AuthorizationV1ApiCreateSubjectAccessReviewRequest, options?: Configuration): Promise<V1SubjectAccessReview>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: AuthorizationV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
}
import { AutoscalingApiRequestFactory, AutoscalingApiResponseProcessor } from "../apis/AutoscalingApi";
export interface AutoscalingApiGetAPIGroupRequest {
}
export declare class ObjectAutoscalingApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: AutoscalingApiRequestFactory, responseProcessor?: AutoscalingApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: AutoscalingApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { AutoscalingV1ApiRequestFactory, AutoscalingV1ApiResponseProcessor } from "../apis/AutoscalingV1Api";
export interface AutoscalingV1ApiCreateNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApicreateNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type V1HorizontalPodAutoscaler
     * @memberof AutoscalingV1ApicreateNamespacedHorizontalPodAutoscaler
     */
    body: V1HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApicreateNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV1ApicreateNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV1ApicreateNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
}
export interface AutoscalingV1ApiDeleteCollectionNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AutoscalingV1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    body?: V1DeleteOptions;
}
export interface AutoscalingV1ApiDeleteNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AutoscalingV1ApideleteNamespacedHorizontalPodAutoscaler
     */
    body?: V1DeleteOptions;
}
export interface AutoscalingV1ApiGetAPIResourcesRequest {
}
export interface AutoscalingV1ApiListHorizontalPodAutoscalerForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AutoscalingV1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    watch?: boolean;
}
export interface AutoscalingV1ApiListNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AutoscalingV1ApilistNamespacedHorizontalPodAutoscaler
     */
    watch?: boolean;
}
export interface AutoscalingV1ApiPatchNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscaler
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscaler
     */
    force?: boolean;
}
export interface AutoscalingV1ApiPatchNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AutoscalingV1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    force?: boolean;
}
export interface AutoscalingV1ApiReadNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV1ApireadNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApireadNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApireadNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
}
export interface AutoscalingV1ApiReadNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV1ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
}
export interface AutoscalingV1ApiReplaceNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type V1HorizontalPodAutoscaler
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    body: V1HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
}
export interface AutoscalingV1ApiReplaceNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     *
     * @type V1HorizontalPodAutoscaler
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    body: V1HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    fieldManager?: string;
}
export declare class ObjectAutoscalingV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: AutoscalingV1ApiRequestFactory, responseProcessor?: AutoscalingV1ApiResponseProcessor);
    /**
     * create a HorizontalPodAutoscaler
     * @param param the request object
     */
    createNamespacedHorizontalPodAutoscaler(param: AutoscalingV1ApiCreateNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1HorizontalPodAutoscaler>;
    /**
     * delete collection of HorizontalPodAutoscaler
     * @param param the request object
     */
    deleteCollectionNamespacedHorizontalPodAutoscaler(param: AutoscalingV1ApiDeleteCollectionNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a HorizontalPodAutoscaler
     * @param param the request object
     */
    deleteNamespacedHorizontalPodAutoscaler(param: AutoscalingV1ApiDeleteNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: AutoscalingV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind HorizontalPodAutoscaler
     * @param param the request object
     */
    listHorizontalPodAutoscalerForAllNamespaces(param?: AutoscalingV1ApiListHorizontalPodAutoscalerForAllNamespacesRequest, options?: Configuration): Promise<V1HorizontalPodAutoscalerList>;
    /**
     * list or watch objects of kind HorizontalPodAutoscaler
     * @param param the request object
     */
    listNamespacedHorizontalPodAutoscaler(param: AutoscalingV1ApiListNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1HorizontalPodAutoscalerList>;
    /**
     * partially update the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    patchNamespacedHorizontalPodAutoscaler(param: AutoscalingV1ApiPatchNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1HorizontalPodAutoscaler>;
    /**
     * partially update status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    patchNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV1ApiPatchNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V1HorizontalPodAutoscaler>;
    /**
     * read the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    readNamespacedHorizontalPodAutoscaler(param: AutoscalingV1ApiReadNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1HorizontalPodAutoscaler>;
    /**
     * read status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    readNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV1ApiReadNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V1HorizontalPodAutoscaler>;
    /**
     * replace the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    replaceNamespacedHorizontalPodAutoscaler(param: AutoscalingV1ApiReplaceNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1HorizontalPodAutoscaler>;
    /**
     * replace status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    replaceNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV1ApiReplaceNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V1HorizontalPodAutoscaler>;
}
import { AutoscalingV2beta1ApiRequestFactory, AutoscalingV2beta1ApiResponseProcessor } from "../apis/AutoscalingV2beta1Api";
export interface AutoscalingV2beta1ApiCreateNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApicreateNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type V2beta1HorizontalPodAutoscaler
     * @memberof AutoscalingV2beta1ApicreateNamespacedHorizontalPodAutoscaler
     */
    body: V2beta1HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApicreateNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta1ApicreateNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV2beta1ApicreateNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
}
export interface AutoscalingV2beta1ApiDeleteCollectionNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AutoscalingV2beta1ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    body?: V1DeleteOptions;
}
export interface AutoscalingV2beta1ApiDeleteNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AutoscalingV2beta1ApideleteNamespacedHorizontalPodAutoscaler
     */
    body?: V1DeleteOptions;
}
export interface AutoscalingV2beta1ApiGetAPIResourcesRequest {
}
export interface AutoscalingV2beta1ApiListHorizontalPodAutoscalerForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AutoscalingV2beta1ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    watch?: boolean;
}
export interface AutoscalingV2beta1ApiListNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AutoscalingV2beta1ApilistNamespacedHorizontalPodAutoscaler
     */
    watch?: boolean;
}
export interface AutoscalingV2beta1ApiPatchNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscaler
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscaler
     */
    force?: boolean;
}
export interface AutoscalingV2beta1ApiPatchNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AutoscalingV2beta1ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    force?: boolean;
}
export interface AutoscalingV2beta1ApiReadNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta1ApireadNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApireadNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApireadNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
}
export interface AutoscalingV2beta1ApiReadNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta1ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
}
export interface AutoscalingV2beta1ApiReplaceNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type V2beta1HorizontalPodAutoscaler
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    body: V2beta1HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
}
export interface AutoscalingV2beta1ApiReplaceNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     *
     * @type V2beta1HorizontalPodAutoscaler
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    body: V2beta1HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV2beta1ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    fieldManager?: string;
}
export declare class ObjectAutoscalingV2beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: AutoscalingV2beta1ApiRequestFactory, responseProcessor?: AutoscalingV2beta1ApiResponseProcessor);
    /**
     * create a HorizontalPodAutoscaler
     * @param param the request object
     */
    createNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta1ApiCreateNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscaler>;
    /**
     * delete collection of HorizontalPodAutoscaler
     * @param param the request object
     */
    deleteCollectionNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta1ApiDeleteCollectionNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a HorizontalPodAutoscaler
     * @param param the request object
     */
    deleteNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta1ApiDeleteNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: AutoscalingV2beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind HorizontalPodAutoscaler
     * @param param the request object
     */
    listHorizontalPodAutoscalerForAllNamespaces(param?: AutoscalingV2beta1ApiListHorizontalPodAutoscalerForAllNamespacesRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscalerList>;
    /**
     * list or watch objects of kind HorizontalPodAutoscaler
     * @param param the request object
     */
    listNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta1ApiListNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscalerList>;
    /**
     * partially update the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    patchNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta1ApiPatchNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscaler>;
    /**
     * partially update status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    patchNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV2beta1ApiPatchNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscaler>;
    /**
     * read the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    readNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta1ApiReadNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscaler>;
    /**
     * read status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    readNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV2beta1ApiReadNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscaler>;
    /**
     * replace the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    replaceNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta1ApiReplaceNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscaler>;
    /**
     * replace status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    replaceNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV2beta1ApiReplaceNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V2beta1HorizontalPodAutoscaler>;
}
import { AutoscalingV2beta2ApiRequestFactory, AutoscalingV2beta2ApiResponseProcessor } from "../apis/AutoscalingV2beta2Api";
export interface AutoscalingV2beta2ApiCreateNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApicreateNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type V2beta2HorizontalPodAutoscaler
     * @memberof AutoscalingV2beta2ApicreateNamespacedHorizontalPodAutoscaler
     */
    body: V2beta2HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApicreateNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta2ApicreateNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV2beta2ApicreateNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
}
export interface AutoscalingV2beta2ApiDeleteCollectionNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AutoscalingV2beta2ApideleteCollectionNamespacedHorizontalPodAutoscaler
     */
    body?: V1DeleteOptions;
}
export interface AutoscalingV2beta2ApiDeleteNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof AutoscalingV2beta2ApideleteNamespacedHorizontalPodAutoscaler
     */
    body?: V1DeleteOptions;
}
export interface AutoscalingV2beta2ApiGetAPIResourcesRequest {
}
export interface AutoscalingV2beta2ApiListHorizontalPodAutoscalerForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AutoscalingV2beta2ApilistHorizontalPodAutoscalerForAllNamespaces
     */
    watch?: boolean;
}
export interface AutoscalingV2beta2ApiListNamespacedHorizontalPodAutoscalerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof AutoscalingV2beta2ApilistNamespacedHorizontalPodAutoscaler
     */
    watch?: boolean;
}
export interface AutoscalingV2beta2ApiPatchNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscaler
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscaler
     */
    force?: boolean;
}
export interface AutoscalingV2beta2ApiPatchNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof AutoscalingV2beta2ApipatchNamespacedHorizontalPodAutoscalerStatus
     */
    force?: boolean;
}
export interface AutoscalingV2beta2ApiReadNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta2ApireadNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApireadNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApireadNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
}
export interface AutoscalingV2beta2ApiReadNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta2ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApireadNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
}
export interface AutoscalingV2beta2ApiReplaceNamespacedHorizontalPodAutoscalerRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscaler
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscaler
     */
    namespace: string;
    /**
     *
     * @type V2beta2HorizontalPodAutoscaler
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscaler
     */
    body: V2beta2HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscaler
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscaler
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscaler
     */
    fieldManager?: string;
}
export interface AutoscalingV2beta2ApiReplaceNamespacedHorizontalPodAutoscalerStatusRequest {
    /**
     * name of the HorizontalPodAutoscaler
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    namespace: string;
    /**
     *
     * @type V2beta2HorizontalPodAutoscaler
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    body: V2beta2HorizontalPodAutoscaler;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof AutoscalingV2beta2ApireplaceNamespacedHorizontalPodAutoscalerStatus
     */
    fieldManager?: string;
}
export declare class ObjectAutoscalingV2beta2Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: AutoscalingV2beta2ApiRequestFactory, responseProcessor?: AutoscalingV2beta2ApiResponseProcessor);
    /**
     * create a HorizontalPodAutoscaler
     * @param param the request object
     */
    createNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta2ApiCreateNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscaler>;
    /**
     * delete collection of HorizontalPodAutoscaler
     * @param param the request object
     */
    deleteCollectionNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta2ApiDeleteCollectionNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a HorizontalPodAutoscaler
     * @param param the request object
     */
    deleteNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta2ApiDeleteNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: AutoscalingV2beta2ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind HorizontalPodAutoscaler
     * @param param the request object
     */
    listHorizontalPodAutoscalerForAllNamespaces(param?: AutoscalingV2beta2ApiListHorizontalPodAutoscalerForAllNamespacesRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscalerList>;
    /**
     * list or watch objects of kind HorizontalPodAutoscaler
     * @param param the request object
     */
    listNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta2ApiListNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscalerList>;
    /**
     * partially update the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    patchNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta2ApiPatchNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscaler>;
    /**
     * partially update status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    patchNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV2beta2ApiPatchNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscaler>;
    /**
     * read the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    readNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta2ApiReadNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscaler>;
    /**
     * read status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    readNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV2beta2ApiReadNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscaler>;
    /**
     * replace the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    replaceNamespacedHorizontalPodAutoscaler(param: AutoscalingV2beta2ApiReplaceNamespacedHorizontalPodAutoscalerRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscaler>;
    /**
     * replace status of the specified HorizontalPodAutoscaler
     * @param param the request object
     */
    replaceNamespacedHorizontalPodAutoscalerStatus(param: AutoscalingV2beta2ApiReplaceNamespacedHorizontalPodAutoscalerStatusRequest, options?: Configuration): Promise<V2beta2HorizontalPodAutoscaler>;
}
import { BatchApiRequestFactory, BatchApiResponseProcessor } from "../apis/BatchApi";
export interface BatchApiGetAPIGroupRequest {
}
export declare class ObjectBatchApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: BatchApiRequestFactory, responseProcessor?: BatchApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: BatchApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { BatchV1ApiRequestFactory, BatchV1ApiResponseProcessor } from "../apis/BatchV1Api";
export interface BatchV1ApiCreateNamespacedCronJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApicreateNamespacedCronJob
     */
    namespace: string;
    /**
     *
     * @type V1CronJob
     * @memberof BatchV1ApicreateNamespacedCronJob
     */
    body: V1CronJob;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApicreateNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApicreateNamespacedCronJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1ApicreateNamespacedCronJob
     */
    fieldManager?: string;
}
export interface BatchV1ApiCreateNamespacedJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApicreateNamespacedJob
     */
    namespace: string;
    /**
     *
     * @type V1Job
     * @memberof BatchV1ApicreateNamespacedJob
     */
    body: V1Job;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApicreateNamespacedJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApicreateNamespacedJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1ApicreateNamespacedJob
     */
    fieldManager?: string;
}
export interface BatchV1ApiDeleteCollectionNamespacedCronJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof BatchV1ApideleteCollectionNamespacedCronJob
     */
    body?: V1DeleteOptions;
}
export interface BatchV1ApiDeleteCollectionNamespacedJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof BatchV1ApideleteCollectionNamespacedJob
     */
    body?: V1DeleteOptions;
}
export interface BatchV1ApiDeleteNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof BatchV1ApideleteNamespacedCronJob
     */
    body?: V1DeleteOptions;
}
export interface BatchV1ApiDeleteNamespacedJobRequest {
    /**
     * name of the Job
     * @type string
     * @memberof BatchV1ApideleteNamespacedJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApideleteNamespacedJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApideleteNamespacedJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApideleteNamespacedJob
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof BatchV1ApideleteNamespacedJob
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof BatchV1ApideleteNamespacedJob
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof BatchV1ApideleteNamespacedJob
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof BatchV1ApideleteNamespacedJob
     */
    body?: V1DeleteOptions;
}
export interface BatchV1ApiGetAPIResourcesRequest {
}
export interface BatchV1ApiListCronJobForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof BatchV1ApilistCronJobForAllNamespaces
     */
    watch?: boolean;
}
export interface BatchV1ApiListJobForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof BatchV1ApilistJobForAllNamespaces
     */
    watch?: boolean;
}
export interface BatchV1ApiListNamespacedCronJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof BatchV1ApilistNamespacedCronJob
     */
    watch?: boolean;
}
export interface BatchV1ApiListNamespacedJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApilistNamespacedJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApilistNamespacedJob
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof BatchV1ApilistNamespacedJob
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1ApilistNamespacedJob
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistNamespacedJob
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1ApilistNamespacedJob
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1ApilistNamespacedJob
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistNamespacedJob
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1ApilistNamespacedJob
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1ApilistNamespacedJob
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof BatchV1ApilistNamespacedJob
     */
    watch?: boolean;
}
export interface BatchV1ApiPatchNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJob
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof BatchV1ApipatchNamespacedCronJob
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJob
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof BatchV1ApipatchNamespacedCronJob
     */
    force?: boolean;
}
export interface BatchV1ApiPatchNamespacedCronJobStatusRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJobStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof BatchV1ApipatchNamespacedCronJobStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJobStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJobStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof BatchV1ApipatchNamespacedCronJobStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof BatchV1ApipatchNamespacedCronJobStatus
     */
    force?: boolean;
}
export interface BatchV1ApiPatchNamespacedJobRequest {
    /**
     * name of the Job
     * @type string
     * @memberof BatchV1ApipatchNamespacedJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApipatchNamespacedJob
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof BatchV1ApipatchNamespacedJob
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApipatchNamespacedJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApipatchNamespacedJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof BatchV1ApipatchNamespacedJob
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof BatchV1ApipatchNamespacedJob
     */
    force?: boolean;
}
export interface BatchV1ApiPatchNamespacedJobStatusRequest {
    /**
     * name of the Job
     * @type string
     * @memberof BatchV1ApipatchNamespacedJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApipatchNamespacedJobStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof BatchV1ApipatchNamespacedJobStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApipatchNamespacedJobStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApipatchNamespacedJobStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof BatchV1ApipatchNamespacedJobStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof BatchV1ApipatchNamespacedJobStatus
     */
    force?: boolean;
}
export interface BatchV1ApiReadNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1ApireadNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireadNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireadNamespacedCronJob
     */
    pretty?: string;
}
export interface BatchV1ApiReadNamespacedCronJobStatusRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1ApireadNamespacedCronJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireadNamespacedCronJobStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireadNamespacedCronJobStatus
     */
    pretty?: string;
}
export interface BatchV1ApiReadNamespacedJobRequest {
    /**
     * name of the Job
     * @type string
     * @memberof BatchV1ApireadNamespacedJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireadNamespacedJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireadNamespacedJob
     */
    pretty?: string;
}
export interface BatchV1ApiReadNamespacedJobStatusRequest {
    /**
     * name of the Job
     * @type string
     * @memberof BatchV1ApireadNamespacedJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireadNamespacedJobStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireadNamespacedJobStatus
     */
    pretty?: string;
}
export interface BatchV1ApiReplaceNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJob
     */
    namespace: string;
    /**
     *
     * @type V1CronJob
     * @memberof BatchV1ApireplaceNamespacedCronJob
     */
    body: V1CronJob;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJob
     */
    fieldManager?: string;
}
export interface BatchV1ApiReplaceNamespacedCronJobStatusRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJobStatus
     */
    namespace: string;
    /**
     *
     * @type V1CronJob
     * @memberof BatchV1ApireplaceNamespacedCronJobStatus
     */
    body: V1CronJob;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJobStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJobStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedCronJobStatus
     */
    fieldManager?: string;
}
export interface BatchV1ApiReplaceNamespacedJobRequest {
    /**
     * name of the Job
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJob
     */
    namespace: string;
    /**
     *
     * @type V1Job
     * @memberof BatchV1ApireplaceNamespacedJob
     */
    body: V1Job;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJob
     */
    fieldManager?: string;
}
export interface BatchV1ApiReplaceNamespacedJobStatusRequest {
    /**
     * name of the Job
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJobStatus
     */
    namespace: string;
    /**
     *
     * @type V1Job
     * @memberof BatchV1ApireplaceNamespacedJobStatus
     */
    body: V1Job;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJobStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJobStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1ApireplaceNamespacedJobStatus
     */
    fieldManager?: string;
}
export declare class ObjectBatchV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: BatchV1ApiRequestFactory, responseProcessor?: BatchV1ApiResponseProcessor);
    /**
     * create a CronJob
     * @param param the request object
     */
    createNamespacedCronJob(param: BatchV1ApiCreateNamespacedCronJobRequest, options?: Configuration): Promise<V1CronJob>;
    /**
     * create a Job
     * @param param the request object
     */
    createNamespacedJob(param: BatchV1ApiCreateNamespacedJobRequest, options?: Configuration): Promise<V1Job>;
    /**
     * delete collection of CronJob
     * @param param the request object
     */
    deleteCollectionNamespacedCronJob(param: BatchV1ApiDeleteCollectionNamespacedCronJobRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Job
     * @param param the request object
     */
    deleteCollectionNamespacedJob(param: BatchV1ApiDeleteCollectionNamespacedJobRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a CronJob
     * @param param the request object
     */
    deleteNamespacedCronJob(param: BatchV1ApiDeleteNamespacedCronJobRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a Job
     * @param param the request object
     */
    deleteNamespacedJob(param: BatchV1ApiDeleteNamespacedJobRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: BatchV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind CronJob
     * @param param the request object
     */
    listCronJobForAllNamespaces(param?: BatchV1ApiListCronJobForAllNamespacesRequest, options?: Configuration): Promise<V1CronJobList>;
    /**
     * list or watch objects of kind Job
     * @param param the request object
     */
    listJobForAllNamespaces(param?: BatchV1ApiListJobForAllNamespacesRequest, options?: Configuration): Promise<V1JobList>;
    /**
     * list or watch objects of kind CronJob
     * @param param the request object
     */
    listNamespacedCronJob(param: BatchV1ApiListNamespacedCronJobRequest, options?: Configuration): Promise<V1CronJobList>;
    /**
     * list or watch objects of kind Job
     * @param param the request object
     */
    listNamespacedJob(param: BatchV1ApiListNamespacedJobRequest, options?: Configuration): Promise<V1JobList>;
    /**
     * partially update the specified CronJob
     * @param param the request object
     */
    patchNamespacedCronJob(param: BatchV1ApiPatchNamespacedCronJobRequest, options?: Configuration): Promise<V1CronJob>;
    /**
     * partially update status of the specified CronJob
     * @param param the request object
     */
    patchNamespacedCronJobStatus(param: BatchV1ApiPatchNamespacedCronJobStatusRequest, options?: Configuration): Promise<V1CronJob>;
    /**
     * partially update the specified Job
     * @param param the request object
     */
    patchNamespacedJob(param: BatchV1ApiPatchNamespacedJobRequest, options?: Configuration): Promise<V1Job>;
    /**
     * partially update status of the specified Job
     * @param param the request object
     */
    patchNamespacedJobStatus(param: BatchV1ApiPatchNamespacedJobStatusRequest, options?: Configuration): Promise<V1Job>;
    /**
     * read the specified CronJob
     * @param param the request object
     */
    readNamespacedCronJob(param: BatchV1ApiReadNamespacedCronJobRequest, options?: Configuration): Promise<V1CronJob>;
    /**
     * read status of the specified CronJob
     * @param param the request object
     */
    readNamespacedCronJobStatus(param: BatchV1ApiReadNamespacedCronJobStatusRequest, options?: Configuration): Promise<V1CronJob>;
    /**
     * read the specified Job
     * @param param the request object
     */
    readNamespacedJob(param: BatchV1ApiReadNamespacedJobRequest, options?: Configuration): Promise<V1Job>;
    /**
     * read status of the specified Job
     * @param param the request object
     */
    readNamespacedJobStatus(param: BatchV1ApiReadNamespacedJobStatusRequest, options?: Configuration): Promise<V1Job>;
    /**
     * replace the specified CronJob
     * @param param the request object
     */
    replaceNamespacedCronJob(param: BatchV1ApiReplaceNamespacedCronJobRequest, options?: Configuration): Promise<V1CronJob>;
    /**
     * replace status of the specified CronJob
     * @param param the request object
     */
    replaceNamespacedCronJobStatus(param: BatchV1ApiReplaceNamespacedCronJobStatusRequest, options?: Configuration): Promise<V1CronJob>;
    /**
     * replace the specified Job
     * @param param the request object
     */
    replaceNamespacedJob(param: BatchV1ApiReplaceNamespacedJobRequest, options?: Configuration): Promise<V1Job>;
    /**
     * replace status of the specified Job
     * @param param the request object
     */
    replaceNamespacedJobStatus(param: BatchV1ApiReplaceNamespacedJobStatusRequest, options?: Configuration): Promise<V1Job>;
}
import { BatchV1beta1ApiRequestFactory, BatchV1beta1ApiResponseProcessor } from "../apis/BatchV1beta1Api";
export interface BatchV1beta1ApiCreateNamespacedCronJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApicreateNamespacedCronJob
     */
    namespace: string;
    /**
     *
     * @type V1beta1CronJob
     * @memberof BatchV1beta1ApicreateNamespacedCronJob
     */
    body: V1beta1CronJob;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApicreateNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1beta1ApicreateNamespacedCronJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1beta1ApicreateNamespacedCronJob
     */
    fieldManager?: string;
}
export interface BatchV1beta1ApiDeleteCollectionNamespacedCronJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof BatchV1beta1ApideleteCollectionNamespacedCronJob
     */
    body?: V1DeleteOptions;
}
export interface BatchV1beta1ApiDeleteNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof BatchV1beta1ApideleteNamespacedCronJob
     */
    body?: V1DeleteOptions;
}
export interface BatchV1beta1ApiGetAPIResourcesRequest {
}
export interface BatchV1beta1ApiListCronJobForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof BatchV1beta1ApilistCronJobForAllNamespaces
     */
    watch?: boolean;
}
export interface BatchV1beta1ApiListNamespacedCronJobRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof BatchV1beta1ApilistNamespacedCronJob
     */
    watch?: boolean;
}
export interface BatchV1beta1ApiPatchNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJob
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof BatchV1beta1ApipatchNamespacedCronJob
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJob
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof BatchV1beta1ApipatchNamespacedCronJob
     */
    force?: boolean;
}
export interface BatchV1beta1ApiPatchNamespacedCronJobStatusRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJobStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof BatchV1beta1ApipatchNamespacedCronJobStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJobStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJobStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof BatchV1beta1ApipatchNamespacedCronJobStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof BatchV1beta1ApipatchNamespacedCronJobStatus
     */
    force?: boolean;
}
export interface BatchV1beta1ApiReadNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1beta1ApireadNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApireadNamespacedCronJob
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApireadNamespacedCronJob
     */
    pretty?: string;
}
export interface BatchV1beta1ApiReadNamespacedCronJobStatusRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1beta1ApireadNamespacedCronJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApireadNamespacedCronJobStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApireadNamespacedCronJobStatus
     */
    pretty?: string;
}
export interface BatchV1beta1ApiReplaceNamespacedCronJobRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJob
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJob
     */
    namespace: string;
    /**
     *
     * @type V1beta1CronJob
     * @memberof BatchV1beta1ApireplaceNamespacedCronJob
     */
    body: V1beta1CronJob;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJob
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJob
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJob
     */
    fieldManager?: string;
}
export interface BatchV1beta1ApiReplaceNamespacedCronJobStatusRequest {
    /**
     * name of the CronJob
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJobStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJobStatus
     */
    namespace: string;
    /**
     *
     * @type V1beta1CronJob
     * @memberof BatchV1beta1ApireplaceNamespacedCronJobStatus
     */
    body: V1beta1CronJob;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJobStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJobStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof BatchV1beta1ApireplaceNamespacedCronJobStatus
     */
    fieldManager?: string;
}
export declare class ObjectBatchV1beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: BatchV1beta1ApiRequestFactory, responseProcessor?: BatchV1beta1ApiResponseProcessor);
    /**
     * create a CronJob
     * @param param the request object
     */
    createNamespacedCronJob(param: BatchV1beta1ApiCreateNamespacedCronJobRequest, options?: Configuration): Promise<V1beta1CronJob>;
    /**
     * delete collection of CronJob
     * @param param the request object
     */
    deleteCollectionNamespacedCronJob(param: BatchV1beta1ApiDeleteCollectionNamespacedCronJobRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a CronJob
     * @param param the request object
     */
    deleteNamespacedCronJob(param: BatchV1beta1ApiDeleteNamespacedCronJobRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: BatchV1beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind CronJob
     * @param param the request object
     */
    listCronJobForAllNamespaces(param?: BatchV1beta1ApiListCronJobForAllNamespacesRequest, options?: Configuration): Promise<V1beta1CronJobList>;
    /**
     * list or watch objects of kind CronJob
     * @param param the request object
     */
    listNamespacedCronJob(param: BatchV1beta1ApiListNamespacedCronJobRequest, options?: Configuration): Promise<V1beta1CronJobList>;
    /**
     * partially update the specified CronJob
     * @param param the request object
     */
    patchNamespacedCronJob(param: BatchV1beta1ApiPatchNamespacedCronJobRequest, options?: Configuration): Promise<V1beta1CronJob>;
    /**
     * partially update status of the specified CronJob
     * @param param the request object
     */
    patchNamespacedCronJobStatus(param: BatchV1beta1ApiPatchNamespacedCronJobStatusRequest, options?: Configuration): Promise<V1beta1CronJob>;
    /**
     * read the specified CronJob
     * @param param the request object
     */
    readNamespacedCronJob(param: BatchV1beta1ApiReadNamespacedCronJobRequest, options?: Configuration): Promise<V1beta1CronJob>;
    /**
     * read status of the specified CronJob
     * @param param the request object
     */
    readNamespacedCronJobStatus(param: BatchV1beta1ApiReadNamespacedCronJobStatusRequest, options?: Configuration): Promise<V1beta1CronJob>;
    /**
     * replace the specified CronJob
     * @param param the request object
     */
    replaceNamespacedCronJob(param: BatchV1beta1ApiReplaceNamespacedCronJobRequest, options?: Configuration): Promise<V1beta1CronJob>;
    /**
     * replace status of the specified CronJob
     * @param param the request object
     */
    replaceNamespacedCronJobStatus(param: BatchV1beta1ApiReplaceNamespacedCronJobStatusRequest, options?: Configuration): Promise<V1beta1CronJob>;
}
import { CertificatesApiRequestFactory, CertificatesApiResponseProcessor } from "../apis/CertificatesApi";
export interface CertificatesApiGetAPIGroupRequest {
}
export declare class ObjectCertificatesApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: CertificatesApiRequestFactory, responseProcessor?: CertificatesApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: CertificatesApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { CertificatesV1ApiRequestFactory, CertificatesV1ApiResponseProcessor } from "../apis/CertificatesV1Api";
export interface CertificatesV1ApiCreateCertificateSigningRequestRequest {
    /**
     *
     * @type V1CertificateSigningRequest
     * @memberof CertificatesV1ApicreateCertificateSigningRequest
     */
    body: V1CertificateSigningRequest;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApicreateCertificateSigningRequest
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApicreateCertificateSigningRequest
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CertificatesV1ApicreateCertificateSigningRequest
     */
    fieldManager?: string;
}
export interface CertificatesV1ApiDeleteCertificateSigningRequestRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApideleteCertificateSigningRequest
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApideleteCertificateSigningRequest
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApideleteCertificateSigningRequest
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CertificatesV1ApideleteCertificateSigningRequest
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CertificatesV1ApideleteCertificateSigningRequest
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CertificatesV1ApideleteCertificateSigningRequest
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CertificatesV1ApideleteCertificateSigningRequest
     */
    body?: V1DeleteOptions;
}
export interface CertificatesV1ApiDeleteCollectionCertificateSigningRequestRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CertificatesV1ApideleteCollectionCertificateSigningRequest
     */
    body?: V1DeleteOptions;
}
export interface CertificatesV1ApiGetAPIResourcesRequest {
}
export interface CertificatesV1ApiListCertificateSigningRequestRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CertificatesV1ApilistCertificateSigningRequest
     */
    watch?: boolean;
}
export interface CertificatesV1ApiPatchCertificateSigningRequestRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequest
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CertificatesV1ApipatchCertificateSigningRequest
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequest
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequest
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequest
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CertificatesV1ApipatchCertificateSigningRequest
     */
    force?: boolean;
}
export interface CertificatesV1ApiPatchCertificateSigningRequestApprovalRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestApproval
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CertificatesV1ApipatchCertificateSigningRequestApproval
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestApproval
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestApproval
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestApproval
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CertificatesV1ApipatchCertificateSigningRequestApproval
     */
    force?: boolean;
}
export interface CertificatesV1ApiPatchCertificateSigningRequestStatusRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CertificatesV1ApipatchCertificateSigningRequestStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CertificatesV1ApipatchCertificateSigningRequestStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CertificatesV1ApipatchCertificateSigningRequestStatus
     */
    force?: boolean;
}
export interface CertificatesV1ApiReadCertificateSigningRequestRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApireadCertificateSigningRequest
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApireadCertificateSigningRequest
     */
    pretty?: string;
}
export interface CertificatesV1ApiReadCertificateSigningRequestApprovalRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApireadCertificateSigningRequestApproval
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApireadCertificateSigningRequestApproval
     */
    pretty?: string;
}
export interface CertificatesV1ApiReadCertificateSigningRequestStatusRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApireadCertificateSigningRequestStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApireadCertificateSigningRequestStatus
     */
    pretty?: string;
}
export interface CertificatesV1ApiReplaceCertificateSigningRequestRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequest
     */
    name: string;
    /**
     *
     * @type V1CertificateSigningRequest
     * @memberof CertificatesV1ApireplaceCertificateSigningRequest
     */
    body: V1CertificateSigningRequest;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequest
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequest
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequest
     */
    fieldManager?: string;
}
export interface CertificatesV1ApiReplaceCertificateSigningRequestApprovalRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestApproval
     */
    name: string;
    /**
     *
     * @type V1CertificateSigningRequest
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestApproval
     */
    body: V1CertificateSigningRequest;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestApproval
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestApproval
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestApproval
     */
    fieldManager?: string;
}
export interface CertificatesV1ApiReplaceCertificateSigningRequestStatusRequest {
    /**
     * name of the CertificateSigningRequest
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestStatus
     */
    name: string;
    /**
     *
     * @type V1CertificateSigningRequest
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestStatus
     */
    body: V1CertificateSigningRequest;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CertificatesV1ApireplaceCertificateSigningRequestStatus
     */
    fieldManager?: string;
}
export declare class ObjectCertificatesV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: CertificatesV1ApiRequestFactory, responseProcessor?: CertificatesV1ApiResponseProcessor);
    /**
     * create a CertificateSigningRequest
     * @param param the request object
     */
    createCertificateSigningRequest(param: CertificatesV1ApiCreateCertificateSigningRequestRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * delete a CertificateSigningRequest
     * @param param the request object
     */
    deleteCertificateSigningRequest(param: CertificatesV1ApiDeleteCertificateSigningRequestRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of CertificateSigningRequest
     * @param param the request object
     */
    deleteCollectionCertificateSigningRequest(param?: CertificatesV1ApiDeleteCollectionCertificateSigningRequestRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: CertificatesV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind CertificateSigningRequest
     * @param param the request object
     */
    listCertificateSigningRequest(param?: CertificatesV1ApiListCertificateSigningRequestRequest, options?: Configuration): Promise<V1CertificateSigningRequestList>;
    /**
     * partially update the specified CertificateSigningRequest
     * @param param the request object
     */
    patchCertificateSigningRequest(param: CertificatesV1ApiPatchCertificateSigningRequestRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * partially update approval of the specified CertificateSigningRequest
     * @param param the request object
     */
    patchCertificateSigningRequestApproval(param: CertificatesV1ApiPatchCertificateSigningRequestApprovalRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * partially update status of the specified CertificateSigningRequest
     * @param param the request object
     */
    patchCertificateSigningRequestStatus(param: CertificatesV1ApiPatchCertificateSigningRequestStatusRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * read the specified CertificateSigningRequest
     * @param param the request object
     */
    readCertificateSigningRequest(param: CertificatesV1ApiReadCertificateSigningRequestRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * read approval of the specified CertificateSigningRequest
     * @param param the request object
     */
    readCertificateSigningRequestApproval(param: CertificatesV1ApiReadCertificateSigningRequestApprovalRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * read status of the specified CertificateSigningRequest
     * @param param the request object
     */
    readCertificateSigningRequestStatus(param: CertificatesV1ApiReadCertificateSigningRequestStatusRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * replace the specified CertificateSigningRequest
     * @param param the request object
     */
    replaceCertificateSigningRequest(param: CertificatesV1ApiReplaceCertificateSigningRequestRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * replace approval of the specified CertificateSigningRequest
     * @param param the request object
     */
    replaceCertificateSigningRequestApproval(param: CertificatesV1ApiReplaceCertificateSigningRequestApprovalRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
    /**
     * replace status of the specified CertificateSigningRequest
     * @param param the request object
     */
    replaceCertificateSigningRequestStatus(param: CertificatesV1ApiReplaceCertificateSigningRequestStatusRequest, options?: Configuration): Promise<V1CertificateSigningRequest>;
}
import { CoordinationApiRequestFactory, CoordinationApiResponseProcessor } from "../apis/CoordinationApi";
export interface CoordinationApiGetAPIGroupRequest {
}
export declare class ObjectCoordinationApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: CoordinationApiRequestFactory, responseProcessor?: CoordinationApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: CoordinationApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { CoordinationV1ApiRequestFactory, CoordinationV1ApiResponseProcessor } from "../apis/CoordinationV1Api";
export interface CoordinationV1ApiCreateNamespacedLeaseRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoordinationV1ApicreateNamespacedLease
     */
    namespace: string;
    /**
     *
     * @type V1Lease
     * @memberof CoordinationV1ApicreateNamespacedLease
     */
    body: V1Lease;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApicreateNamespacedLease
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoordinationV1ApicreateNamespacedLease
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoordinationV1ApicreateNamespacedLease
     */
    fieldManager?: string;
}
export interface CoordinationV1ApiDeleteCollectionNamespacedLeaseRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoordinationV1ApideleteCollectionNamespacedLease
     */
    body?: V1DeleteOptions;
}
export interface CoordinationV1ApiDeleteNamespacedLeaseRequest {
    /**
     * name of the Lease
     * @type string
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoordinationV1ApideleteNamespacedLease
     */
    body?: V1DeleteOptions;
}
export interface CoordinationV1ApiGetAPIResourcesRequest {
}
export interface CoordinationV1ApiListLeaseForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoordinationV1ApilistLeaseForAllNamespaces
     */
    watch?: boolean;
}
export interface CoordinationV1ApiListNamespacedLeaseRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoordinationV1ApilistNamespacedLease
     */
    watch?: boolean;
}
export interface CoordinationV1ApiPatchNamespacedLeaseRequest {
    /**
     * name of the Lease
     * @type string
     * @memberof CoordinationV1ApipatchNamespacedLease
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoordinationV1ApipatchNamespacedLease
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoordinationV1ApipatchNamespacedLease
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApipatchNamespacedLease
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoordinationV1ApipatchNamespacedLease
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoordinationV1ApipatchNamespacedLease
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoordinationV1ApipatchNamespacedLease
     */
    force?: boolean;
}
export interface CoordinationV1ApiReadNamespacedLeaseRequest {
    /**
     * name of the Lease
     * @type string
     * @memberof CoordinationV1ApireadNamespacedLease
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoordinationV1ApireadNamespacedLease
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApireadNamespacedLease
     */
    pretty?: string;
}
export interface CoordinationV1ApiReplaceNamespacedLeaseRequest {
    /**
     * name of the Lease
     * @type string
     * @memberof CoordinationV1ApireplaceNamespacedLease
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoordinationV1ApireplaceNamespacedLease
     */
    namespace: string;
    /**
     *
     * @type V1Lease
     * @memberof CoordinationV1ApireplaceNamespacedLease
     */
    body: V1Lease;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoordinationV1ApireplaceNamespacedLease
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoordinationV1ApireplaceNamespacedLease
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoordinationV1ApireplaceNamespacedLease
     */
    fieldManager?: string;
}
export declare class ObjectCoordinationV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: CoordinationV1ApiRequestFactory, responseProcessor?: CoordinationV1ApiResponseProcessor);
    /**
     * create a Lease
     * @param param the request object
     */
    createNamespacedLease(param: CoordinationV1ApiCreateNamespacedLeaseRequest, options?: Configuration): Promise<V1Lease>;
    /**
     * delete collection of Lease
     * @param param the request object
     */
    deleteCollectionNamespacedLease(param: CoordinationV1ApiDeleteCollectionNamespacedLeaseRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a Lease
     * @param param the request object
     */
    deleteNamespacedLease(param: CoordinationV1ApiDeleteNamespacedLeaseRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: CoordinationV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind Lease
     * @param param the request object
     */
    listLeaseForAllNamespaces(param?: CoordinationV1ApiListLeaseForAllNamespacesRequest, options?: Configuration): Promise<V1LeaseList>;
    /**
     * list or watch objects of kind Lease
     * @param param the request object
     */
    listNamespacedLease(param: CoordinationV1ApiListNamespacedLeaseRequest, options?: Configuration): Promise<V1LeaseList>;
    /**
     * partially update the specified Lease
     * @param param the request object
     */
    patchNamespacedLease(param: CoordinationV1ApiPatchNamespacedLeaseRequest, options?: Configuration): Promise<V1Lease>;
    /**
     * read the specified Lease
     * @param param the request object
     */
    readNamespacedLease(param: CoordinationV1ApiReadNamespacedLeaseRequest, options?: Configuration): Promise<V1Lease>;
    /**
     * replace the specified Lease
     * @param param the request object
     */
    replaceNamespacedLease(param: CoordinationV1ApiReplaceNamespacedLeaseRequest, options?: Configuration): Promise<V1Lease>;
}
import { CoreApiRequestFactory, CoreApiResponseProcessor } from "../apis/CoreApi";
export interface CoreApiGetAPIVersionsRequest {
}
export declare class ObjectCoreApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: CoreApiRequestFactory, responseProcessor?: CoreApiResponseProcessor);
    /**
     * get available API versions
     * @param param the request object
     */
    getAPIVersions(param?: CoreApiGetAPIVersionsRequest, options?: Configuration): Promise<V1APIVersions>;
}
import { CoreV1ApiRequestFactory, CoreV1ApiResponseProcessor } from "../apis/CoreV1Api";
export interface CoreV1ApiConnectDeleteNamespacedPodProxyRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedPodProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedPodProxy
     */
    namespace: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedPodProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectDeleteNamespacedPodProxyWithPathRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedPodProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedPodProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedPodProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedPodProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectDeleteNamespacedServiceProxyRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedServiceProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedServiceProxy
     */
    namespace: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedServiceProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectDeleteNamespacedServiceProxyWithPathRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedServiceProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedServiceProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedServiceProxyWithPath
     */
    path: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectDeleteNamespacedServiceProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectDeleteNodeProxyRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectDeleteNodeProxy
     */
    name: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectDeleteNodeProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectDeleteNodeProxyWithPathRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectDeleteNodeProxyWithPath
     */
    name: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectDeleteNodeProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectDeleteNodeProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectGetNamespacedPodAttachRequest {
    /**
     * name of the PodAttachOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodAttach
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodAttach
     */
    namespace: string;
    /**
     * The container in which to execute the command. Defaults to only container if there is only one container in the pod.
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodAttach
     */
    container?: string;
    /**
     * Stderr if true indicates that stderr is to be redirected for the attach call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodAttach
     */
    stderr?: boolean;
    /**
     * Stdin if true, redirects the standard input stream of the pod for this call. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodAttach
     */
    stdin?: boolean;
    /**
     * Stdout if true indicates that stdout is to be redirected for the attach call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodAttach
     */
    stdout?: boolean;
    /**
     * TTY if true indicates that a tty will be allocated for the attach call. This is passed through the container runtime so the tty is allocated on the worker node by the container runtime. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodAttach
     */
    tty?: boolean;
}
export interface CoreV1ApiConnectGetNamespacedPodExecRequest {
    /**
     * name of the PodExecOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    namespace: string;
    /**
     * Command is the remote command to execute. argv array. Not executed within a shell.
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    command?: string;
    /**
     * Container in which to execute the command. Defaults to only container if there is only one container in the pod.
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    container?: string;
    /**
     * Redirect the standard error stream of the pod for this call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    stderr?: boolean;
    /**
     * Redirect the standard input stream of the pod for this call. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    stdin?: boolean;
    /**
     * Redirect the standard output stream of the pod for this call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    stdout?: boolean;
    /**
     * TTY if true indicates that a tty will be allocated for the exec call. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectGetNamespacedPodExec
     */
    tty?: boolean;
}
export interface CoreV1ApiConnectGetNamespacedPodPortforwardRequest {
    /**
     * name of the PodPortForwardOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodPortforward
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodPortforward
     */
    namespace: string;
    /**
     * List of ports to forward Required when using WebSockets
     * @type number
     * @memberof CoreV1ApiconnectGetNamespacedPodPortforward
     */
    ports?: number;
}
export interface CoreV1ApiConnectGetNamespacedPodProxyRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodProxy
     */
    namespace: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectGetNamespacedPodProxyWithPathRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedPodProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectGetNamespacedServiceProxyRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedServiceProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedServiceProxy
     */
    namespace: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedServiceProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectGetNamespacedServiceProxyWithPathRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedServiceProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedServiceProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedServiceProxyWithPath
     */
    path: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectGetNamespacedServiceProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectGetNodeProxyRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNodeProxy
     */
    name: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectGetNodeProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectGetNodeProxyWithPathRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectGetNodeProxyWithPath
     */
    name: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectGetNodeProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectGetNodeProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectHeadNamespacedPodProxyRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedPodProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedPodProxy
     */
    namespace: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedPodProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectHeadNamespacedPodProxyWithPathRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedPodProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedPodProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedPodProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedPodProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectHeadNamespacedServiceProxyRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedServiceProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedServiceProxy
     */
    namespace: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedServiceProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectHeadNamespacedServiceProxyWithPathRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedServiceProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedServiceProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedServiceProxyWithPath
     */
    path: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectHeadNamespacedServiceProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectHeadNodeProxyRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectHeadNodeProxy
     */
    name: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectHeadNodeProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectHeadNodeProxyWithPathRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectHeadNodeProxyWithPath
     */
    name: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectHeadNodeProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectHeadNodeProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectOptionsNamespacedPodProxyRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedPodProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedPodProxy
     */
    namespace: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedPodProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectOptionsNamespacedPodProxyWithPathRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedPodProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedPodProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedPodProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedPodProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectOptionsNamespacedServiceProxyRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedServiceProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedServiceProxy
     */
    namespace: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedServiceProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectOptionsNamespacedServiceProxyWithPathRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedServiceProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedServiceProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedServiceProxyWithPath
     */
    path: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectOptionsNamespacedServiceProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectOptionsNodeProxyRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectOptionsNodeProxy
     */
    name: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectOptionsNodeProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectOptionsNodeProxyWithPathRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectOptionsNodeProxyWithPath
     */
    name: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectOptionsNodeProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectOptionsNodeProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPatchNamespacedPodProxyRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedPodProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedPodProxy
     */
    namespace: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedPodProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPatchNamespacedPodProxyWithPathRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedPodProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedPodProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedPodProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedPodProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPatchNamespacedServiceProxyRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedServiceProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedServiceProxy
     */
    namespace: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedServiceProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPatchNamespacedServiceProxyWithPathRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedServiceProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedServiceProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedServiceProxyWithPath
     */
    path: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectPatchNamespacedServiceProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPatchNodeProxyRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPatchNodeProxy
     */
    name: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectPatchNodeProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPatchNodeProxyWithPathRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPatchNodeProxyWithPath
     */
    name: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPatchNodeProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectPatchNodeProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPostNamespacedPodAttachRequest {
    /**
     * name of the PodAttachOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodAttach
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodAttach
     */
    namespace: string;
    /**
     * The container in which to execute the command. Defaults to only container if there is only one container in the pod.
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodAttach
     */
    container?: string;
    /**
     * Stderr if true indicates that stderr is to be redirected for the attach call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodAttach
     */
    stderr?: boolean;
    /**
     * Stdin if true, redirects the standard input stream of the pod for this call. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodAttach
     */
    stdin?: boolean;
    /**
     * Stdout if true indicates that stdout is to be redirected for the attach call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodAttach
     */
    stdout?: boolean;
    /**
     * TTY if true indicates that a tty will be allocated for the attach call. This is passed through the container runtime so the tty is allocated on the worker node by the container runtime. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodAttach
     */
    tty?: boolean;
}
export interface CoreV1ApiConnectPostNamespacedPodExecRequest {
    /**
     * name of the PodExecOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    namespace: string;
    /**
     * Command is the remote command to execute. argv array. Not executed within a shell.
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    command?: string;
    /**
     * Container in which to execute the command. Defaults to only container if there is only one container in the pod.
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    container?: string;
    /**
     * Redirect the standard error stream of the pod for this call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    stderr?: boolean;
    /**
     * Redirect the standard input stream of the pod for this call. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    stdin?: boolean;
    /**
     * Redirect the standard output stream of the pod for this call. Defaults to true.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    stdout?: boolean;
    /**
     * TTY if true indicates that a tty will be allocated for the exec call. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApiconnectPostNamespacedPodExec
     */
    tty?: boolean;
}
export interface CoreV1ApiConnectPostNamespacedPodPortforwardRequest {
    /**
     * name of the PodPortForwardOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodPortforward
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodPortforward
     */
    namespace: string;
    /**
     * List of ports to forward Required when using WebSockets
     * @type number
     * @memberof CoreV1ApiconnectPostNamespacedPodPortforward
     */
    ports?: number;
}
export interface CoreV1ApiConnectPostNamespacedPodProxyRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodProxy
     */
    namespace: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPostNamespacedPodProxyWithPathRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedPodProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPostNamespacedServiceProxyRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedServiceProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedServiceProxy
     */
    namespace: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedServiceProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPostNamespacedServiceProxyWithPathRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedServiceProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedServiceProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedServiceProxyWithPath
     */
    path: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectPostNamespacedServiceProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPostNodeProxyRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNodeProxy
     */
    name: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectPostNodeProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPostNodeProxyWithPathRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPostNodeProxyWithPath
     */
    name: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPostNodeProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectPostNodeProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPutNamespacedPodProxyRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedPodProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedPodProxy
     */
    namespace: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedPodProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPutNamespacedPodProxyWithPathRequest {
    /**
     * name of the PodProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedPodProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedPodProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedPodProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to pod.
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedPodProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPutNamespacedServiceProxyRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedServiceProxy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedServiceProxy
     */
    namespace: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedServiceProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPutNamespacedServiceProxyWithPathRequest {
    /**
     * name of the ServiceProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedServiceProxyWithPath
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedServiceProxyWithPath
     */
    namespace: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedServiceProxyWithPath
     */
    path: string;
    /**
     * Path is the part of URLs that include service endpoints, suffixes, and parameters to use for the current proxy request to service. For example, the whole request URL is http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q&#x3D;user:kimchy. Path is _search?q&#x3D;user:kimchy.
     * @type string
     * @memberof CoreV1ApiconnectPutNamespacedServiceProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiConnectPutNodeProxyRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPutNodeProxy
     */
    name: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectPutNodeProxy
     */
    path?: string;
}
export interface CoreV1ApiConnectPutNodeProxyWithPathRequest {
    /**
     * name of the NodeProxyOptions
     * @type string
     * @memberof CoreV1ApiconnectPutNodeProxyWithPath
     */
    name: string;
    /**
     * path to the resource
     * @type string
     * @memberof CoreV1ApiconnectPutNodeProxyWithPath
     */
    path: string;
    /**
     * Path is the URL path to use for the current proxy request to node.
     * @type string
     * @memberof CoreV1ApiconnectPutNodeProxyWithPath
     */
    path2?: string;
}
export interface CoreV1ApiCreateNamespaceRequest {
    /**
     *
     * @type V1Namespace
     * @memberof CoreV1ApicreateNamespace
     */
    body: V1Namespace;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespace
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespace
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespace
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedBindingRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedBinding
     */
    namespace: string;
    /**
     *
     * @type V1Binding
     * @memberof CoreV1ApicreateNamespacedBinding
     */
    body: V1Binding;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedBinding
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedBinding
     */
    pretty?: string;
}
export interface CoreV1ApiCreateNamespacedConfigMapRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedConfigMap
     */
    namespace: string;
    /**
     *
     * @type V1ConfigMap
     * @memberof CoreV1ApicreateNamespacedConfigMap
     */
    body: V1ConfigMap;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedConfigMap
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedConfigMap
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedConfigMap
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedEndpointsRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedEndpoints
     */
    namespace: string;
    /**
     *
     * @type V1Endpoints
     * @memberof CoreV1ApicreateNamespacedEndpoints
     */
    body: V1Endpoints;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedEndpoints
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedEndpoints
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedEndpoints
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type CoreV1Event
     * @memberof CoreV1ApicreateNamespacedEvent
     */
    body: CoreV1Event;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedEvent
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedLimitRangeRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedLimitRange
     */
    namespace: string;
    /**
     *
     * @type V1LimitRange
     * @memberof CoreV1ApicreateNamespacedLimitRange
     */
    body: V1LimitRange;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedLimitRange
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedLimitRange
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedLimitRange
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedPersistentVolumeClaimRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedPersistentVolumeClaim
     */
    namespace: string;
    /**
     *
     * @type V1PersistentVolumeClaim
     * @memberof CoreV1ApicreateNamespacedPersistentVolumeClaim
     */
    body: V1PersistentVolumeClaim;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPersistentVolumeClaim
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedPersistentVolumeClaim
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPersistentVolumeClaim
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedPodRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedPod
     */
    namespace: string;
    /**
     *
     * @type V1Pod
     * @memberof CoreV1ApicreateNamespacedPod
     */
    body: V1Pod;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPod
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedPod
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPod
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedPodBindingRequest {
    /**
     * name of the Binding
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodBinding
     */
    namespace: string;
    /**
     *
     * @type V1Binding
     * @memberof CoreV1ApicreateNamespacedPodBinding
     */
    body: V1Binding;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodBinding
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodBinding
     */
    pretty?: string;
}
export interface CoreV1ApiCreateNamespacedPodEvictionRequest {
    /**
     * name of the Eviction
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodEviction
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodEviction
     */
    namespace: string;
    /**
     *
     * @type V1Eviction
     * @memberof CoreV1ApicreateNamespacedPodEviction
     */
    body: V1Eviction;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodEviction
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodEviction
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodEviction
     */
    pretty?: string;
}
export interface CoreV1ApiCreateNamespacedPodTemplateRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodTemplate
     */
    namespace: string;
    /**
     *
     * @type V1PodTemplate
     * @memberof CoreV1ApicreateNamespacedPodTemplate
     */
    body: V1PodTemplate;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodTemplate
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodTemplate
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedPodTemplate
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedReplicationControllerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedReplicationController
     */
    namespace: string;
    /**
     *
     * @type V1ReplicationController
     * @memberof CoreV1ApicreateNamespacedReplicationController
     */
    body: V1ReplicationController;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedReplicationController
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedReplicationController
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedReplicationController
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedResourceQuotaRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedResourceQuota
     */
    namespace: string;
    /**
     *
     * @type V1ResourceQuota
     * @memberof CoreV1ApicreateNamespacedResourceQuota
     */
    body: V1ResourceQuota;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedResourceQuota
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedResourceQuota
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedResourceQuota
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedSecretRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedSecret
     */
    namespace: string;
    /**
     *
     * @type V1Secret
     * @memberof CoreV1ApicreateNamespacedSecret
     */
    body: V1Secret;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedSecret
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedSecret
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedSecret
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedServiceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedService
     */
    namespace: string;
    /**
     *
     * @type V1Service
     * @memberof CoreV1ApicreateNamespacedService
     */
    body: V1Service;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedService
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedService
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedServiceAccountRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccount
     */
    namespace: string;
    /**
     *
     * @type V1ServiceAccount
     * @memberof CoreV1ApicreateNamespacedServiceAccount
     */
    body: V1ServiceAccount;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccount
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccount
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccount
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreateNamespacedServiceAccountTokenRequest {
    /**
     * name of the TokenRequest
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccountToken
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccountToken
     */
    namespace: string;
    /**
     *
     * @type AuthenticationV1TokenRequest
     * @memberof CoreV1ApicreateNamespacedServiceAccountToken
     */
    body: AuthenticationV1TokenRequest;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccountToken
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccountToken
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNamespacedServiceAccountToken
     */
    pretty?: string;
}
export interface CoreV1ApiCreateNodeRequest {
    /**
     *
     * @type V1Node
     * @memberof CoreV1ApicreateNode
     */
    body: V1Node;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreateNode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreateNode
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreateNode
     */
    fieldManager?: string;
}
export interface CoreV1ApiCreatePersistentVolumeRequest {
    /**
     *
     * @type V1PersistentVolume
     * @memberof CoreV1ApicreatePersistentVolume
     */
    body: V1PersistentVolume;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApicreatePersistentVolume
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApicreatePersistentVolume
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApicreatePersistentVolume
     */
    fieldManager?: string;
}
export interface CoreV1ApiDeleteCollectionNamespacedConfigMapRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedConfigMap
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedEndpointsRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedEndpoints
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedEvent
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedLimitRangeRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedLimitRange
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedPersistentVolumeClaimRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedPersistentVolumeClaim
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedPodRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedPod
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedPodTemplateRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedPodTemplate
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedReplicationControllerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedReplicationController
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedResourceQuotaRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedResourceQuota
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedSecretRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedSecret
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNamespacedServiceAccountRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNamespacedServiceAccount
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionNodeRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionNode
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionNode
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionNode
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionNode
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionNode
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionNode
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteCollectionPersistentVolumeRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteCollectionPersistentVolume
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespaceRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApideleteNamespace
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespace
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespace
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespace
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespace
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespace
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespace
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedConfigMapRequest {
    /**
     * name of the ConfigMap
     * @type string
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedConfigMap
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedEndpointsRequest {
    /**
     * name of the Endpoints
     * @type string
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedEndpoints
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedEvent
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedLimitRangeRequest {
    /**
     * name of the LimitRange
     * @type string
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedLimitRange
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedPersistentVolumeClaimRequest {
    /**
     * name of the PersistentVolumeClaim
     * @type string
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedPersistentVolumeClaim
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedPodRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApideleteNamespacedPod
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedPod
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedPod
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedPod
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedPod
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedPod
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedPod
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedPod
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedPodTemplateRequest {
    /**
     * name of the PodTemplate
     * @type string
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedPodTemplate
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedReplicationControllerRequest {
    /**
     * name of the ReplicationController
     * @type string
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedReplicationController
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedResourceQuotaRequest {
    /**
     * name of the ResourceQuota
     * @type string
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedResourceQuota
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedSecretRequest {
    /**
     * name of the Secret
     * @type string
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedSecret
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedServiceRequest {
    /**
     * name of the Service
     * @type string
     * @memberof CoreV1ApideleteNamespacedService
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedService
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedService
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedService
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedService
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedService
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedService
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNamespacedServiceAccountRequest {
    /**
     * name of the ServiceAccount
     * @type string
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNamespacedServiceAccount
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeleteNodeRequest {
    /**
     * name of the Node
     * @type string
     * @memberof CoreV1ApideleteNode
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideleteNode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideleteNode
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideleteNode
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideleteNode
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideleteNode
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideleteNode
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiDeletePersistentVolumeRequest {
    /**
     * name of the PersistentVolume
     * @type string
     * @memberof CoreV1ApideletePersistentVolume
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApideletePersistentVolume
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApideletePersistentVolume
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CoreV1ApideletePersistentVolume
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CoreV1ApideletePersistentVolume
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof CoreV1ApideletePersistentVolume
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CoreV1ApideletePersistentVolume
     */
    body?: V1DeleteOptions;
}
export interface CoreV1ApiGetAPIResourcesRequest {
}
export interface CoreV1ApiListComponentStatusRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistComponentStatus
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistComponentStatus
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistComponentStatus
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistComponentStatus
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistComponentStatus
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistComponentStatus
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistComponentStatus
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistComponentStatus
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistComponentStatus
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistComponentStatus
     */
    watch?: boolean;
}
export interface CoreV1ApiListConfigMapForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistConfigMapForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListEndpointsForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistEndpointsForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListEventForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistEventForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListLimitRangeForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistLimitRangeForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespaceRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespace
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespace
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespace
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespace
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespace
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespace
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespace
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespace
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespace
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespace
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedConfigMapRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedConfigMap
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedEndpointsRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedEndpoints
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedEvent
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedEvent
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedEvent
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedEvent
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedEvent
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedEvent
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedEvent
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedEvent
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedEvent
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedEvent
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedLimitRangeRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedLimitRange
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedPersistentVolumeClaimRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedPersistentVolumeClaim
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedPodRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedPod
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedPod
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedPod
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedPod
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedPod
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedPod
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedPod
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedPod
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedPod
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedPod
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedPod
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedPodTemplateRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedPodTemplate
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedReplicationControllerRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedReplicationController
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedResourceQuotaRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedResourceQuota
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedSecretRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedSecret
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedSecret
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedSecret
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedSecret
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedSecret
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedSecret
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedSecret
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedSecret
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedSecret
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedSecret
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedSecret
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedServiceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedService
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedService
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedService
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedService
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedService
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedService
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedService
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedService
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedService
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedService
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedService
     */
    watch?: boolean;
}
export interface CoreV1ApiListNamespacedServiceAccountRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNamespacedServiceAccount
     */
    watch?: boolean;
}
export interface CoreV1ApiListNodeRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistNode
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistNode
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistNode
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNode
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistNode
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistNode
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNode
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistNode
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistNode
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistNode
     */
    watch?: boolean;
}
export interface CoreV1ApiListPersistentVolumeRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistPersistentVolume
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistPersistentVolume
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistPersistentVolume
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPersistentVolume
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPersistentVolume
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistPersistentVolume
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPersistentVolume
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPersistentVolume
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistPersistentVolume
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistPersistentVolume
     */
    watch?: boolean;
}
export interface CoreV1ApiListPersistentVolumeClaimForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistPersistentVolumeClaimForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListPodForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistPodForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListPodTemplateForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistPodTemplateForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListReplicationControllerForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistReplicationControllerForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListResourceQuotaForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistResourceQuotaForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListSecretForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistSecretForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListServiceAccountForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistServiceAccountForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiListServiceForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof CoreV1ApilistServiceForAllNamespaces
     */
    watch?: boolean;
}
export interface CoreV1ApiPatchNamespaceRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApipatchNamespace
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespace
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespace
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespace
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespace
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespace
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespaceStatusRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApipatchNamespaceStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespaceStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespaceStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespaceStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespaceStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespaceStatus
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedConfigMapRequest {
    /**
     * name of the ConfigMap
     * @type string
     * @memberof CoreV1ApipatchNamespacedConfigMap
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedConfigMap
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedConfigMap
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedConfigMap
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedConfigMap
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedConfigMap
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedConfigMap
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedEndpointsRequest {
    /**
     * name of the Endpoints
     * @type string
     * @memberof CoreV1ApipatchNamespacedEndpoints
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedEndpoints
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedEndpoints
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedEndpoints
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedEndpoints
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedEndpoints
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedEndpoints
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof CoreV1ApipatchNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedEvent
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedEvent
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedEvent
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedLimitRangeRequest {
    /**
     * name of the LimitRange
     * @type string
     * @memberof CoreV1ApipatchNamespacedLimitRange
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedLimitRange
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedLimitRange
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedLimitRange
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedLimitRange
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedLimitRange
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedLimitRange
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedPersistentVolumeClaimRequest {
    /**
     * name of the PersistentVolumeClaim
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaim
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaim
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaim
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaim
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaim
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaim
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaim
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedPersistentVolumeClaimStatusRequest {
    /**
     * name of the PersistentVolumeClaim
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaimStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaimStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaimStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaimStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaimStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaimStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedPersistentVolumeClaimStatus
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedPodRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApipatchNamespacedPod
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedPod
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedPod
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedPod
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedPod
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedPod
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedPod
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedPodEphemeralcontainersRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodEphemeralcontainers
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodEphemeralcontainers
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedPodEphemeralcontainers
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodEphemeralcontainers
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodEphemeralcontainers
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodEphemeralcontainers
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedPodEphemeralcontainers
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedPodStatusRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedPodStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedPodStatus
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedPodTemplateRequest {
    /**
     * name of the PodTemplate
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodTemplate
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodTemplate
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedPodTemplate
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodTemplate
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodTemplate
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedPodTemplate
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedPodTemplate
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedReplicationControllerRequest {
    /**
     * name of the ReplicationController
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationController
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationController
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedReplicationController
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationController
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationController
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationController
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedReplicationController
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedReplicationControllerScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerScale
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedReplicationControllerScale
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerScale
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedReplicationControllerScale
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedReplicationControllerStatusRequest {
    /**
     * name of the ReplicationController
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedReplicationControllerStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedReplicationControllerStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedReplicationControllerStatus
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedResourceQuotaRequest {
    /**
     * name of the ResourceQuota
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuota
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuota
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedResourceQuota
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuota
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuota
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuota
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedResourceQuota
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedResourceQuotaStatusRequest {
    /**
     * name of the ResourceQuota
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuotaStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuotaStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedResourceQuotaStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuotaStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuotaStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedResourceQuotaStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedResourceQuotaStatus
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedSecretRequest {
    /**
     * name of the Secret
     * @type string
     * @memberof CoreV1ApipatchNamespacedSecret
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedSecret
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedSecret
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedSecret
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedSecret
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedSecret
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedSecret
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedServiceRequest {
    /**
     * name of the Service
     * @type string
     * @memberof CoreV1ApipatchNamespacedService
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedService
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedService
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedService
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedService
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedService
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedServiceAccountRequest {
    /**
     * name of the ServiceAccount
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceAccount
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceAccount
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedServiceAccount
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceAccount
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceAccount
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceAccount
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedServiceAccount
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNamespacedServiceStatusRequest {
    /**
     * name of the Service
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNamespacedServiceStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNamespacedServiceStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNamespacedServiceStatus
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNodeRequest {
    /**
     * name of the Node
     * @type string
     * @memberof CoreV1ApipatchNode
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNode
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNode
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNode
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNode
     */
    force?: boolean;
}
export interface CoreV1ApiPatchNodeStatusRequest {
    /**
     * name of the Node
     * @type string
     * @memberof CoreV1ApipatchNodeStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchNodeStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchNodeStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchNodeStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchNodeStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchNodeStatus
     */
    force?: boolean;
}
export interface CoreV1ApiPatchPersistentVolumeRequest {
    /**
     * name of the PersistentVolume
     * @type string
     * @memberof CoreV1ApipatchPersistentVolume
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchPersistentVolume
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchPersistentVolume
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchPersistentVolume
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchPersistentVolume
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchPersistentVolume
     */
    force?: boolean;
}
export interface CoreV1ApiPatchPersistentVolumeStatusRequest {
    /**
     * name of the PersistentVolume
     * @type string
     * @memberof CoreV1ApipatchPersistentVolumeStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CoreV1ApipatchPersistentVolumeStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApipatchPersistentVolumeStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApipatchPersistentVolumeStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CoreV1ApipatchPersistentVolumeStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CoreV1ApipatchPersistentVolumeStatus
     */
    force?: boolean;
}
export interface CoreV1ApiReadComponentStatusRequest {
    /**
     * name of the ComponentStatus
     * @type string
     * @memberof CoreV1ApireadComponentStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadComponentStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespaceRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApireadNamespace
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespace
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespaceStatusRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApireadNamespaceStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespaceStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedConfigMapRequest {
    /**
     * name of the ConfigMap
     * @type string
     * @memberof CoreV1ApireadNamespacedConfigMap
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedConfigMap
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedConfigMap
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedEndpointsRequest {
    /**
     * name of the Endpoints
     * @type string
     * @memberof CoreV1ApireadNamespacedEndpoints
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedEndpoints
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedEndpoints
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof CoreV1ApireadNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedEvent
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedLimitRangeRequest {
    /**
     * name of the LimitRange
     * @type string
     * @memberof CoreV1ApireadNamespacedLimitRange
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedLimitRange
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedLimitRange
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedPersistentVolumeClaimRequest {
    /**
     * name of the PersistentVolumeClaim
     * @type string
     * @memberof CoreV1ApireadNamespacedPersistentVolumeClaim
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedPersistentVolumeClaim
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedPersistentVolumeClaim
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedPersistentVolumeClaimStatusRequest {
    /**
     * name of the PersistentVolumeClaim
     * @type string
     * @memberof CoreV1ApireadNamespacedPersistentVolumeClaimStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedPersistentVolumeClaimStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedPersistentVolumeClaimStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedPodRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApireadNamespacedPod
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedPod
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedPod
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedPodEphemeralcontainersRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApireadNamespacedPodEphemeralcontainers
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedPodEphemeralcontainers
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedPodEphemeralcontainers
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedPodLogRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    namespace: string;
    /**
     * The container for which to stream logs. Defaults to only container if there is one container in the pod.
     * @type string
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    container?: string;
    /**
     * Follow the log stream of the pod. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    follow?: boolean;
    /**
     * insecureSkipTLSVerifyBackend indicates that the apiserver should not confirm the validity of the serving certificate of the backend it is connecting to.  This will make the HTTPS connection between the apiserver and the backend insecure. This means the apiserver cannot verify the log data it is receiving came from the real kubelet.  If the kubelet is configured to verify the apiserver\&#39;s TLS credentials, it does not mean the connection to the real kubelet is vulnerable to a man in the middle attack (e.g. an attacker could not intercept the actual log data coming from the real kubelet).
     * @type boolean
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    insecureSkipTLSVerifyBackend?: boolean;
    /**
     * If set, the number of bytes to read from the server before terminating the log output. This may not display a complete final line of logging, and may return slightly more or slightly less than the specified limit.
     * @type number
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    limitBytes?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    pretty?: string;
    /**
     * Return previous terminated container logs. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    previous?: boolean;
    /**
     * A relative time in seconds before the current time from which to show logs. If this value precedes the time a pod was started, only logs since the pod start will be returned. If this value is in the future, no logs will be returned. Only one of sinceSeconds or sinceTime may be specified.
     * @type number
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    sinceSeconds?: number;
    /**
     * If set, the number of lines from the end of the logs to show. If not specified, logs are shown from the creation of the container or sinceSeconds or sinceTime
     * @type number
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    tailLines?: number;
    /**
     * If true, add an RFC3339 or RFC3339Nano timestamp at the beginning of every line of log output. Defaults to false.
     * @type boolean
     * @memberof CoreV1ApireadNamespacedPodLog
     */
    timestamps?: boolean;
}
export interface CoreV1ApiReadNamespacedPodStatusRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApireadNamespacedPodStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedPodStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedPodStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedPodTemplateRequest {
    /**
     * name of the PodTemplate
     * @type string
     * @memberof CoreV1ApireadNamespacedPodTemplate
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedPodTemplate
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedPodTemplate
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedReplicationControllerRequest {
    /**
     * name of the ReplicationController
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationController
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationController
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationController
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedReplicationControllerScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationControllerScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationControllerScale
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationControllerScale
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedReplicationControllerStatusRequest {
    /**
     * name of the ReplicationController
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationControllerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationControllerStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedReplicationControllerStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedResourceQuotaRequest {
    /**
     * name of the ResourceQuota
     * @type string
     * @memberof CoreV1ApireadNamespacedResourceQuota
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedResourceQuota
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedResourceQuota
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedResourceQuotaStatusRequest {
    /**
     * name of the ResourceQuota
     * @type string
     * @memberof CoreV1ApireadNamespacedResourceQuotaStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedResourceQuotaStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedResourceQuotaStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedSecretRequest {
    /**
     * name of the Secret
     * @type string
     * @memberof CoreV1ApireadNamespacedSecret
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedSecret
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedSecret
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedServiceRequest {
    /**
     * name of the Service
     * @type string
     * @memberof CoreV1ApireadNamespacedService
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedService
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedService
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedServiceAccountRequest {
    /**
     * name of the ServiceAccount
     * @type string
     * @memberof CoreV1ApireadNamespacedServiceAccount
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedServiceAccount
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedServiceAccount
     */
    pretty?: string;
}
export interface CoreV1ApiReadNamespacedServiceStatusRequest {
    /**
     * name of the Service
     * @type string
     * @memberof CoreV1ApireadNamespacedServiceStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireadNamespacedServiceStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNamespacedServiceStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadNodeRequest {
    /**
     * name of the Node
     * @type string
     * @memberof CoreV1ApireadNode
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNode
     */
    pretty?: string;
}
export interface CoreV1ApiReadNodeStatusRequest {
    /**
     * name of the Node
     * @type string
     * @memberof CoreV1ApireadNodeStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadNodeStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReadPersistentVolumeRequest {
    /**
     * name of the PersistentVolume
     * @type string
     * @memberof CoreV1ApireadPersistentVolume
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadPersistentVolume
     */
    pretty?: string;
}
export interface CoreV1ApiReadPersistentVolumeStatusRequest {
    /**
     * name of the PersistentVolume
     * @type string
     * @memberof CoreV1ApireadPersistentVolumeStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireadPersistentVolumeStatus
     */
    pretty?: string;
}
export interface CoreV1ApiReplaceNamespaceRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApireplaceNamespace
     */
    name: string;
    /**
     *
     * @type V1Namespace
     * @memberof CoreV1ApireplaceNamespace
     */
    body: V1Namespace;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespace
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespace
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespace
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespaceFinalizeRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApireplaceNamespaceFinalize
     */
    name: string;
    /**
     *
     * @type V1Namespace
     * @memberof CoreV1ApireplaceNamespaceFinalize
     */
    body: V1Namespace;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespaceFinalize
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespaceFinalize
     */
    fieldManager?: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespaceFinalize
     */
    pretty?: string;
}
export interface CoreV1ApiReplaceNamespaceStatusRequest {
    /**
     * name of the Namespace
     * @type string
     * @memberof CoreV1ApireplaceNamespaceStatus
     */
    name: string;
    /**
     *
     * @type V1Namespace
     * @memberof CoreV1ApireplaceNamespaceStatus
     */
    body: V1Namespace;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespaceStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespaceStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespaceStatus
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedConfigMapRequest {
    /**
     * name of the ConfigMap
     * @type string
     * @memberof CoreV1ApireplaceNamespacedConfigMap
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedConfigMap
     */
    namespace: string;
    /**
     *
     * @type V1ConfigMap
     * @memberof CoreV1ApireplaceNamespacedConfigMap
     */
    body: V1ConfigMap;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedConfigMap
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedConfigMap
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedConfigMap
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedEndpointsRequest {
    /**
     * name of the Endpoints
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEndpoints
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEndpoints
     */
    namespace: string;
    /**
     *
     * @type V1Endpoints
     * @memberof CoreV1ApireplaceNamespacedEndpoints
     */
    body: V1Endpoints;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEndpoints
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEndpoints
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEndpoints
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type CoreV1Event
     * @memberof CoreV1ApireplaceNamespacedEvent
     */
    body: CoreV1Event;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedEvent
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedLimitRangeRequest {
    /**
     * name of the LimitRange
     * @type string
     * @memberof CoreV1ApireplaceNamespacedLimitRange
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedLimitRange
     */
    namespace: string;
    /**
     *
     * @type V1LimitRange
     * @memberof CoreV1ApireplaceNamespacedLimitRange
     */
    body: V1LimitRange;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedLimitRange
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedLimitRange
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedLimitRange
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedPersistentVolumeClaimRequest {
    /**
     * name of the PersistentVolumeClaim
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaim
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaim
     */
    namespace: string;
    /**
     *
     * @type V1PersistentVolumeClaim
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaim
     */
    body: V1PersistentVolumeClaim;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaim
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaim
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaim
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedPersistentVolumeClaimStatusRequest {
    /**
     * name of the PersistentVolumeClaim
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaimStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaimStatus
     */
    namespace: string;
    /**
     *
     * @type V1PersistentVolumeClaim
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaimStatus
     */
    body: V1PersistentVolumeClaim;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaimStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaimStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPersistentVolumeClaimStatus
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedPodRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPod
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPod
     */
    namespace: string;
    /**
     *
     * @type V1Pod
     * @memberof CoreV1ApireplaceNamespacedPod
     */
    body: V1Pod;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPod
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPod
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPod
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedPodEphemeralcontainersRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodEphemeralcontainers
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodEphemeralcontainers
     */
    namespace: string;
    /**
     *
     * @type V1Pod
     * @memberof CoreV1ApireplaceNamespacedPodEphemeralcontainers
     */
    body: V1Pod;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodEphemeralcontainers
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodEphemeralcontainers
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodEphemeralcontainers
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedPodStatusRequest {
    /**
     * name of the Pod
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodStatus
     */
    namespace: string;
    /**
     *
     * @type V1Pod
     * @memberof CoreV1ApireplaceNamespacedPodStatus
     */
    body: V1Pod;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodStatus
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedPodTemplateRequest {
    /**
     * name of the PodTemplate
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodTemplate
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodTemplate
     */
    namespace: string;
    /**
     *
     * @type V1PodTemplate
     * @memberof CoreV1ApireplaceNamespacedPodTemplate
     */
    body: V1PodTemplate;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodTemplate
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodTemplate
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedPodTemplate
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedReplicationControllerRequest {
    /**
     * name of the ReplicationController
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationController
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationController
     */
    namespace: string;
    /**
     *
     * @type V1ReplicationController
     * @memberof CoreV1ApireplaceNamespacedReplicationController
     */
    body: V1ReplicationController;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationController
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationController
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationController
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedReplicationControllerScaleRequest {
    /**
     * name of the Scale
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerScale
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerScale
     */
    namespace: string;
    /**
     *
     * @type V1Scale
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerScale
     */
    body: V1Scale;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerScale
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerScale
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedReplicationControllerStatusRequest {
    /**
     * name of the ReplicationController
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerStatus
     */
    namespace: string;
    /**
     *
     * @type V1ReplicationController
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerStatus
     */
    body: V1ReplicationController;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedReplicationControllerStatus
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedResourceQuotaRequest {
    /**
     * name of the ResourceQuota
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuota
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuota
     */
    namespace: string;
    /**
     *
     * @type V1ResourceQuota
     * @memberof CoreV1ApireplaceNamespacedResourceQuota
     */
    body: V1ResourceQuota;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuota
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuota
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuota
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedResourceQuotaStatusRequest {
    /**
     * name of the ResourceQuota
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuotaStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuotaStatus
     */
    namespace: string;
    /**
     *
     * @type V1ResourceQuota
     * @memberof CoreV1ApireplaceNamespacedResourceQuotaStatus
     */
    body: V1ResourceQuota;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuotaStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuotaStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedResourceQuotaStatus
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedSecretRequest {
    /**
     * name of the Secret
     * @type string
     * @memberof CoreV1ApireplaceNamespacedSecret
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedSecret
     */
    namespace: string;
    /**
     *
     * @type V1Secret
     * @memberof CoreV1ApireplaceNamespacedSecret
     */
    body: V1Secret;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedSecret
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedSecret
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedSecret
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedServiceRequest {
    /**
     * name of the Service
     * @type string
     * @memberof CoreV1ApireplaceNamespacedService
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedService
     */
    namespace: string;
    /**
     *
     * @type V1Service
     * @memberof CoreV1ApireplaceNamespacedService
     */
    body: V1Service;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedService
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedService
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedService
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedServiceAccountRequest {
    /**
     * name of the ServiceAccount
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceAccount
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceAccount
     */
    namespace: string;
    /**
     *
     * @type V1ServiceAccount
     * @memberof CoreV1ApireplaceNamespacedServiceAccount
     */
    body: V1ServiceAccount;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceAccount
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceAccount
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceAccount
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNamespacedServiceStatusRequest {
    /**
     * name of the Service
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceStatus
     */
    namespace: string;
    /**
     *
     * @type V1Service
     * @memberof CoreV1ApireplaceNamespacedServiceStatus
     */
    body: V1Service;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNamespacedServiceStatus
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNodeRequest {
    /**
     * name of the Node
     * @type string
     * @memberof CoreV1ApireplaceNode
     */
    name: string;
    /**
     *
     * @type V1Node
     * @memberof CoreV1ApireplaceNode
     */
    body: V1Node;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNode
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNode
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplaceNodeStatusRequest {
    /**
     * name of the Node
     * @type string
     * @memberof CoreV1ApireplaceNodeStatus
     */
    name: string;
    /**
     *
     * @type V1Node
     * @memberof CoreV1ApireplaceNodeStatus
     */
    body: V1Node;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplaceNodeStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplaceNodeStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplaceNodeStatus
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplacePersistentVolumeRequest {
    /**
     * name of the PersistentVolume
     * @type string
     * @memberof CoreV1ApireplacePersistentVolume
     */
    name: string;
    /**
     *
     * @type V1PersistentVolume
     * @memberof CoreV1ApireplacePersistentVolume
     */
    body: V1PersistentVolume;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplacePersistentVolume
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplacePersistentVolume
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplacePersistentVolume
     */
    fieldManager?: string;
}
export interface CoreV1ApiReplacePersistentVolumeStatusRequest {
    /**
     * name of the PersistentVolume
     * @type string
     * @memberof CoreV1ApireplacePersistentVolumeStatus
     */
    name: string;
    /**
     *
     * @type V1PersistentVolume
     * @memberof CoreV1ApireplacePersistentVolumeStatus
     */
    body: V1PersistentVolume;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CoreV1ApireplacePersistentVolumeStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CoreV1ApireplacePersistentVolumeStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CoreV1ApireplacePersistentVolumeStatus
     */
    fieldManager?: string;
}
export declare class ObjectCoreV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: CoreV1ApiRequestFactory, responseProcessor?: CoreV1ApiResponseProcessor);
    /**
     * connect DELETE requests to proxy of Pod
     * @param param the request object
     */
    connectDeleteNamespacedPodProxy(param: CoreV1ApiConnectDeleteNamespacedPodProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect DELETE requests to proxy of Pod
     * @param param the request object
     */
    connectDeleteNamespacedPodProxyWithPath(param: CoreV1ApiConnectDeleteNamespacedPodProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect DELETE requests to proxy of Service
     * @param param the request object
     */
    connectDeleteNamespacedServiceProxy(param: CoreV1ApiConnectDeleteNamespacedServiceProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect DELETE requests to proxy of Service
     * @param param the request object
     */
    connectDeleteNamespacedServiceProxyWithPath(param: CoreV1ApiConnectDeleteNamespacedServiceProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect DELETE requests to proxy of Node
     * @param param the request object
     */
    connectDeleteNodeProxy(param: CoreV1ApiConnectDeleteNodeProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect DELETE requests to proxy of Node
     * @param param the request object
     */
    connectDeleteNodeProxyWithPath(param: CoreV1ApiConnectDeleteNodeProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to attach of Pod
     * @param param the request object
     */
    connectGetNamespacedPodAttach(param: CoreV1ApiConnectGetNamespacedPodAttachRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to exec of Pod
     * @param param the request object
     */
    connectGetNamespacedPodExec(param: CoreV1ApiConnectGetNamespacedPodExecRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to portforward of Pod
     * @param param the request object
     */
    connectGetNamespacedPodPortforward(param: CoreV1ApiConnectGetNamespacedPodPortforwardRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to proxy of Pod
     * @param param the request object
     */
    connectGetNamespacedPodProxy(param: CoreV1ApiConnectGetNamespacedPodProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to proxy of Pod
     * @param param the request object
     */
    connectGetNamespacedPodProxyWithPath(param: CoreV1ApiConnectGetNamespacedPodProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to proxy of Service
     * @param param the request object
     */
    connectGetNamespacedServiceProxy(param: CoreV1ApiConnectGetNamespacedServiceProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to proxy of Service
     * @param param the request object
     */
    connectGetNamespacedServiceProxyWithPath(param: CoreV1ApiConnectGetNamespacedServiceProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to proxy of Node
     * @param param the request object
     */
    connectGetNodeProxy(param: CoreV1ApiConnectGetNodeProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect GET requests to proxy of Node
     * @param param the request object
     */
    connectGetNodeProxyWithPath(param: CoreV1ApiConnectGetNodeProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect HEAD requests to proxy of Pod
     * @param param the request object
     */
    connectHeadNamespacedPodProxy(param: CoreV1ApiConnectHeadNamespacedPodProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect HEAD requests to proxy of Pod
     * @param param the request object
     */
    connectHeadNamespacedPodProxyWithPath(param: CoreV1ApiConnectHeadNamespacedPodProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect HEAD requests to proxy of Service
     * @param param the request object
     */
    connectHeadNamespacedServiceProxy(param: CoreV1ApiConnectHeadNamespacedServiceProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect HEAD requests to proxy of Service
     * @param param the request object
     */
    connectHeadNamespacedServiceProxyWithPath(param: CoreV1ApiConnectHeadNamespacedServiceProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect HEAD requests to proxy of Node
     * @param param the request object
     */
    connectHeadNodeProxy(param: CoreV1ApiConnectHeadNodeProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect HEAD requests to proxy of Node
     * @param param the request object
     */
    connectHeadNodeProxyWithPath(param: CoreV1ApiConnectHeadNodeProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect OPTIONS requests to proxy of Pod
     * @param param the request object
     */
    connectOptionsNamespacedPodProxy(param: CoreV1ApiConnectOptionsNamespacedPodProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect OPTIONS requests to proxy of Pod
     * @param param the request object
     */
    connectOptionsNamespacedPodProxyWithPath(param: CoreV1ApiConnectOptionsNamespacedPodProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect OPTIONS requests to proxy of Service
     * @param param the request object
     */
    connectOptionsNamespacedServiceProxy(param: CoreV1ApiConnectOptionsNamespacedServiceProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect OPTIONS requests to proxy of Service
     * @param param the request object
     */
    connectOptionsNamespacedServiceProxyWithPath(param: CoreV1ApiConnectOptionsNamespacedServiceProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect OPTIONS requests to proxy of Node
     * @param param the request object
     */
    connectOptionsNodeProxy(param: CoreV1ApiConnectOptionsNodeProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect OPTIONS requests to proxy of Node
     * @param param the request object
     */
    connectOptionsNodeProxyWithPath(param: CoreV1ApiConnectOptionsNodeProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect PATCH requests to proxy of Pod
     * @param param the request object
     */
    connectPatchNamespacedPodProxy(param: CoreV1ApiConnectPatchNamespacedPodProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect PATCH requests to proxy of Pod
     * @param param the request object
     */
    connectPatchNamespacedPodProxyWithPath(param: CoreV1ApiConnectPatchNamespacedPodProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect PATCH requests to proxy of Service
     * @param param the request object
     */
    connectPatchNamespacedServiceProxy(param: CoreV1ApiConnectPatchNamespacedServiceProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect PATCH requests to proxy of Service
     * @param param the request object
     */
    connectPatchNamespacedServiceProxyWithPath(param: CoreV1ApiConnectPatchNamespacedServiceProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect PATCH requests to proxy of Node
     * @param param the request object
     */
    connectPatchNodeProxy(param: CoreV1ApiConnectPatchNodeProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect PATCH requests to proxy of Node
     * @param param the request object
     */
    connectPatchNodeProxyWithPath(param: CoreV1ApiConnectPatchNodeProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to attach of Pod
     * @param param the request object
     */
    connectPostNamespacedPodAttach(param: CoreV1ApiConnectPostNamespacedPodAttachRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to exec of Pod
     * @param param the request object
     */
    connectPostNamespacedPodExec(param: CoreV1ApiConnectPostNamespacedPodExecRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to portforward of Pod
     * @param param the request object
     */
    connectPostNamespacedPodPortforward(param: CoreV1ApiConnectPostNamespacedPodPortforwardRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to proxy of Pod
     * @param param the request object
     */
    connectPostNamespacedPodProxy(param: CoreV1ApiConnectPostNamespacedPodProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to proxy of Pod
     * @param param the request object
     */
    connectPostNamespacedPodProxyWithPath(param: CoreV1ApiConnectPostNamespacedPodProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to proxy of Service
     * @param param the request object
     */
    connectPostNamespacedServiceProxy(param: CoreV1ApiConnectPostNamespacedServiceProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to proxy of Service
     * @param param the request object
     */
    connectPostNamespacedServiceProxyWithPath(param: CoreV1ApiConnectPostNamespacedServiceProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to proxy of Node
     * @param param the request object
     */
    connectPostNodeProxy(param: CoreV1ApiConnectPostNodeProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect POST requests to proxy of Node
     * @param param the request object
     */
    connectPostNodeProxyWithPath(param: CoreV1ApiConnectPostNodeProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect PUT requests to proxy of Pod
     * @param param the request object
     */
    connectPutNamespacedPodProxy(param: CoreV1ApiConnectPutNamespacedPodProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect PUT requests to proxy of Pod
     * @param param the request object
     */
    connectPutNamespacedPodProxyWithPath(param: CoreV1ApiConnectPutNamespacedPodProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect PUT requests to proxy of Service
     * @param param the request object
     */
    connectPutNamespacedServiceProxy(param: CoreV1ApiConnectPutNamespacedServiceProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect PUT requests to proxy of Service
     * @param param the request object
     */
    connectPutNamespacedServiceProxyWithPath(param: CoreV1ApiConnectPutNamespacedServiceProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * connect PUT requests to proxy of Node
     * @param param the request object
     */
    connectPutNodeProxy(param: CoreV1ApiConnectPutNodeProxyRequest, options?: Configuration): Promise<string>;
    /**
     * connect PUT requests to proxy of Node
     * @param param the request object
     */
    connectPutNodeProxyWithPath(param: CoreV1ApiConnectPutNodeProxyWithPathRequest, options?: Configuration): Promise<string>;
    /**
     * create a Namespace
     * @param param the request object
     */
    createNamespace(param: CoreV1ApiCreateNamespaceRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * create a Binding
     * @param param the request object
     */
    createNamespacedBinding(param: CoreV1ApiCreateNamespacedBindingRequest, options?: Configuration): Promise<V1Binding>;
    /**
     * create a ConfigMap
     * @param param the request object
     */
    createNamespacedConfigMap(param: CoreV1ApiCreateNamespacedConfigMapRequest, options?: Configuration): Promise<V1ConfigMap>;
    /**
     * create Endpoints
     * @param param the request object
     */
    createNamespacedEndpoints(param: CoreV1ApiCreateNamespacedEndpointsRequest, options?: Configuration): Promise<V1Endpoints>;
    /**
     * create an Event
     * @param param the request object
     */
    createNamespacedEvent(param: CoreV1ApiCreateNamespacedEventRequest, options?: Configuration): Promise<CoreV1Event>;
    /**
     * create a LimitRange
     * @param param the request object
     */
    createNamespacedLimitRange(param: CoreV1ApiCreateNamespacedLimitRangeRequest, options?: Configuration): Promise<V1LimitRange>;
    /**
     * create a PersistentVolumeClaim
     * @param param the request object
     */
    createNamespacedPersistentVolumeClaim(param: CoreV1ApiCreateNamespacedPersistentVolumeClaimRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * create a Pod
     * @param param the request object
     */
    createNamespacedPod(param: CoreV1ApiCreateNamespacedPodRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * create binding of a Pod
     * @param param the request object
     */
    createNamespacedPodBinding(param: CoreV1ApiCreateNamespacedPodBindingRequest, options?: Configuration): Promise<V1Binding>;
    /**
     * create eviction of a Pod
     * @param param the request object
     */
    createNamespacedPodEviction(param: CoreV1ApiCreateNamespacedPodEvictionRequest, options?: Configuration): Promise<V1Eviction>;
    /**
     * create a PodTemplate
     * @param param the request object
     */
    createNamespacedPodTemplate(param: CoreV1ApiCreateNamespacedPodTemplateRequest, options?: Configuration): Promise<V1PodTemplate>;
    /**
     * create a ReplicationController
     * @param param the request object
     */
    createNamespacedReplicationController(param: CoreV1ApiCreateNamespacedReplicationControllerRequest, options?: Configuration): Promise<V1ReplicationController>;
    /**
     * create a ResourceQuota
     * @param param the request object
     */
    createNamespacedResourceQuota(param: CoreV1ApiCreateNamespacedResourceQuotaRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * create a Secret
     * @param param the request object
     */
    createNamespacedSecret(param: CoreV1ApiCreateNamespacedSecretRequest, options?: Configuration): Promise<V1Secret>;
    /**
     * create a Service
     * @param param the request object
     */
    createNamespacedService(param: CoreV1ApiCreateNamespacedServiceRequest, options?: Configuration): Promise<V1Service>;
    /**
     * create a ServiceAccount
     * @param param the request object
     */
    createNamespacedServiceAccount(param: CoreV1ApiCreateNamespacedServiceAccountRequest, options?: Configuration): Promise<V1ServiceAccount>;
    /**
     * create token of a ServiceAccount
     * @param param the request object
     */
    createNamespacedServiceAccountToken(param: CoreV1ApiCreateNamespacedServiceAccountTokenRequest, options?: Configuration): Promise<AuthenticationV1TokenRequest>;
    /**
     * create a Node
     * @param param the request object
     */
    createNode(param: CoreV1ApiCreateNodeRequest, options?: Configuration): Promise<V1Node>;
    /**
     * create a PersistentVolume
     * @param param the request object
     */
    createPersistentVolume(param: CoreV1ApiCreatePersistentVolumeRequest, options?: Configuration): Promise<V1PersistentVolume>;
    /**
     * delete collection of ConfigMap
     * @param param the request object
     */
    deleteCollectionNamespacedConfigMap(param: CoreV1ApiDeleteCollectionNamespacedConfigMapRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Endpoints
     * @param param the request object
     */
    deleteCollectionNamespacedEndpoints(param: CoreV1ApiDeleteCollectionNamespacedEndpointsRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Event
     * @param param the request object
     */
    deleteCollectionNamespacedEvent(param: CoreV1ApiDeleteCollectionNamespacedEventRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of LimitRange
     * @param param the request object
     */
    deleteCollectionNamespacedLimitRange(param: CoreV1ApiDeleteCollectionNamespacedLimitRangeRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of PersistentVolumeClaim
     * @param param the request object
     */
    deleteCollectionNamespacedPersistentVolumeClaim(param: CoreV1ApiDeleteCollectionNamespacedPersistentVolumeClaimRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Pod
     * @param param the request object
     */
    deleteCollectionNamespacedPod(param: CoreV1ApiDeleteCollectionNamespacedPodRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of PodTemplate
     * @param param the request object
     */
    deleteCollectionNamespacedPodTemplate(param: CoreV1ApiDeleteCollectionNamespacedPodTemplateRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ReplicationController
     * @param param the request object
     */
    deleteCollectionNamespacedReplicationController(param: CoreV1ApiDeleteCollectionNamespacedReplicationControllerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ResourceQuota
     * @param param the request object
     */
    deleteCollectionNamespacedResourceQuota(param: CoreV1ApiDeleteCollectionNamespacedResourceQuotaRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Secret
     * @param param the request object
     */
    deleteCollectionNamespacedSecret(param: CoreV1ApiDeleteCollectionNamespacedSecretRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ServiceAccount
     * @param param the request object
     */
    deleteCollectionNamespacedServiceAccount(param: CoreV1ApiDeleteCollectionNamespacedServiceAccountRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Node
     * @param param the request object
     */
    deleteCollectionNode(param?: CoreV1ApiDeleteCollectionNodeRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of PersistentVolume
     * @param param the request object
     */
    deleteCollectionPersistentVolume(param?: CoreV1ApiDeleteCollectionPersistentVolumeRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a Namespace
     * @param param the request object
     */
    deleteNamespace(param: CoreV1ApiDeleteNamespaceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ConfigMap
     * @param param the request object
     */
    deleteNamespacedConfigMap(param: CoreV1ApiDeleteNamespacedConfigMapRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete Endpoints
     * @param param the request object
     */
    deleteNamespacedEndpoints(param: CoreV1ApiDeleteNamespacedEndpointsRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete an Event
     * @param param the request object
     */
    deleteNamespacedEvent(param: CoreV1ApiDeleteNamespacedEventRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a LimitRange
     * @param param the request object
     */
    deleteNamespacedLimitRange(param: CoreV1ApiDeleteNamespacedLimitRangeRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PersistentVolumeClaim
     * @param param the request object
     */
    deleteNamespacedPersistentVolumeClaim(param: CoreV1ApiDeleteNamespacedPersistentVolumeClaimRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * delete a Pod
     * @param param the request object
     */
    deleteNamespacedPod(param: CoreV1ApiDeleteNamespacedPodRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * delete a PodTemplate
     * @param param the request object
     */
    deleteNamespacedPodTemplate(param: CoreV1ApiDeleteNamespacedPodTemplateRequest, options?: Configuration): Promise<V1PodTemplate>;
    /**
     * delete a ReplicationController
     * @param param the request object
     */
    deleteNamespacedReplicationController(param: CoreV1ApiDeleteNamespacedReplicationControllerRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ResourceQuota
     * @param param the request object
     */
    deleteNamespacedResourceQuota(param: CoreV1ApiDeleteNamespacedResourceQuotaRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * delete a Secret
     * @param param the request object
     */
    deleteNamespacedSecret(param: CoreV1ApiDeleteNamespacedSecretRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a Service
     * @param param the request object
     */
    deleteNamespacedService(param: CoreV1ApiDeleteNamespacedServiceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ServiceAccount
     * @param param the request object
     */
    deleteNamespacedServiceAccount(param: CoreV1ApiDeleteNamespacedServiceAccountRequest, options?: Configuration): Promise<V1ServiceAccount>;
    /**
     * delete a Node
     * @param param the request object
     */
    deleteNode(param: CoreV1ApiDeleteNodeRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PersistentVolume
     * @param param the request object
     */
    deletePersistentVolume(param: CoreV1ApiDeletePersistentVolumeRequest, options?: Configuration): Promise<V1PersistentVolume>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: CoreV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list objects of kind ComponentStatus
     * @param param the request object
     */
    listComponentStatus(param?: CoreV1ApiListComponentStatusRequest, options?: Configuration): Promise<V1ComponentStatusList>;
    /**
     * list or watch objects of kind ConfigMap
     * @param param the request object
     */
    listConfigMapForAllNamespaces(param?: CoreV1ApiListConfigMapForAllNamespacesRequest, options?: Configuration): Promise<V1ConfigMapList>;
    /**
     * list or watch objects of kind Endpoints
     * @param param the request object
     */
    listEndpointsForAllNamespaces(param?: CoreV1ApiListEndpointsForAllNamespacesRequest, options?: Configuration): Promise<V1EndpointsList>;
    /**
     * list or watch objects of kind Event
     * @param param the request object
     */
    listEventForAllNamespaces(param?: CoreV1ApiListEventForAllNamespacesRequest, options?: Configuration): Promise<CoreV1EventList>;
    /**
     * list or watch objects of kind LimitRange
     * @param param the request object
     */
    listLimitRangeForAllNamespaces(param?: CoreV1ApiListLimitRangeForAllNamespacesRequest, options?: Configuration): Promise<V1LimitRangeList>;
    /**
     * list or watch objects of kind Namespace
     * @param param the request object
     */
    listNamespace(param?: CoreV1ApiListNamespaceRequest, options?: Configuration): Promise<V1NamespaceList>;
    /**
     * list or watch objects of kind ConfigMap
     * @param param the request object
     */
    listNamespacedConfigMap(param: CoreV1ApiListNamespacedConfigMapRequest, options?: Configuration): Promise<V1ConfigMapList>;
    /**
     * list or watch objects of kind Endpoints
     * @param param the request object
     */
    listNamespacedEndpoints(param: CoreV1ApiListNamespacedEndpointsRequest, options?: Configuration): Promise<V1EndpointsList>;
    /**
     * list or watch objects of kind Event
     * @param param the request object
     */
    listNamespacedEvent(param: CoreV1ApiListNamespacedEventRequest, options?: Configuration): Promise<CoreV1EventList>;
    /**
     * list or watch objects of kind LimitRange
     * @param param the request object
     */
    listNamespacedLimitRange(param: CoreV1ApiListNamespacedLimitRangeRequest, options?: Configuration): Promise<V1LimitRangeList>;
    /**
     * list or watch objects of kind PersistentVolumeClaim
     * @param param the request object
     */
    listNamespacedPersistentVolumeClaim(param: CoreV1ApiListNamespacedPersistentVolumeClaimRequest, options?: Configuration): Promise<V1PersistentVolumeClaimList>;
    /**
     * list or watch objects of kind Pod
     * @param param the request object
     */
    listNamespacedPod(param: CoreV1ApiListNamespacedPodRequest, options?: Configuration): Promise<V1PodList>;
    /**
     * list or watch objects of kind PodTemplate
     * @param param the request object
     */
    listNamespacedPodTemplate(param: CoreV1ApiListNamespacedPodTemplateRequest, options?: Configuration): Promise<V1PodTemplateList>;
    /**
     * list or watch objects of kind ReplicationController
     * @param param the request object
     */
    listNamespacedReplicationController(param: CoreV1ApiListNamespacedReplicationControllerRequest, options?: Configuration): Promise<V1ReplicationControllerList>;
    /**
     * list or watch objects of kind ResourceQuota
     * @param param the request object
     */
    listNamespacedResourceQuota(param: CoreV1ApiListNamespacedResourceQuotaRequest, options?: Configuration): Promise<V1ResourceQuotaList>;
    /**
     * list or watch objects of kind Secret
     * @param param the request object
     */
    listNamespacedSecret(param: CoreV1ApiListNamespacedSecretRequest, options?: Configuration): Promise<V1SecretList>;
    /**
     * list or watch objects of kind Service
     * @param param the request object
     */
    listNamespacedService(param: CoreV1ApiListNamespacedServiceRequest, options?: Configuration): Promise<V1ServiceList>;
    /**
     * list or watch objects of kind ServiceAccount
     * @param param the request object
     */
    listNamespacedServiceAccount(param: CoreV1ApiListNamespacedServiceAccountRequest, options?: Configuration): Promise<V1ServiceAccountList>;
    /**
     * list or watch objects of kind Node
     * @param param the request object
     */
    listNode(param?: CoreV1ApiListNodeRequest, options?: Configuration): Promise<V1NodeList>;
    /**
     * list or watch objects of kind PersistentVolume
     * @param param the request object
     */
    listPersistentVolume(param?: CoreV1ApiListPersistentVolumeRequest, options?: Configuration): Promise<V1PersistentVolumeList>;
    /**
     * list or watch objects of kind PersistentVolumeClaim
     * @param param the request object
     */
    listPersistentVolumeClaimForAllNamespaces(param?: CoreV1ApiListPersistentVolumeClaimForAllNamespacesRequest, options?: Configuration): Promise<V1PersistentVolumeClaimList>;
    /**
     * list or watch objects of kind Pod
     * @param param the request object
     */
    listPodForAllNamespaces(param?: CoreV1ApiListPodForAllNamespacesRequest, options?: Configuration): Promise<V1PodList>;
    /**
     * list or watch objects of kind PodTemplate
     * @param param the request object
     */
    listPodTemplateForAllNamespaces(param?: CoreV1ApiListPodTemplateForAllNamespacesRequest, options?: Configuration): Promise<V1PodTemplateList>;
    /**
     * list or watch objects of kind ReplicationController
     * @param param the request object
     */
    listReplicationControllerForAllNamespaces(param?: CoreV1ApiListReplicationControllerForAllNamespacesRequest, options?: Configuration): Promise<V1ReplicationControllerList>;
    /**
     * list or watch objects of kind ResourceQuota
     * @param param the request object
     */
    listResourceQuotaForAllNamespaces(param?: CoreV1ApiListResourceQuotaForAllNamespacesRequest, options?: Configuration): Promise<V1ResourceQuotaList>;
    /**
     * list or watch objects of kind Secret
     * @param param the request object
     */
    listSecretForAllNamespaces(param?: CoreV1ApiListSecretForAllNamespacesRequest, options?: Configuration): Promise<V1SecretList>;
    /**
     * list or watch objects of kind ServiceAccount
     * @param param the request object
     */
    listServiceAccountForAllNamespaces(param?: CoreV1ApiListServiceAccountForAllNamespacesRequest, options?: Configuration): Promise<V1ServiceAccountList>;
    /**
     * list or watch objects of kind Service
     * @param param the request object
     */
    listServiceForAllNamespaces(param?: CoreV1ApiListServiceForAllNamespacesRequest, options?: Configuration): Promise<V1ServiceList>;
    /**
     * partially update the specified Namespace
     * @param param the request object
     */
    patchNamespace(param: CoreV1ApiPatchNamespaceRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * partially update status of the specified Namespace
     * @param param the request object
     */
    patchNamespaceStatus(param: CoreV1ApiPatchNamespaceStatusRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * partially update the specified ConfigMap
     * @param param the request object
     */
    patchNamespacedConfigMap(param: CoreV1ApiPatchNamespacedConfigMapRequest, options?: Configuration): Promise<V1ConfigMap>;
    /**
     * partially update the specified Endpoints
     * @param param the request object
     */
    patchNamespacedEndpoints(param: CoreV1ApiPatchNamespacedEndpointsRequest, options?: Configuration): Promise<V1Endpoints>;
    /**
     * partially update the specified Event
     * @param param the request object
     */
    patchNamespacedEvent(param: CoreV1ApiPatchNamespacedEventRequest, options?: Configuration): Promise<CoreV1Event>;
    /**
     * partially update the specified LimitRange
     * @param param the request object
     */
    patchNamespacedLimitRange(param: CoreV1ApiPatchNamespacedLimitRangeRequest, options?: Configuration): Promise<V1LimitRange>;
    /**
     * partially update the specified PersistentVolumeClaim
     * @param param the request object
     */
    patchNamespacedPersistentVolumeClaim(param: CoreV1ApiPatchNamespacedPersistentVolumeClaimRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * partially update status of the specified PersistentVolumeClaim
     * @param param the request object
     */
    patchNamespacedPersistentVolumeClaimStatus(param: CoreV1ApiPatchNamespacedPersistentVolumeClaimStatusRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * partially update the specified Pod
     * @param param the request object
     */
    patchNamespacedPod(param: CoreV1ApiPatchNamespacedPodRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * partially update ephemeralcontainers of the specified Pod
     * @param param the request object
     */
    patchNamespacedPodEphemeralcontainers(param: CoreV1ApiPatchNamespacedPodEphemeralcontainersRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * partially update status of the specified Pod
     * @param param the request object
     */
    patchNamespacedPodStatus(param: CoreV1ApiPatchNamespacedPodStatusRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * partially update the specified PodTemplate
     * @param param the request object
     */
    patchNamespacedPodTemplate(param: CoreV1ApiPatchNamespacedPodTemplateRequest, options?: Configuration): Promise<V1PodTemplate>;
    /**
     * partially update the specified ReplicationController
     * @param param the request object
     */
    patchNamespacedReplicationController(param: CoreV1ApiPatchNamespacedReplicationControllerRequest, options?: Configuration): Promise<V1ReplicationController>;
    /**
     * partially update scale of the specified ReplicationController
     * @param param the request object
     */
    patchNamespacedReplicationControllerScale(param: CoreV1ApiPatchNamespacedReplicationControllerScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * partially update status of the specified ReplicationController
     * @param param the request object
     */
    patchNamespacedReplicationControllerStatus(param: CoreV1ApiPatchNamespacedReplicationControllerStatusRequest, options?: Configuration): Promise<V1ReplicationController>;
    /**
     * partially update the specified ResourceQuota
     * @param param the request object
     */
    patchNamespacedResourceQuota(param: CoreV1ApiPatchNamespacedResourceQuotaRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * partially update status of the specified ResourceQuota
     * @param param the request object
     */
    patchNamespacedResourceQuotaStatus(param: CoreV1ApiPatchNamespacedResourceQuotaStatusRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * partially update the specified Secret
     * @param param the request object
     */
    patchNamespacedSecret(param: CoreV1ApiPatchNamespacedSecretRequest, options?: Configuration): Promise<V1Secret>;
    /**
     * partially update the specified Service
     * @param param the request object
     */
    patchNamespacedService(param: CoreV1ApiPatchNamespacedServiceRequest, options?: Configuration): Promise<V1Service>;
    /**
     * partially update the specified ServiceAccount
     * @param param the request object
     */
    patchNamespacedServiceAccount(param: CoreV1ApiPatchNamespacedServiceAccountRequest, options?: Configuration): Promise<V1ServiceAccount>;
    /**
     * partially update status of the specified Service
     * @param param the request object
     */
    patchNamespacedServiceStatus(param: CoreV1ApiPatchNamespacedServiceStatusRequest, options?: Configuration): Promise<V1Service>;
    /**
     * partially update the specified Node
     * @param param the request object
     */
    patchNode(param: CoreV1ApiPatchNodeRequest, options?: Configuration): Promise<V1Node>;
    /**
     * partially update status of the specified Node
     * @param param the request object
     */
    patchNodeStatus(param: CoreV1ApiPatchNodeStatusRequest, options?: Configuration): Promise<V1Node>;
    /**
     * partially update the specified PersistentVolume
     * @param param the request object
     */
    patchPersistentVolume(param: CoreV1ApiPatchPersistentVolumeRequest, options?: Configuration): Promise<V1PersistentVolume>;
    /**
     * partially update status of the specified PersistentVolume
     * @param param the request object
     */
    patchPersistentVolumeStatus(param: CoreV1ApiPatchPersistentVolumeStatusRequest, options?: Configuration): Promise<V1PersistentVolume>;
    /**
     * read the specified ComponentStatus
     * @param param the request object
     */
    readComponentStatus(param: CoreV1ApiReadComponentStatusRequest, options?: Configuration): Promise<V1ComponentStatus>;
    /**
     * read the specified Namespace
     * @param param the request object
     */
    readNamespace(param: CoreV1ApiReadNamespaceRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * read status of the specified Namespace
     * @param param the request object
     */
    readNamespaceStatus(param: CoreV1ApiReadNamespaceStatusRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * read the specified ConfigMap
     * @param param the request object
     */
    readNamespacedConfigMap(param: CoreV1ApiReadNamespacedConfigMapRequest, options?: Configuration): Promise<V1ConfigMap>;
    /**
     * read the specified Endpoints
     * @param param the request object
     */
    readNamespacedEndpoints(param: CoreV1ApiReadNamespacedEndpointsRequest, options?: Configuration): Promise<V1Endpoints>;
    /**
     * read the specified Event
     * @param param the request object
     */
    readNamespacedEvent(param: CoreV1ApiReadNamespacedEventRequest, options?: Configuration): Promise<CoreV1Event>;
    /**
     * read the specified LimitRange
     * @param param the request object
     */
    readNamespacedLimitRange(param: CoreV1ApiReadNamespacedLimitRangeRequest, options?: Configuration): Promise<V1LimitRange>;
    /**
     * read the specified PersistentVolumeClaim
     * @param param the request object
     */
    readNamespacedPersistentVolumeClaim(param: CoreV1ApiReadNamespacedPersistentVolumeClaimRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * read status of the specified PersistentVolumeClaim
     * @param param the request object
     */
    readNamespacedPersistentVolumeClaimStatus(param: CoreV1ApiReadNamespacedPersistentVolumeClaimStatusRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * read the specified Pod
     * @param param the request object
     */
    readNamespacedPod(param: CoreV1ApiReadNamespacedPodRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * read ephemeralcontainers of the specified Pod
     * @param param the request object
     */
    readNamespacedPodEphemeralcontainers(param: CoreV1ApiReadNamespacedPodEphemeralcontainersRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * read log of the specified Pod
     * @param param the request object
     */
    readNamespacedPodLog(param: CoreV1ApiReadNamespacedPodLogRequest, options?: Configuration): Promise<string>;
    /**
     * read status of the specified Pod
     * @param param the request object
     */
    readNamespacedPodStatus(param: CoreV1ApiReadNamespacedPodStatusRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * read the specified PodTemplate
     * @param param the request object
     */
    readNamespacedPodTemplate(param: CoreV1ApiReadNamespacedPodTemplateRequest, options?: Configuration): Promise<V1PodTemplate>;
    /**
     * read the specified ReplicationController
     * @param param the request object
     */
    readNamespacedReplicationController(param: CoreV1ApiReadNamespacedReplicationControllerRequest, options?: Configuration): Promise<V1ReplicationController>;
    /**
     * read scale of the specified ReplicationController
     * @param param the request object
     */
    readNamespacedReplicationControllerScale(param: CoreV1ApiReadNamespacedReplicationControllerScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * read status of the specified ReplicationController
     * @param param the request object
     */
    readNamespacedReplicationControllerStatus(param: CoreV1ApiReadNamespacedReplicationControllerStatusRequest, options?: Configuration): Promise<V1ReplicationController>;
    /**
     * read the specified ResourceQuota
     * @param param the request object
     */
    readNamespacedResourceQuota(param: CoreV1ApiReadNamespacedResourceQuotaRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * read status of the specified ResourceQuota
     * @param param the request object
     */
    readNamespacedResourceQuotaStatus(param: CoreV1ApiReadNamespacedResourceQuotaStatusRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * read the specified Secret
     * @param param the request object
     */
    readNamespacedSecret(param: CoreV1ApiReadNamespacedSecretRequest, options?: Configuration): Promise<V1Secret>;
    /**
     * read the specified Service
     * @param param the request object
     */
    readNamespacedService(param: CoreV1ApiReadNamespacedServiceRequest, options?: Configuration): Promise<V1Service>;
    /**
     * read the specified ServiceAccount
     * @param param the request object
     */
    readNamespacedServiceAccount(param: CoreV1ApiReadNamespacedServiceAccountRequest, options?: Configuration): Promise<V1ServiceAccount>;
    /**
     * read status of the specified Service
     * @param param the request object
     */
    readNamespacedServiceStatus(param: CoreV1ApiReadNamespacedServiceStatusRequest, options?: Configuration): Promise<V1Service>;
    /**
     * read the specified Node
     * @param param the request object
     */
    readNode(param: CoreV1ApiReadNodeRequest, options?: Configuration): Promise<V1Node>;
    /**
     * read status of the specified Node
     * @param param the request object
     */
    readNodeStatus(param: CoreV1ApiReadNodeStatusRequest, options?: Configuration): Promise<V1Node>;
    /**
     * read the specified PersistentVolume
     * @param param the request object
     */
    readPersistentVolume(param: CoreV1ApiReadPersistentVolumeRequest, options?: Configuration): Promise<V1PersistentVolume>;
    /**
     * read status of the specified PersistentVolume
     * @param param the request object
     */
    readPersistentVolumeStatus(param: CoreV1ApiReadPersistentVolumeStatusRequest, options?: Configuration): Promise<V1PersistentVolume>;
    /**
     * replace the specified Namespace
     * @param param the request object
     */
    replaceNamespace(param: CoreV1ApiReplaceNamespaceRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * replace finalize of the specified Namespace
     * @param param the request object
     */
    replaceNamespaceFinalize(param: CoreV1ApiReplaceNamespaceFinalizeRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * replace status of the specified Namespace
     * @param param the request object
     */
    replaceNamespaceStatus(param: CoreV1ApiReplaceNamespaceStatusRequest, options?: Configuration): Promise<V1Namespace>;
    /**
     * replace the specified ConfigMap
     * @param param the request object
     */
    replaceNamespacedConfigMap(param: CoreV1ApiReplaceNamespacedConfigMapRequest, options?: Configuration): Promise<V1ConfigMap>;
    /**
     * replace the specified Endpoints
     * @param param the request object
     */
    replaceNamespacedEndpoints(param: CoreV1ApiReplaceNamespacedEndpointsRequest, options?: Configuration): Promise<V1Endpoints>;
    /**
     * replace the specified Event
     * @param param the request object
     */
    replaceNamespacedEvent(param: CoreV1ApiReplaceNamespacedEventRequest, options?: Configuration): Promise<CoreV1Event>;
    /**
     * replace the specified LimitRange
     * @param param the request object
     */
    replaceNamespacedLimitRange(param: CoreV1ApiReplaceNamespacedLimitRangeRequest, options?: Configuration): Promise<V1LimitRange>;
    /**
     * replace the specified PersistentVolumeClaim
     * @param param the request object
     */
    replaceNamespacedPersistentVolumeClaim(param: CoreV1ApiReplaceNamespacedPersistentVolumeClaimRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * replace status of the specified PersistentVolumeClaim
     * @param param the request object
     */
    replaceNamespacedPersistentVolumeClaimStatus(param: CoreV1ApiReplaceNamespacedPersistentVolumeClaimStatusRequest, options?: Configuration): Promise<V1PersistentVolumeClaim>;
    /**
     * replace the specified Pod
     * @param param the request object
     */
    replaceNamespacedPod(param: CoreV1ApiReplaceNamespacedPodRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * replace ephemeralcontainers of the specified Pod
     * @param param the request object
     */
    replaceNamespacedPodEphemeralcontainers(param: CoreV1ApiReplaceNamespacedPodEphemeralcontainersRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * replace status of the specified Pod
     * @param param the request object
     */
    replaceNamespacedPodStatus(param: CoreV1ApiReplaceNamespacedPodStatusRequest, options?: Configuration): Promise<V1Pod>;
    /**
     * replace the specified PodTemplate
     * @param param the request object
     */
    replaceNamespacedPodTemplate(param: CoreV1ApiReplaceNamespacedPodTemplateRequest, options?: Configuration): Promise<V1PodTemplate>;
    /**
     * replace the specified ReplicationController
     * @param param the request object
     */
    replaceNamespacedReplicationController(param: CoreV1ApiReplaceNamespacedReplicationControllerRequest, options?: Configuration): Promise<V1ReplicationController>;
    /**
     * replace scale of the specified ReplicationController
     * @param param the request object
     */
    replaceNamespacedReplicationControllerScale(param: CoreV1ApiReplaceNamespacedReplicationControllerScaleRequest, options?: Configuration): Promise<V1Scale>;
    /**
     * replace status of the specified ReplicationController
     * @param param the request object
     */
    replaceNamespacedReplicationControllerStatus(param: CoreV1ApiReplaceNamespacedReplicationControllerStatusRequest, options?: Configuration): Promise<V1ReplicationController>;
    /**
     * replace the specified ResourceQuota
     * @param param the request object
     */
    replaceNamespacedResourceQuota(param: CoreV1ApiReplaceNamespacedResourceQuotaRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * replace status of the specified ResourceQuota
     * @param param the request object
     */
    replaceNamespacedResourceQuotaStatus(param: CoreV1ApiReplaceNamespacedResourceQuotaStatusRequest, options?: Configuration): Promise<V1ResourceQuota>;
    /**
     * replace the specified Secret
     * @param param the request object
     */
    replaceNamespacedSecret(param: CoreV1ApiReplaceNamespacedSecretRequest, options?: Configuration): Promise<V1Secret>;
    /**
     * replace the specified Service
     * @param param the request object
     */
    replaceNamespacedService(param: CoreV1ApiReplaceNamespacedServiceRequest, options?: Configuration): Promise<V1Service>;
    /**
     * replace the specified ServiceAccount
     * @param param the request object
     */
    replaceNamespacedServiceAccount(param: CoreV1ApiReplaceNamespacedServiceAccountRequest, options?: Configuration): Promise<V1ServiceAccount>;
    /**
     * replace status of the specified Service
     * @param param the request object
     */
    replaceNamespacedServiceStatus(param: CoreV1ApiReplaceNamespacedServiceStatusRequest, options?: Configuration): Promise<V1Service>;
    /**
     * replace the specified Node
     * @param param the request object
     */
    replaceNode(param: CoreV1ApiReplaceNodeRequest, options?: Configuration): Promise<V1Node>;
    /**
     * replace status of the specified Node
     * @param param the request object
     */
    replaceNodeStatus(param: CoreV1ApiReplaceNodeStatusRequest, options?: Configuration): Promise<V1Node>;
    /**
     * replace the specified PersistentVolume
     * @param param the request object
     */
    replacePersistentVolume(param: CoreV1ApiReplacePersistentVolumeRequest, options?: Configuration): Promise<V1PersistentVolume>;
    /**
     * replace status of the specified PersistentVolume
     * @param param the request object
     */
    replacePersistentVolumeStatus(param: CoreV1ApiReplacePersistentVolumeStatusRequest, options?: Configuration): Promise<V1PersistentVolume>;
}
import { CustomObjectsApiRequestFactory, CustomObjectsApiResponseProcessor } from "../apis/CustomObjectsApi";
export interface CustomObjectsApiCreateClusterCustomObjectRequest {
    /**
     * The custom resource\&#39;s group name
     * @type string
     * @memberof CustomObjectsApicreateClusterCustomObject
     */
    group: string;
    /**
     * The custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApicreateClusterCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApicreateClusterCustomObject
     */
    plural: string;
    /**
     * The JSON schema of the Resource to create.
     * @type any
     * @memberof CustomObjectsApicreateClusterCustomObject
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CustomObjectsApicreateClusterCustomObject
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApicreateClusterCustomObject
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CustomObjectsApicreateClusterCustomObject
     */
    fieldManager?: string;
}
export interface CustomObjectsApiCreateNamespacedCustomObjectRequest {
    /**
     * The custom resource\&#39;s group name
     * @type string
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    group: string;
    /**
     * The custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    namespace: string;
    /**
     * The custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    plural: string;
    /**
     * The JSON schema of the Resource to create.
     * @type any
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CustomObjectsApicreateNamespacedCustomObject
     */
    fieldManager?: string;
}
export interface CustomObjectsApiDeleteClusterCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    version: string;
    /**
     * the custom object\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    name: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy.
     * @type string
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    propagationPolicy?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    dryRun?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CustomObjectsApideleteClusterCustomObject
     */
    body?: V1DeleteOptions;
}
export interface CustomObjectsApiDeleteCollectionClusterCustomObjectRequest {
    /**
     * The custom resource\&#39;s group name
     * @type string
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    group: string;
    /**
     * The custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    plural: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    pretty?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy.
     * @type string
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    propagationPolicy?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    dryRun?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CustomObjectsApideleteCollectionClusterCustomObject
     */
    body?: V1DeleteOptions;
}
export interface CustomObjectsApiDeleteCollectionNamespacedCustomObjectRequest {
    /**
     * The custom resource\&#39;s group name
     * @type string
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    group: string;
    /**
     * The custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    namespace: string;
    /**
     * The custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    plural: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    pretty?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy.
     * @type string
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    propagationPolicy?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    dryRun?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CustomObjectsApideleteCollectionNamespacedCustomObject
     */
    body?: V1DeleteOptions;
}
export interface CustomObjectsApiDeleteNamespacedCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    name: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy.
     * @type string
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    propagationPolicy?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    dryRun?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof CustomObjectsApideleteNamespacedCustomObject
     */
    body?: V1DeleteOptions;
}
export interface CustomObjectsApiGetAPIResourcesRequest {
    /**
     * The custom resource\&#39;s group name
     * @type string
     * @memberof CustomObjectsApigetAPIResources
     */
    group: string;
    /**
     * The custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApigetAPIResources
     */
    version: string;
}
export interface CustomObjectsApiGetClusterCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObject
     */
    version: string;
    /**
     * the custom object\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObject
     */
    name: string;
}
export interface CustomObjectsApiGetClusterCustomObjectScaleRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectScale
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectScale
     */
    version: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectScale
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectScale
     */
    name: string;
}
export interface CustomObjectsApiGetClusterCustomObjectStatusRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectStatus
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectStatus
     */
    version: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectStatus
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApigetClusterCustomObjectStatus
     */
    name: string;
}
export interface CustomObjectsApiGetNamespacedCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObject
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObject
     */
    name: string;
}
export interface CustomObjectsApiGetNamespacedCustomObjectScaleRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectScale
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectScale
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectScale
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectScale
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectScale
     */
    name: string;
}
export interface CustomObjectsApiGetNamespacedCustomObjectStatusRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectStatus
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectStatus
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectStatus
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectStatus
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApigetNamespacedCustomObjectStatus
     */
    name: string;
}
export interface CustomObjectsApiListClusterCustomObjectRequest {
    /**
     * The custom resource\&#39;s group name
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    group: string;
    /**
     * The custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    plural: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored. If the feature gate WatchBookmarks is not enabled in apiserver, this field is ignored.
     * @type boolean
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    limit?: number;
    /**
     * When specified with a watch call, shows changes that occur after that particular version of a resource. Defaults to changes from the beginning of history. When specified for list: - if unset, then the result is returned from remote storage based on quorum-read flag; - if it\&#39;s 0, then we simply return what we currently have in cache, no guarantee; - if set to non zero, then the result is at least as fresh as given rv.
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications.
     * @type boolean
     * @memberof CustomObjectsApilistClusterCustomObject
     */
    watch?: boolean;
}
export interface CustomObjectsApiListNamespacedCustomObjectRequest {
    /**
     * The custom resource\&#39;s group name
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    group: string;
    /**
     * The custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    namespace: string;
    /**
     * The custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    plural: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored. If the feature gate WatchBookmarks is not enabled in apiserver, this field is ignored.
     * @type boolean
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    limit?: number;
    /**
     * When specified with a watch call, shows changes that occur after that particular version of a resource. Defaults to changes from the beginning of history. When specified for list: - if unset, then the result is returned from remote storage based on quorum-read flag; - if it\&#39;s 0, then we simply return what we currently have in cache, no guarantee; - if set to non zero, then the result is at least as fresh as given rv.
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications.
     * @type boolean
     * @memberof CustomObjectsApilistNamespacedCustomObject
     */
    watch?: boolean;
}
export interface CustomObjectsApiPatchClusterCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    version: string;
    /**
     * the custom object\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    name: string;
    /**
     * The JSON schema of the Resource to patch.
     * @type any
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CustomObjectsApipatchClusterCustomObject
     */
    force?: boolean;
}
export interface CustomObjectsApiPatchClusterCustomObjectScaleRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    version: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CustomObjectsApipatchClusterCustomObjectScale
     */
    force?: boolean;
}
export interface CustomObjectsApiPatchClusterCustomObjectStatusRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    version: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CustomObjectsApipatchClusterCustomObjectStatus
     */
    force?: boolean;
}
export interface CustomObjectsApiPatchNamespacedCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    name: string;
    /**
     * The JSON schema of the Resource to patch.
     * @type any
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CustomObjectsApipatchNamespacedCustomObject
     */
    force?: boolean;
}
export interface CustomObjectsApiPatchNamespacedCustomObjectScaleRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CustomObjectsApipatchNamespacedCustomObjectScale
     */
    force?: boolean;
}
export interface CustomObjectsApiPatchNamespacedCustomObjectStatusRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof CustomObjectsApipatchNamespacedCustomObjectStatus
     */
    force?: boolean;
}
export interface CustomObjectsApiReplaceClusterCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObject
     */
    version: string;
    /**
     * the custom object\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObject
     */
    name: string;
    /**
     * The JSON schema of the Resource to replace.
     * @type any
     * @memberof CustomObjectsApireplaceClusterCustomObject
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObject
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObject
     */
    fieldManager?: string;
}
export interface CustomObjectsApiReplaceClusterCustomObjectScaleRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectScale
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectScale
     */
    version: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectScale
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectScale
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApireplaceClusterCustomObjectScale
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectScale
     */
    fieldManager?: string;
}
export interface CustomObjectsApiReplaceClusterCustomObjectStatusRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectStatus
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectStatus
     */
    version: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectStatus
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApireplaceClusterCustomObjectStatus
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CustomObjectsApireplaceClusterCustomObjectStatus
     */
    fieldManager?: string;
}
export interface CustomObjectsApiReplaceNamespacedCustomObjectRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    name: string;
    /**
     * The JSON schema of the Resource to replace.
     * @type any
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObject
     */
    fieldManager?: string;
}
export interface CustomObjectsApiReplaceNamespacedCustomObjectScaleRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectScale
     */
    fieldManager?: string;
}
export interface CustomObjectsApiReplaceNamespacedCustomObjectStatusRequest {
    /**
     * the custom resource\&#39;s group
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    group: string;
    /**
     * the custom resource\&#39;s version
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    version: string;
    /**
     * The custom resource\&#39;s namespace
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    namespace: string;
    /**
     * the custom resource\&#39;s plural name. For TPRs this would be lowercase plural kind.
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    plural: string;
    /**
     * the custom object\&#39;s name
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    body: any;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof CustomObjectsApireplaceNamespacedCustomObjectStatus
     */
    fieldManager?: string;
}
export declare class ObjectCustomObjectsApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: CustomObjectsApiRequestFactory, responseProcessor?: CustomObjectsApiResponseProcessor);
    /**
     * Creates a cluster scoped Custom object
     * @param param the request object
     */
    createClusterCustomObject(param: CustomObjectsApiCreateClusterCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * Creates a namespace scoped Custom object
     * @param param the request object
     */
    createNamespacedCustomObject(param: CustomObjectsApiCreateNamespacedCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * Deletes the specified cluster scoped custom object
     * @param param the request object
     */
    deleteClusterCustomObject(param: CustomObjectsApiDeleteClusterCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * Delete collection of cluster scoped custom objects
     * @param param the request object
     */
    deleteCollectionClusterCustomObject(param: CustomObjectsApiDeleteCollectionClusterCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * Delete collection of namespace scoped custom objects
     * @param param the request object
     */
    deleteCollectionNamespacedCustomObject(param: CustomObjectsApiDeleteCollectionNamespacedCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * Deletes the specified namespace scoped custom object
     * @param param the request object
     */
    deleteNamespacedCustomObject(param: CustomObjectsApiDeleteNamespacedCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param: CustomObjectsApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * Returns a cluster scoped custom object
     * @param param the request object
     */
    getClusterCustomObject(param: CustomObjectsApiGetClusterCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * read scale of the specified custom object
     * @param param the request object
     */
    getClusterCustomObjectScale(param: CustomObjectsApiGetClusterCustomObjectScaleRequest, options?: Configuration): Promise<any>;
    /**
     * read status of the specified cluster scoped custom object
     * @param param the request object
     */
    getClusterCustomObjectStatus(param: CustomObjectsApiGetClusterCustomObjectStatusRequest, options?: Configuration): Promise<any>;
    /**
     * Returns a namespace scoped custom object
     * @param param the request object
     */
    getNamespacedCustomObject(param: CustomObjectsApiGetNamespacedCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * read scale of the specified namespace scoped custom object
     * @param param the request object
     */
    getNamespacedCustomObjectScale(param: CustomObjectsApiGetNamespacedCustomObjectScaleRequest, options?: Configuration): Promise<any>;
    /**
     * read status of the specified namespace scoped custom object
     * @param param the request object
     */
    getNamespacedCustomObjectStatus(param: CustomObjectsApiGetNamespacedCustomObjectStatusRequest, options?: Configuration): Promise<any>;
    /**
     * list or watch cluster scoped custom objects
     * @param param the request object
     */
    listClusterCustomObject(param: CustomObjectsApiListClusterCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * list or watch namespace scoped custom objects
     * @param param the request object
     */
    listNamespacedCustomObject(param: CustomObjectsApiListNamespacedCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * patch the specified cluster scoped custom object
     * @param param the request object
     */
    patchClusterCustomObject(param: CustomObjectsApiPatchClusterCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * partially update scale of the specified cluster scoped custom object
     * @param param the request object
     */
    patchClusterCustomObjectScale(param: CustomObjectsApiPatchClusterCustomObjectScaleRequest, options?: Configuration): Promise<any>;
    /**
     * partially update status of the specified cluster scoped custom object
     * @param param the request object
     */
    patchClusterCustomObjectStatus(param: CustomObjectsApiPatchClusterCustomObjectStatusRequest, options?: Configuration): Promise<any>;
    /**
     * patch the specified namespace scoped custom object
     * @param param the request object
     */
    patchNamespacedCustomObject(param: CustomObjectsApiPatchNamespacedCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * partially update scale of the specified namespace scoped custom object
     * @param param the request object
     */
    patchNamespacedCustomObjectScale(param: CustomObjectsApiPatchNamespacedCustomObjectScaleRequest, options?: Configuration): Promise<any>;
    /**
     * partially update status of the specified namespace scoped custom object
     * @param param the request object
     */
    patchNamespacedCustomObjectStatus(param: CustomObjectsApiPatchNamespacedCustomObjectStatusRequest, options?: Configuration): Promise<any>;
    /**
     * replace the specified cluster scoped custom object
     * @param param the request object
     */
    replaceClusterCustomObject(param: CustomObjectsApiReplaceClusterCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * replace scale of the specified cluster scoped custom object
     * @param param the request object
     */
    replaceClusterCustomObjectScale(param: CustomObjectsApiReplaceClusterCustomObjectScaleRequest, options?: Configuration): Promise<any>;
    /**
     * replace status of the cluster scoped specified custom object
     * @param param the request object
     */
    replaceClusterCustomObjectStatus(param: CustomObjectsApiReplaceClusterCustomObjectStatusRequest, options?: Configuration): Promise<any>;
    /**
     * replace the specified namespace scoped custom object
     * @param param the request object
     */
    replaceNamespacedCustomObject(param: CustomObjectsApiReplaceNamespacedCustomObjectRequest, options?: Configuration): Promise<any>;
    /**
     * replace scale of the specified namespace scoped custom object
     * @param param the request object
     */
    replaceNamespacedCustomObjectScale(param: CustomObjectsApiReplaceNamespacedCustomObjectScaleRequest, options?: Configuration): Promise<any>;
    /**
     * replace status of the specified namespace scoped custom object
     * @param param the request object
     */
    replaceNamespacedCustomObjectStatus(param: CustomObjectsApiReplaceNamespacedCustomObjectStatusRequest, options?: Configuration): Promise<any>;
}
import { DiscoveryApiRequestFactory, DiscoveryApiResponseProcessor } from "../apis/DiscoveryApi";
export interface DiscoveryApiGetAPIGroupRequest {
}
export declare class ObjectDiscoveryApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: DiscoveryApiRequestFactory, responseProcessor?: DiscoveryApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: DiscoveryApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { DiscoveryV1ApiRequestFactory, DiscoveryV1ApiResponseProcessor } from "../apis/DiscoveryV1Api";
export interface DiscoveryV1ApiCreateNamespacedEndpointSliceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1ApicreateNamespacedEndpointSlice
     */
    namespace: string;
    /**
     *
     * @type V1EndpointSlice
     * @memberof DiscoveryV1ApicreateNamespacedEndpointSlice
     */
    body: V1EndpointSlice;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApicreateNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1ApicreateNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof DiscoveryV1ApicreateNamespacedEndpointSlice
     */
    fieldManager?: string;
}
export interface DiscoveryV1ApiDeleteCollectionNamespacedEndpointSliceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof DiscoveryV1ApideleteCollectionNamespacedEndpointSlice
     */
    body?: V1DeleteOptions;
}
export interface DiscoveryV1ApiDeleteNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof DiscoveryV1ApideleteNamespacedEndpointSlice
     */
    body?: V1DeleteOptions;
}
export interface DiscoveryV1ApiGetAPIResourcesRequest {
}
export interface DiscoveryV1ApiListEndpointSliceForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof DiscoveryV1ApilistEndpointSliceForAllNamespaces
     */
    watch?: boolean;
}
export interface DiscoveryV1ApiListNamespacedEndpointSliceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof DiscoveryV1ApilistNamespacedEndpointSlice
     */
    watch?: boolean;
}
export interface DiscoveryV1ApiPatchNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1ApipatchNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1ApipatchNamespacedEndpointSlice
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof DiscoveryV1ApipatchNamespacedEndpointSlice
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApipatchNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1ApipatchNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof DiscoveryV1ApipatchNamespacedEndpointSlice
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof DiscoveryV1ApipatchNamespacedEndpointSlice
     */
    force?: boolean;
}
export interface DiscoveryV1ApiReadNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1ApireadNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1ApireadNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApireadNamespacedEndpointSlice
     */
    pretty?: string;
}
export interface DiscoveryV1ApiReplaceNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1ApireplaceNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1ApireplaceNamespacedEndpointSlice
     */
    namespace: string;
    /**
     *
     * @type V1EndpointSlice
     * @memberof DiscoveryV1ApireplaceNamespacedEndpointSlice
     */
    body: V1EndpointSlice;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1ApireplaceNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1ApireplaceNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof DiscoveryV1ApireplaceNamespacedEndpointSlice
     */
    fieldManager?: string;
}
export declare class ObjectDiscoveryV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: DiscoveryV1ApiRequestFactory, responseProcessor?: DiscoveryV1ApiResponseProcessor);
    /**
     * create an EndpointSlice
     * @param param the request object
     */
    createNamespacedEndpointSlice(param: DiscoveryV1ApiCreateNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1EndpointSlice>;
    /**
     * delete collection of EndpointSlice
     * @param param the request object
     */
    deleteCollectionNamespacedEndpointSlice(param: DiscoveryV1ApiDeleteCollectionNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete an EndpointSlice
     * @param param the request object
     */
    deleteNamespacedEndpointSlice(param: DiscoveryV1ApiDeleteNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: DiscoveryV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind EndpointSlice
     * @param param the request object
     */
    listEndpointSliceForAllNamespaces(param?: DiscoveryV1ApiListEndpointSliceForAllNamespacesRequest, options?: Configuration): Promise<V1EndpointSliceList>;
    /**
     * list or watch objects of kind EndpointSlice
     * @param param the request object
     */
    listNamespacedEndpointSlice(param: DiscoveryV1ApiListNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1EndpointSliceList>;
    /**
     * partially update the specified EndpointSlice
     * @param param the request object
     */
    patchNamespacedEndpointSlice(param: DiscoveryV1ApiPatchNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1EndpointSlice>;
    /**
     * read the specified EndpointSlice
     * @param param the request object
     */
    readNamespacedEndpointSlice(param: DiscoveryV1ApiReadNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1EndpointSlice>;
    /**
     * replace the specified EndpointSlice
     * @param param the request object
     */
    replaceNamespacedEndpointSlice(param: DiscoveryV1ApiReplaceNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1EndpointSlice>;
}
import { DiscoveryV1beta1ApiRequestFactory, DiscoveryV1beta1ApiResponseProcessor } from "../apis/DiscoveryV1beta1Api";
export interface DiscoveryV1beta1ApiCreateNamespacedEndpointSliceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1beta1ApicreateNamespacedEndpointSlice
     */
    namespace: string;
    /**
     *
     * @type V1beta1EndpointSlice
     * @memberof DiscoveryV1beta1ApicreateNamespacedEndpointSlice
     */
    body: V1beta1EndpointSlice;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApicreateNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1beta1ApicreateNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof DiscoveryV1beta1ApicreateNamespacedEndpointSlice
     */
    fieldManager?: string;
}
export interface DiscoveryV1beta1ApiDeleteCollectionNamespacedEndpointSliceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof DiscoveryV1beta1ApideleteCollectionNamespacedEndpointSlice
     */
    body?: V1DeleteOptions;
}
export interface DiscoveryV1beta1ApiDeleteNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof DiscoveryV1beta1ApideleteNamespacedEndpointSlice
     */
    body?: V1DeleteOptions;
}
export interface DiscoveryV1beta1ApiGetAPIResourcesRequest {
}
export interface DiscoveryV1beta1ApiListEndpointSliceForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof DiscoveryV1beta1ApilistEndpointSliceForAllNamespaces
     */
    watch?: boolean;
}
export interface DiscoveryV1beta1ApiListNamespacedEndpointSliceRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof DiscoveryV1beta1ApilistNamespacedEndpointSlice
     */
    watch?: boolean;
}
export interface DiscoveryV1beta1ApiPatchNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1beta1ApipatchNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1beta1ApipatchNamespacedEndpointSlice
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof DiscoveryV1beta1ApipatchNamespacedEndpointSlice
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApipatchNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1beta1ApipatchNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof DiscoveryV1beta1ApipatchNamespacedEndpointSlice
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof DiscoveryV1beta1ApipatchNamespacedEndpointSlice
     */
    force?: boolean;
}
export interface DiscoveryV1beta1ApiReadNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1beta1ApireadNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1beta1ApireadNamespacedEndpointSlice
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApireadNamespacedEndpointSlice
     */
    pretty?: string;
}
export interface DiscoveryV1beta1ApiReplaceNamespacedEndpointSliceRequest {
    /**
     * name of the EndpointSlice
     * @type string
     * @memberof DiscoveryV1beta1ApireplaceNamespacedEndpointSlice
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof DiscoveryV1beta1ApireplaceNamespacedEndpointSlice
     */
    namespace: string;
    /**
     *
     * @type V1beta1EndpointSlice
     * @memberof DiscoveryV1beta1ApireplaceNamespacedEndpointSlice
     */
    body: V1beta1EndpointSlice;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof DiscoveryV1beta1ApireplaceNamespacedEndpointSlice
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof DiscoveryV1beta1ApireplaceNamespacedEndpointSlice
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof DiscoveryV1beta1ApireplaceNamespacedEndpointSlice
     */
    fieldManager?: string;
}
export declare class ObjectDiscoveryV1beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: DiscoveryV1beta1ApiRequestFactory, responseProcessor?: DiscoveryV1beta1ApiResponseProcessor);
    /**
     * create an EndpointSlice
     * @param param the request object
     */
    createNamespacedEndpointSlice(param: DiscoveryV1beta1ApiCreateNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1beta1EndpointSlice>;
    /**
     * delete collection of EndpointSlice
     * @param param the request object
     */
    deleteCollectionNamespacedEndpointSlice(param: DiscoveryV1beta1ApiDeleteCollectionNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete an EndpointSlice
     * @param param the request object
     */
    deleteNamespacedEndpointSlice(param: DiscoveryV1beta1ApiDeleteNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: DiscoveryV1beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind EndpointSlice
     * @param param the request object
     */
    listEndpointSliceForAllNamespaces(param?: DiscoveryV1beta1ApiListEndpointSliceForAllNamespacesRequest, options?: Configuration): Promise<V1beta1EndpointSliceList>;
    /**
     * list or watch objects of kind EndpointSlice
     * @param param the request object
     */
    listNamespacedEndpointSlice(param: DiscoveryV1beta1ApiListNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1beta1EndpointSliceList>;
    /**
     * partially update the specified EndpointSlice
     * @param param the request object
     */
    patchNamespacedEndpointSlice(param: DiscoveryV1beta1ApiPatchNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1beta1EndpointSlice>;
    /**
     * read the specified EndpointSlice
     * @param param the request object
     */
    readNamespacedEndpointSlice(param: DiscoveryV1beta1ApiReadNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1beta1EndpointSlice>;
    /**
     * replace the specified EndpointSlice
     * @param param the request object
     */
    replaceNamespacedEndpointSlice(param: DiscoveryV1beta1ApiReplaceNamespacedEndpointSliceRequest, options?: Configuration): Promise<V1beta1EndpointSlice>;
}
import { EventsApiRequestFactory, EventsApiResponseProcessor } from "../apis/EventsApi";
export interface EventsApiGetAPIGroupRequest {
}
export declare class ObjectEventsApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: EventsApiRequestFactory, responseProcessor?: EventsApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: EventsApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { EventsV1ApiRequestFactory, EventsV1ApiResponseProcessor } from "../apis/EventsV1Api";
export interface EventsV1ApiCreateNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1ApicreateNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type EventsV1Event
     * @memberof EventsV1ApicreateNamespacedEvent
     */
    body: EventsV1Event;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApicreateNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1ApicreateNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof EventsV1ApicreateNamespacedEvent
     */
    fieldManager?: string;
}
export interface EventsV1ApiDeleteCollectionNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof EventsV1ApideleteCollectionNamespacedEvent
     */
    body?: V1DeleteOptions;
}
export interface EventsV1ApiDeleteNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof EventsV1ApideleteNamespacedEvent
     */
    body?: V1DeleteOptions;
}
export interface EventsV1ApiGetAPIResourcesRequest {
}
export interface EventsV1ApiListEventForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof EventsV1ApilistEventForAllNamespaces
     */
    watch?: boolean;
}
export interface EventsV1ApiListNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1ApilistNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApilistNamespacedEvent
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof EventsV1ApilistNamespacedEvent
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof EventsV1ApilistNamespacedEvent
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof EventsV1ApilistNamespacedEvent
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof EventsV1ApilistNamespacedEvent
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof EventsV1ApilistNamespacedEvent
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1ApilistNamespacedEvent
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1ApilistNamespacedEvent
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof EventsV1ApilistNamespacedEvent
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof EventsV1ApilistNamespacedEvent
     */
    watch?: boolean;
}
export interface EventsV1ApiPatchNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1ApipatchNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1ApipatchNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof EventsV1ApipatchNamespacedEvent
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApipatchNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1ApipatchNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof EventsV1ApipatchNamespacedEvent
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof EventsV1ApipatchNamespacedEvent
     */
    force?: boolean;
}
export interface EventsV1ApiReadNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1ApireadNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1ApireadNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApireadNamespacedEvent
     */
    pretty?: string;
}
export interface EventsV1ApiReplaceNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1ApireplaceNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1ApireplaceNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type EventsV1Event
     * @memberof EventsV1ApireplaceNamespacedEvent
     */
    body: EventsV1Event;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1ApireplaceNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1ApireplaceNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof EventsV1ApireplaceNamespacedEvent
     */
    fieldManager?: string;
}
export declare class ObjectEventsV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: EventsV1ApiRequestFactory, responseProcessor?: EventsV1ApiResponseProcessor);
    /**
     * create an Event
     * @param param the request object
     */
    createNamespacedEvent(param: EventsV1ApiCreateNamespacedEventRequest, options?: Configuration): Promise<EventsV1Event>;
    /**
     * delete collection of Event
     * @param param the request object
     */
    deleteCollectionNamespacedEvent(param: EventsV1ApiDeleteCollectionNamespacedEventRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete an Event
     * @param param the request object
     */
    deleteNamespacedEvent(param: EventsV1ApiDeleteNamespacedEventRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: EventsV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind Event
     * @param param the request object
     */
    listEventForAllNamespaces(param?: EventsV1ApiListEventForAllNamespacesRequest, options?: Configuration): Promise<EventsV1EventList>;
    /**
     * list or watch objects of kind Event
     * @param param the request object
     */
    listNamespacedEvent(param: EventsV1ApiListNamespacedEventRequest, options?: Configuration): Promise<EventsV1EventList>;
    /**
     * partially update the specified Event
     * @param param the request object
     */
    patchNamespacedEvent(param: EventsV1ApiPatchNamespacedEventRequest, options?: Configuration): Promise<EventsV1Event>;
    /**
     * read the specified Event
     * @param param the request object
     */
    readNamespacedEvent(param: EventsV1ApiReadNamespacedEventRequest, options?: Configuration): Promise<EventsV1Event>;
    /**
     * replace the specified Event
     * @param param the request object
     */
    replaceNamespacedEvent(param: EventsV1ApiReplaceNamespacedEventRequest, options?: Configuration): Promise<EventsV1Event>;
}
import { EventsV1beta1ApiRequestFactory, EventsV1beta1ApiResponseProcessor } from "../apis/EventsV1beta1Api";
export interface EventsV1beta1ApiCreateNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1beta1ApicreateNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type V1beta1Event
     * @memberof EventsV1beta1ApicreateNamespacedEvent
     */
    body: V1beta1Event;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApicreateNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1beta1ApicreateNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof EventsV1beta1ApicreateNamespacedEvent
     */
    fieldManager?: string;
}
export interface EventsV1beta1ApiDeleteCollectionNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof EventsV1beta1ApideleteCollectionNamespacedEvent
     */
    body?: V1DeleteOptions;
}
export interface EventsV1beta1ApiDeleteNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof EventsV1beta1ApideleteNamespacedEvent
     */
    body?: V1DeleteOptions;
}
export interface EventsV1beta1ApiGetAPIResourcesRequest {
}
export interface EventsV1beta1ApiListEventForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof EventsV1beta1ApilistEventForAllNamespaces
     */
    watch?: boolean;
}
export interface EventsV1beta1ApiListNamespacedEventRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof EventsV1beta1ApilistNamespacedEvent
     */
    watch?: boolean;
}
export interface EventsV1beta1ApiPatchNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1beta1ApipatchNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1beta1ApipatchNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof EventsV1beta1ApipatchNamespacedEvent
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApipatchNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1beta1ApipatchNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof EventsV1beta1ApipatchNamespacedEvent
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof EventsV1beta1ApipatchNamespacedEvent
     */
    force?: boolean;
}
export interface EventsV1beta1ApiReadNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1beta1ApireadNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1beta1ApireadNamespacedEvent
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApireadNamespacedEvent
     */
    pretty?: string;
}
export interface EventsV1beta1ApiReplaceNamespacedEventRequest {
    /**
     * name of the Event
     * @type string
     * @memberof EventsV1beta1ApireplaceNamespacedEvent
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof EventsV1beta1ApireplaceNamespacedEvent
     */
    namespace: string;
    /**
     *
     * @type V1beta1Event
     * @memberof EventsV1beta1ApireplaceNamespacedEvent
     */
    body: V1beta1Event;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof EventsV1beta1ApireplaceNamespacedEvent
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof EventsV1beta1ApireplaceNamespacedEvent
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof EventsV1beta1ApireplaceNamespacedEvent
     */
    fieldManager?: string;
}
export declare class ObjectEventsV1beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: EventsV1beta1ApiRequestFactory, responseProcessor?: EventsV1beta1ApiResponseProcessor);
    /**
     * create an Event
     * @param param the request object
     */
    createNamespacedEvent(param: EventsV1beta1ApiCreateNamespacedEventRequest, options?: Configuration): Promise<V1beta1Event>;
    /**
     * delete collection of Event
     * @param param the request object
     */
    deleteCollectionNamespacedEvent(param: EventsV1beta1ApiDeleteCollectionNamespacedEventRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete an Event
     * @param param the request object
     */
    deleteNamespacedEvent(param: EventsV1beta1ApiDeleteNamespacedEventRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: EventsV1beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind Event
     * @param param the request object
     */
    listEventForAllNamespaces(param?: EventsV1beta1ApiListEventForAllNamespacesRequest, options?: Configuration): Promise<V1beta1EventList>;
    /**
     * list or watch objects of kind Event
     * @param param the request object
     */
    listNamespacedEvent(param: EventsV1beta1ApiListNamespacedEventRequest, options?: Configuration): Promise<V1beta1EventList>;
    /**
     * partially update the specified Event
     * @param param the request object
     */
    patchNamespacedEvent(param: EventsV1beta1ApiPatchNamespacedEventRequest, options?: Configuration): Promise<V1beta1Event>;
    /**
     * read the specified Event
     * @param param the request object
     */
    readNamespacedEvent(param: EventsV1beta1ApiReadNamespacedEventRequest, options?: Configuration): Promise<V1beta1Event>;
    /**
     * replace the specified Event
     * @param param the request object
     */
    replaceNamespacedEvent(param: EventsV1beta1ApiReplaceNamespacedEventRequest, options?: Configuration): Promise<V1beta1Event>;
}
import { FlowcontrolApiserverApiRequestFactory, FlowcontrolApiserverApiResponseProcessor } from "../apis/FlowcontrolApiserverApi";
export interface FlowcontrolApiserverApiGetAPIGroupRequest {
}
export declare class ObjectFlowcontrolApiserverApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: FlowcontrolApiserverApiRequestFactory, responseProcessor?: FlowcontrolApiserverApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: FlowcontrolApiserverApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { FlowcontrolApiserverV1beta1ApiRequestFactory, FlowcontrolApiserverV1beta1ApiResponseProcessor } from "../apis/FlowcontrolApiserverV1beta1Api";
export interface FlowcontrolApiserverV1beta1ApiCreateFlowSchemaRequest {
    /**
     *
     * @type V1beta1FlowSchema
     * @memberof FlowcontrolApiserverV1beta1ApicreateFlowSchema
     */
    body: V1beta1FlowSchema;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApicreateFlowSchema
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApicreateFlowSchema
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApicreateFlowSchema
     */
    fieldManager?: string;
}
export interface FlowcontrolApiserverV1beta1ApiCreatePriorityLevelConfigurationRequest {
    /**
     *
     * @type V1beta1PriorityLevelConfiguration
     * @memberof FlowcontrolApiserverV1beta1ApicreatePriorityLevelConfiguration
     */
    body: V1beta1PriorityLevelConfiguration;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApicreatePriorityLevelConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApicreatePriorityLevelConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApicreatePriorityLevelConfiguration
     */
    fieldManager?: string;
}
export interface FlowcontrolApiserverV1beta1ApiDeleteCollectionFlowSchemaRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionFlowSchema
     */
    body?: V1DeleteOptions;
}
export interface FlowcontrolApiserverV1beta1ApiDeleteCollectionPriorityLevelConfigurationRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof FlowcontrolApiserverV1beta1ApideleteCollectionPriorityLevelConfiguration
     */
    body?: V1DeleteOptions;
}
export interface FlowcontrolApiserverV1beta1ApiDeleteFlowSchemaRequest {
    /**
     * name of the FlowSchema
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteFlowSchema
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteFlowSchema
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteFlowSchema
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideleteFlowSchema
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApideleteFlowSchema
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideleteFlowSchema
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof FlowcontrolApiserverV1beta1ApideleteFlowSchema
     */
    body?: V1DeleteOptions;
}
export interface FlowcontrolApiserverV1beta1ApiDeletePriorityLevelConfigurationRequest {
    /**
     * name of the PriorityLevelConfiguration
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideletePriorityLevelConfiguration
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideletePriorityLevelConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideletePriorityLevelConfiguration
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApideletePriorityLevelConfiguration
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApideletePriorityLevelConfiguration
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApideletePriorityLevelConfiguration
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof FlowcontrolApiserverV1beta1ApideletePriorityLevelConfiguration
     */
    body?: V1DeleteOptions;
}
export interface FlowcontrolApiserverV1beta1ApiGetAPIResourcesRequest {
}
export interface FlowcontrolApiserverV1beta1ApiListFlowSchemaRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApilistFlowSchema
     */
    watch?: boolean;
}
export interface FlowcontrolApiserverV1beta1ApiListPriorityLevelConfigurationRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApilistPriorityLevelConfiguration
     */
    watch?: boolean;
}
export interface FlowcontrolApiserverV1beta1ApiPatchFlowSchemaRequest {
    /**
     * name of the FlowSchema
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchema
     */
    name: string;
    /**
     *
     * @type any
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchema
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchema
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchema
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchema
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchema
     */
    force?: boolean;
}
export interface FlowcontrolApiserverV1beta1ApiPatchFlowSchemaStatusRequest {
    /**
     * name of the FlowSchema
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchemaStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchemaStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchemaStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchemaStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchemaStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApipatchFlowSchemaStatus
     */
    force?: boolean;
}
export interface FlowcontrolApiserverV1beta1ApiPatchPriorityLevelConfigurationRequest {
    /**
     * name of the PriorityLevelConfiguration
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfiguration
     */
    name: string;
    /**
     *
     * @type any
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfiguration
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfiguration
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfiguration
     */
    force?: boolean;
}
export interface FlowcontrolApiserverV1beta1ApiPatchPriorityLevelConfigurationStatusRequest {
    /**
     * name of the PriorityLevelConfiguration
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfigurationStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfigurationStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfigurationStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfigurationStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfigurationStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof FlowcontrolApiserverV1beta1ApipatchPriorityLevelConfigurationStatus
     */
    force?: boolean;
}
export interface FlowcontrolApiserverV1beta1ApiReadFlowSchemaRequest {
    /**
     * name of the FlowSchema
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadFlowSchema
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadFlowSchema
     */
    pretty?: string;
}
export interface FlowcontrolApiserverV1beta1ApiReadFlowSchemaStatusRequest {
    /**
     * name of the FlowSchema
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadFlowSchemaStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadFlowSchemaStatus
     */
    pretty?: string;
}
export interface FlowcontrolApiserverV1beta1ApiReadPriorityLevelConfigurationRequest {
    /**
     * name of the PriorityLevelConfiguration
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadPriorityLevelConfiguration
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadPriorityLevelConfiguration
     */
    pretty?: string;
}
export interface FlowcontrolApiserverV1beta1ApiReadPriorityLevelConfigurationStatusRequest {
    /**
     * name of the PriorityLevelConfiguration
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadPriorityLevelConfigurationStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireadPriorityLevelConfigurationStatus
     */
    pretty?: string;
}
export interface FlowcontrolApiserverV1beta1ApiReplaceFlowSchemaRequest {
    /**
     * name of the FlowSchema
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchema
     */
    name: string;
    /**
     *
     * @type V1beta1FlowSchema
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchema
     */
    body: V1beta1FlowSchema;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchema
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchema
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchema
     */
    fieldManager?: string;
}
export interface FlowcontrolApiserverV1beta1ApiReplaceFlowSchemaStatusRequest {
    /**
     * name of the FlowSchema
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchemaStatus
     */
    name: string;
    /**
     *
     * @type V1beta1FlowSchema
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchemaStatus
     */
    body: V1beta1FlowSchema;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchemaStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchemaStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplaceFlowSchemaStatus
     */
    fieldManager?: string;
}
export interface FlowcontrolApiserverV1beta1ApiReplacePriorityLevelConfigurationRequest {
    /**
     * name of the PriorityLevelConfiguration
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfiguration
     */
    name: string;
    /**
     *
     * @type V1beta1PriorityLevelConfiguration
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfiguration
     */
    body: V1beta1PriorityLevelConfiguration;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfiguration
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfiguration
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfiguration
     */
    fieldManager?: string;
}
export interface FlowcontrolApiserverV1beta1ApiReplacePriorityLevelConfigurationStatusRequest {
    /**
     * name of the PriorityLevelConfiguration
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfigurationStatus
     */
    name: string;
    /**
     *
     * @type V1beta1PriorityLevelConfiguration
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfigurationStatus
     */
    body: V1beta1PriorityLevelConfiguration;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfigurationStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfigurationStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof FlowcontrolApiserverV1beta1ApireplacePriorityLevelConfigurationStatus
     */
    fieldManager?: string;
}
export declare class ObjectFlowcontrolApiserverV1beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: FlowcontrolApiserverV1beta1ApiRequestFactory, responseProcessor?: FlowcontrolApiserverV1beta1ApiResponseProcessor);
    /**
     * create a FlowSchema
     * @param param the request object
     */
    createFlowSchema(param: FlowcontrolApiserverV1beta1ApiCreateFlowSchemaRequest, options?: Configuration): Promise<V1beta1FlowSchema>;
    /**
     * create a PriorityLevelConfiguration
     * @param param the request object
     */
    createPriorityLevelConfiguration(param: FlowcontrolApiserverV1beta1ApiCreatePriorityLevelConfigurationRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfiguration>;
    /**
     * delete collection of FlowSchema
     * @param param the request object
     */
    deleteCollectionFlowSchema(param?: FlowcontrolApiserverV1beta1ApiDeleteCollectionFlowSchemaRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of PriorityLevelConfiguration
     * @param param the request object
     */
    deleteCollectionPriorityLevelConfiguration(param?: FlowcontrolApiserverV1beta1ApiDeleteCollectionPriorityLevelConfigurationRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a FlowSchema
     * @param param the request object
     */
    deleteFlowSchema(param: FlowcontrolApiserverV1beta1ApiDeleteFlowSchemaRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PriorityLevelConfiguration
     * @param param the request object
     */
    deletePriorityLevelConfiguration(param: FlowcontrolApiserverV1beta1ApiDeletePriorityLevelConfigurationRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: FlowcontrolApiserverV1beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind FlowSchema
     * @param param the request object
     */
    listFlowSchema(param?: FlowcontrolApiserverV1beta1ApiListFlowSchemaRequest, options?: Configuration): Promise<V1beta1FlowSchemaList>;
    /**
     * list or watch objects of kind PriorityLevelConfiguration
     * @param param the request object
     */
    listPriorityLevelConfiguration(param?: FlowcontrolApiserverV1beta1ApiListPriorityLevelConfigurationRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfigurationList>;
    /**
     * partially update the specified FlowSchema
     * @param param the request object
     */
    patchFlowSchema(param: FlowcontrolApiserverV1beta1ApiPatchFlowSchemaRequest, options?: Configuration): Promise<V1beta1FlowSchema>;
    /**
     * partially update status of the specified FlowSchema
     * @param param the request object
     */
    patchFlowSchemaStatus(param: FlowcontrolApiserverV1beta1ApiPatchFlowSchemaStatusRequest, options?: Configuration): Promise<V1beta1FlowSchema>;
    /**
     * partially update the specified PriorityLevelConfiguration
     * @param param the request object
     */
    patchPriorityLevelConfiguration(param: FlowcontrolApiserverV1beta1ApiPatchPriorityLevelConfigurationRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfiguration>;
    /**
     * partially update status of the specified PriorityLevelConfiguration
     * @param param the request object
     */
    patchPriorityLevelConfigurationStatus(param: FlowcontrolApiserverV1beta1ApiPatchPriorityLevelConfigurationStatusRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfiguration>;
    /**
     * read the specified FlowSchema
     * @param param the request object
     */
    readFlowSchema(param: FlowcontrolApiserverV1beta1ApiReadFlowSchemaRequest, options?: Configuration): Promise<V1beta1FlowSchema>;
    /**
     * read status of the specified FlowSchema
     * @param param the request object
     */
    readFlowSchemaStatus(param: FlowcontrolApiserverV1beta1ApiReadFlowSchemaStatusRequest, options?: Configuration): Promise<V1beta1FlowSchema>;
    /**
     * read the specified PriorityLevelConfiguration
     * @param param the request object
     */
    readPriorityLevelConfiguration(param: FlowcontrolApiserverV1beta1ApiReadPriorityLevelConfigurationRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfiguration>;
    /**
     * read status of the specified PriorityLevelConfiguration
     * @param param the request object
     */
    readPriorityLevelConfigurationStatus(param: FlowcontrolApiserverV1beta1ApiReadPriorityLevelConfigurationStatusRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfiguration>;
    /**
     * replace the specified FlowSchema
     * @param param the request object
     */
    replaceFlowSchema(param: FlowcontrolApiserverV1beta1ApiReplaceFlowSchemaRequest, options?: Configuration): Promise<V1beta1FlowSchema>;
    /**
     * replace status of the specified FlowSchema
     * @param param the request object
     */
    replaceFlowSchemaStatus(param: FlowcontrolApiserverV1beta1ApiReplaceFlowSchemaStatusRequest, options?: Configuration): Promise<V1beta1FlowSchema>;
    /**
     * replace the specified PriorityLevelConfiguration
     * @param param the request object
     */
    replacePriorityLevelConfiguration(param: FlowcontrolApiserverV1beta1ApiReplacePriorityLevelConfigurationRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfiguration>;
    /**
     * replace status of the specified PriorityLevelConfiguration
     * @param param the request object
     */
    replacePriorityLevelConfigurationStatus(param: FlowcontrolApiserverV1beta1ApiReplacePriorityLevelConfigurationStatusRequest, options?: Configuration): Promise<V1beta1PriorityLevelConfiguration>;
}
import { InternalApiserverApiRequestFactory, InternalApiserverApiResponseProcessor } from "../apis/InternalApiserverApi";
export interface InternalApiserverApiGetAPIGroupRequest {
}
export declare class ObjectInternalApiserverApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: InternalApiserverApiRequestFactory, responseProcessor?: InternalApiserverApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: InternalApiserverApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { InternalApiserverV1alpha1ApiRequestFactory, InternalApiserverV1alpha1ApiResponseProcessor } from "../apis/InternalApiserverV1alpha1Api";
export interface InternalApiserverV1alpha1ApiCreateStorageVersionRequest {
    /**
     *
     * @type V1alpha1StorageVersion
     * @memberof InternalApiserverV1alpha1ApicreateStorageVersion
     */
    body: V1alpha1StorageVersion;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApicreateStorageVersion
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof InternalApiserverV1alpha1ApicreateStorageVersion
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof InternalApiserverV1alpha1ApicreateStorageVersion
     */
    fieldManager?: string;
}
export interface InternalApiserverV1alpha1ApiDeleteCollectionStorageVersionRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof InternalApiserverV1alpha1ApideleteCollectionStorageVersion
     */
    body?: V1DeleteOptions;
}
export interface InternalApiserverV1alpha1ApiDeleteStorageVersionRequest {
    /**
     * name of the StorageVersion
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteStorageVersion
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteStorageVersion
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteStorageVersion
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof InternalApiserverV1alpha1ApideleteStorageVersion
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof InternalApiserverV1alpha1ApideleteStorageVersion
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof InternalApiserverV1alpha1ApideleteStorageVersion
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof InternalApiserverV1alpha1ApideleteStorageVersion
     */
    body?: V1DeleteOptions;
}
export interface InternalApiserverV1alpha1ApiGetAPIResourcesRequest {
}
export interface InternalApiserverV1alpha1ApiListStorageVersionRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof InternalApiserverV1alpha1ApilistStorageVersion
     */
    watch?: boolean;
}
export interface InternalApiserverV1alpha1ApiPatchStorageVersionRequest {
    /**
     * name of the StorageVersion
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersion
     */
    name: string;
    /**
     *
     * @type any
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersion
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersion
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersion
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersion
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersion
     */
    force?: boolean;
}
export interface InternalApiserverV1alpha1ApiPatchStorageVersionStatusRequest {
    /**
     * name of the StorageVersion
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersionStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersionStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersionStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersionStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersionStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof InternalApiserverV1alpha1ApipatchStorageVersionStatus
     */
    force?: boolean;
}
export interface InternalApiserverV1alpha1ApiReadStorageVersionRequest {
    /**
     * name of the StorageVersion
     * @type string
     * @memberof InternalApiserverV1alpha1ApireadStorageVersion
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApireadStorageVersion
     */
    pretty?: string;
}
export interface InternalApiserverV1alpha1ApiReadStorageVersionStatusRequest {
    /**
     * name of the StorageVersion
     * @type string
     * @memberof InternalApiserverV1alpha1ApireadStorageVersionStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApireadStorageVersionStatus
     */
    pretty?: string;
}
export interface InternalApiserverV1alpha1ApiReplaceStorageVersionRequest {
    /**
     * name of the StorageVersion
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersion
     */
    name: string;
    /**
     *
     * @type V1alpha1StorageVersion
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersion
     */
    body: V1alpha1StorageVersion;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersion
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersion
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersion
     */
    fieldManager?: string;
}
export interface InternalApiserverV1alpha1ApiReplaceStorageVersionStatusRequest {
    /**
     * name of the StorageVersion
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersionStatus
     */
    name: string;
    /**
     *
     * @type V1alpha1StorageVersion
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersionStatus
     */
    body: V1alpha1StorageVersion;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersionStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersionStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof InternalApiserverV1alpha1ApireplaceStorageVersionStatus
     */
    fieldManager?: string;
}
export declare class ObjectInternalApiserverV1alpha1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: InternalApiserverV1alpha1ApiRequestFactory, responseProcessor?: InternalApiserverV1alpha1ApiResponseProcessor);
    /**
     * create a StorageVersion
     * @param param the request object
     */
    createStorageVersion(param: InternalApiserverV1alpha1ApiCreateStorageVersionRequest, options?: Configuration): Promise<V1alpha1StorageVersion>;
    /**
     * delete collection of StorageVersion
     * @param param the request object
     */
    deleteCollectionStorageVersion(param?: InternalApiserverV1alpha1ApiDeleteCollectionStorageVersionRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a StorageVersion
     * @param param the request object
     */
    deleteStorageVersion(param: InternalApiserverV1alpha1ApiDeleteStorageVersionRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: InternalApiserverV1alpha1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind StorageVersion
     * @param param the request object
     */
    listStorageVersion(param?: InternalApiserverV1alpha1ApiListStorageVersionRequest, options?: Configuration): Promise<V1alpha1StorageVersionList>;
    /**
     * partially update the specified StorageVersion
     * @param param the request object
     */
    patchStorageVersion(param: InternalApiserverV1alpha1ApiPatchStorageVersionRequest, options?: Configuration): Promise<V1alpha1StorageVersion>;
    /**
     * partially update status of the specified StorageVersion
     * @param param the request object
     */
    patchStorageVersionStatus(param: InternalApiserverV1alpha1ApiPatchStorageVersionStatusRequest, options?: Configuration): Promise<V1alpha1StorageVersion>;
    /**
     * read the specified StorageVersion
     * @param param the request object
     */
    readStorageVersion(param: InternalApiserverV1alpha1ApiReadStorageVersionRequest, options?: Configuration): Promise<V1alpha1StorageVersion>;
    /**
     * read status of the specified StorageVersion
     * @param param the request object
     */
    readStorageVersionStatus(param: InternalApiserverV1alpha1ApiReadStorageVersionStatusRequest, options?: Configuration): Promise<V1alpha1StorageVersion>;
    /**
     * replace the specified StorageVersion
     * @param param the request object
     */
    replaceStorageVersion(param: InternalApiserverV1alpha1ApiReplaceStorageVersionRequest, options?: Configuration): Promise<V1alpha1StorageVersion>;
    /**
     * replace status of the specified StorageVersion
     * @param param the request object
     */
    replaceStorageVersionStatus(param: InternalApiserverV1alpha1ApiReplaceStorageVersionStatusRequest, options?: Configuration): Promise<V1alpha1StorageVersion>;
}
import { LogsApiRequestFactory, LogsApiResponseProcessor } from "../apis/LogsApi";
export interface LogsApiLogFileHandlerRequest {
    /**
     * path to the log
     * @type string
     * @memberof LogsApilogFileHandler
     */
    logpath: string;
}
export interface LogsApiLogFileListHandlerRequest {
}
export declare class ObjectLogsApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: LogsApiRequestFactory, responseProcessor?: LogsApiResponseProcessor);
    /**
     * @param param the request object
     */
    logFileHandler(param: LogsApiLogFileHandlerRequest, options?: Configuration): Promise<void>;
    /**
     * @param param the request object
     */
    logFileListHandler(param?: LogsApiLogFileListHandlerRequest, options?: Configuration): Promise<void>;
}
import { NetworkingApiRequestFactory, NetworkingApiResponseProcessor } from "../apis/NetworkingApi";
export interface NetworkingApiGetAPIGroupRequest {
}
export declare class ObjectNetworkingApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: NetworkingApiRequestFactory, responseProcessor?: NetworkingApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: NetworkingApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { NetworkingV1ApiRequestFactory, NetworkingV1ApiResponseProcessor } from "../apis/NetworkingV1Api";
export interface NetworkingV1ApiCreateIngressClassRequest {
    /**
     *
     * @type V1IngressClass
     * @memberof NetworkingV1ApicreateIngressClass
     */
    body: V1IngressClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApicreateIngressClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApicreateIngressClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NetworkingV1ApicreateIngressClass
     */
    fieldManager?: string;
}
export interface NetworkingV1ApiCreateNamespacedIngressRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedIngress
     */
    namespace: string;
    /**
     *
     * @type V1Ingress
     * @memberof NetworkingV1ApicreateNamespacedIngress
     */
    body: V1Ingress;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedIngress
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedIngress
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedIngress
     */
    fieldManager?: string;
}
export interface NetworkingV1ApiCreateNamespacedNetworkPolicyRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedNetworkPolicy
     */
    namespace: string;
    /**
     *
     * @type V1NetworkPolicy
     * @memberof NetworkingV1ApicreateNamespacedNetworkPolicy
     */
    body: V1NetworkPolicy;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedNetworkPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedNetworkPolicy
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NetworkingV1ApicreateNamespacedNetworkPolicy
     */
    fieldManager?: string;
}
export interface NetworkingV1ApiDeleteCollectionIngressClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NetworkingV1ApideleteCollectionIngressClass
     */
    body?: V1DeleteOptions;
}
export interface NetworkingV1ApiDeleteCollectionNamespacedIngressRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NetworkingV1ApideleteCollectionNamespacedIngress
     */
    body?: V1DeleteOptions;
}
export interface NetworkingV1ApiDeleteCollectionNamespacedNetworkPolicyRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NetworkingV1ApideleteCollectionNamespacedNetworkPolicy
     */
    body?: V1DeleteOptions;
}
export interface NetworkingV1ApiDeleteIngressClassRequest {
    /**
     * name of the IngressClass
     * @type string
     * @memberof NetworkingV1ApideleteIngressClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApideleteIngressClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApideleteIngressClass
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NetworkingV1ApideleteIngressClass
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NetworkingV1ApideleteIngressClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NetworkingV1ApideleteIngressClass
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NetworkingV1ApideleteIngressClass
     */
    body?: V1DeleteOptions;
}
export interface NetworkingV1ApiDeleteNamespacedIngressRequest {
    /**
     * name of the Ingress
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NetworkingV1ApideleteNamespacedIngress
     */
    body?: V1DeleteOptions;
}
export interface NetworkingV1ApiDeleteNamespacedNetworkPolicyRequest {
    /**
     * name of the NetworkPolicy
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NetworkingV1ApideleteNamespacedNetworkPolicy
     */
    body?: V1DeleteOptions;
}
export interface NetworkingV1ApiGetAPIResourcesRequest {
}
export interface NetworkingV1ApiListIngressClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApilistIngressClass
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NetworkingV1ApilistIngressClass
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApilistIngressClass
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistIngressClass
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistIngressClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApilistIngressClass
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistIngressClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistIngressClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApilistIngressClass
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NetworkingV1ApilistIngressClass
     */
    watch?: boolean;
}
export interface NetworkingV1ApiListIngressForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NetworkingV1ApilistIngressForAllNamespaces
     */
    watch?: boolean;
}
export interface NetworkingV1ApiListNamespacedIngressRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NetworkingV1ApilistNamespacedIngress
     */
    watch?: boolean;
}
export interface NetworkingV1ApiListNamespacedNetworkPolicyRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NetworkingV1ApilistNamespacedNetworkPolicy
     */
    watch?: boolean;
}
export interface NetworkingV1ApiListNetworkPolicyForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NetworkingV1ApilistNetworkPolicyForAllNamespaces
     */
    watch?: boolean;
}
export interface NetworkingV1ApiPatchIngressClassRequest {
    /**
     * name of the IngressClass
     * @type string
     * @memberof NetworkingV1ApipatchIngressClass
     */
    name: string;
    /**
     *
     * @type any
     * @memberof NetworkingV1ApipatchIngressClass
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApipatchIngressClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApipatchIngressClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof NetworkingV1ApipatchIngressClass
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof NetworkingV1ApipatchIngressClass
     */
    force?: boolean;
}
export interface NetworkingV1ApiPatchNamespacedIngressRequest {
    /**
     * name of the Ingress
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngress
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngress
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof NetworkingV1ApipatchNamespacedIngress
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngress
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngress
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngress
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof NetworkingV1ApipatchNamespacedIngress
     */
    force?: boolean;
}
export interface NetworkingV1ApiPatchNamespacedIngressStatusRequest {
    /**
     * name of the Ingress
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngressStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngressStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof NetworkingV1ApipatchNamespacedIngressStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngressStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngressStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedIngressStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof NetworkingV1ApipatchNamespacedIngressStatus
     */
    force?: boolean;
}
export interface NetworkingV1ApiPatchNamespacedNetworkPolicyRequest {
    /**
     * name of the NetworkPolicy
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedNetworkPolicy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedNetworkPolicy
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof NetworkingV1ApipatchNamespacedNetworkPolicy
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedNetworkPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedNetworkPolicy
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof NetworkingV1ApipatchNamespacedNetworkPolicy
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof NetworkingV1ApipatchNamespacedNetworkPolicy
     */
    force?: boolean;
}
export interface NetworkingV1ApiReadIngressClassRequest {
    /**
     * name of the IngressClass
     * @type string
     * @memberof NetworkingV1ApireadIngressClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireadIngressClass
     */
    pretty?: string;
}
export interface NetworkingV1ApiReadNamespacedIngressRequest {
    /**
     * name of the Ingress
     * @type string
     * @memberof NetworkingV1ApireadNamespacedIngress
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApireadNamespacedIngress
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireadNamespacedIngress
     */
    pretty?: string;
}
export interface NetworkingV1ApiReadNamespacedIngressStatusRequest {
    /**
     * name of the Ingress
     * @type string
     * @memberof NetworkingV1ApireadNamespacedIngressStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApireadNamespacedIngressStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireadNamespacedIngressStatus
     */
    pretty?: string;
}
export interface NetworkingV1ApiReadNamespacedNetworkPolicyRequest {
    /**
     * name of the NetworkPolicy
     * @type string
     * @memberof NetworkingV1ApireadNamespacedNetworkPolicy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApireadNamespacedNetworkPolicy
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireadNamespacedNetworkPolicy
     */
    pretty?: string;
}
export interface NetworkingV1ApiReplaceIngressClassRequest {
    /**
     * name of the IngressClass
     * @type string
     * @memberof NetworkingV1ApireplaceIngressClass
     */
    name: string;
    /**
     *
     * @type V1IngressClass
     * @memberof NetworkingV1ApireplaceIngressClass
     */
    body: V1IngressClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireplaceIngressClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApireplaceIngressClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NetworkingV1ApireplaceIngressClass
     */
    fieldManager?: string;
}
export interface NetworkingV1ApiReplaceNamespacedIngressRequest {
    /**
     * name of the Ingress
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngress
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngress
     */
    namespace: string;
    /**
     *
     * @type V1Ingress
     * @memberof NetworkingV1ApireplaceNamespacedIngress
     */
    body: V1Ingress;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngress
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngress
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngress
     */
    fieldManager?: string;
}
export interface NetworkingV1ApiReplaceNamespacedIngressStatusRequest {
    /**
     * name of the Ingress
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngressStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngressStatus
     */
    namespace: string;
    /**
     *
     * @type V1Ingress
     * @memberof NetworkingV1ApireplaceNamespacedIngressStatus
     */
    body: V1Ingress;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngressStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngressStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedIngressStatus
     */
    fieldManager?: string;
}
export interface NetworkingV1ApiReplaceNamespacedNetworkPolicyRequest {
    /**
     * name of the NetworkPolicy
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedNetworkPolicy
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedNetworkPolicy
     */
    namespace: string;
    /**
     *
     * @type V1NetworkPolicy
     * @memberof NetworkingV1ApireplaceNamespacedNetworkPolicy
     */
    body: V1NetworkPolicy;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedNetworkPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedNetworkPolicy
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NetworkingV1ApireplaceNamespacedNetworkPolicy
     */
    fieldManager?: string;
}
export declare class ObjectNetworkingV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: NetworkingV1ApiRequestFactory, responseProcessor?: NetworkingV1ApiResponseProcessor);
    /**
     * create an IngressClass
     * @param param the request object
     */
    createIngressClass(param: NetworkingV1ApiCreateIngressClassRequest, options?: Configuration): Promise<V1IngressClass>;
    /**
     * create an Ingress
     * @param param the request object
     */
    createNamespacedIngress(param: NetworkingV1ApiCreateNamespacedIngressRequest, options?: Configuration): Promise<V1Ingress>;
    /**
     * create a NetworkPolicy
     * @param param the request object
     */
    createNamespacedNetworkPolicy(param: NetworkingV1ApiCreateNamespacedNetworkPolicyRequest, options?: Configuration): Promise<V1NetworkPolicy>;
    /**
     * delete collection of IngressClass
     * @param param the request object
     */
    deleteCollectionIngressClass(param?: NetworkingV1ApiDeleteCollectionIngressClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Ingress
     * @param param the request object
     */
    deleteCollectionNamespacedIngress(param: NetworkingV1ApiDeleteCollectionNamespacedIngressRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of NetworkPolicy
     * @param param the request object
     */
    deleteCollectionNamespacedNetworkPolicy(param: NetworkingV1ApiDeleteCollectionNamespacedNetworkPolicyRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete an IngressClass
     * @param param the request object
     */
    deleteIngressClass(param: NetworkingV1ApiDeleteIngressClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete an Ingress
     * @param param the request object
     */
    deleteNamespacedIngress(param: NetworkingV1ApiDeleteNamespacedIngressRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a NetworkPolicy
     * @param param the request object
     */
    deleteNamespacedNetworkPolicy(param: NetworkingV1ApiDeleteNamespacedNetworkPolicyRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: NetworkingV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind IngressClass
     * @param param the request object
     */
    listIngressClass(param?: NetworkingV1ApiListIngressClassRequest, options?: Configuration): Promise<V1IngressClassList>;
    /**
     * list or watch objects of kind Ingress
     * @param param the request object
     */
    listIngressForAllNamespaces(param?: NetworkingV1ApiListIngressForAllNamespacesRequest, options?: Configuration): Promise<V1IngressList>;
    /**
     * list or watch objects of kind Ingress
     * @param param the request object
     */
    listNamespacedIngress(param: NetworkingV1ApiListNamespacedIngressRequest, options?: Configuration): Promise<V1IngressList>;
    /**
     * list or watch objects of kind NetworkPolicy
     * @param param the request object
     */
    listNamespacedNetworkPolicy(param: NetworkingV1ApiListNamespacedNetworkPolicyRequest, options?: Configuration): Promise<V1NetworkPolicyList>;
    /**
     * list or watch objects of kind NetworkPolicy
     * @param param the request object
     */
    listNetworkPolicyForAllNamespaces(param?: NetworkingV1ApiListNetworkPolicyForAllNamespacesRequest, options?: Configuration): Promise<V1NetworkPolicyList>;
    /**
     * partially update the specified IngressClass
     * @param param the request object
     */
    patchIngressClass(param: NetworkingV1ApiPatchIngressClassRequest, options?: Configuration): Promise<V1IngressClass>;
    /**
     * partially update the specified Ingress
     * @param param the request object
     */
    patchNamespacedIngress(param: NetworkingV1ApiPatchNamespacedIngressRequest, options?: Configuration): Promise<V1Ingress>;
    /**
     * partially update status of the specified Ingress
     * @param param the request object
     */
    patchNamespacedIngressStatus(param: NetworkingV1ApiPatchNamespacedIngressStatusRequest, options?: Configuration): Promise<V1Ingress>;
    /**
     * partially update the specified NetworkPolicy
     * @param param the request object
     */
    patchNamespacedNetworkPolicy(param: NetworkingV1ApiPatchNamespacedNetworkPolicyRequest, options?: Configuration): Promise<V1NetworkPolicy>;
    /**
     * read the specified IngressClass
     * @param param the request object
     */
    readIngressClass(param: NetworkingV1ApiReadIngressClassRequest, options?: Configuration): Promise<V1IngressClass>;
    /**
     * read the specified Ingress
     * @param param the request object
     */
    readNamespacedIngress(param: NetworkingV1ApiReadNamespacedIngressRequest, options?: Configuration): Promise<V1Ingress>;
    /**
     * read status of the specified Ingress
     * @param param the request object
     */
    readNamespacedIngressStatus(param: NetworkingV1ApiReadNamespacedIngressStatusRequest, options?: Configuration): Promise<V1Ingress>;
    /**
     * read the specified NetworkPolicy
     * @param param the request object
     */
    readNamespacedNetworkPolicy(param: NetworkingV1ApiReadNamespacedNetworkPolicyRequest, options?: Configuration): Promise<V1NetworkPolicy>;
    /**
     * replace the specified IngressClass
     * @param param the request object
     */
    replaceIngressClass(param: NetworkingV1ApiReplaceIngressClassRequest, options?: Configuration): Promise<V1IngressClass>;
    /**
     * replace the specified Ingress
     * @param param the request object
     */
    replaceNamespacedIngress(param: NetworkingV1ApiReplaceNamespacedIngressRequest, options?: Configuration): Promise<V1Ingress>;
    /**
     * replace status of the specified Ingress
     * @param param the request object
     */
    replaceNamespacedIngressStatus(param: NetworkingV1ApiReplaceNamespacedIngressStatusRequest, options?: Configuration): Promise<V1Ingress>;
    /**
     * replace the specified NetworkPolicy
     * @param param the request object
     */
    replaceNamespacedNetworkPolicy(param: NetworkingV1ApiReplaceNamespacedNetworkPolicyRequest, options?: Configuration): Promise<V1NetworkPolicy>;
}
import { NodeApiRequestFactory, NodeApiResponseProcessor } from "../apis/NodeApi";
export interface NodeApiGetAPIGroupRequest {
}
export declare class ObjectNodeApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: NodeApiRequestFactory, responseProcessor?: NodeApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: NodeApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { NodeV1ApiRequestFactory, NodeV1ApiResponseProcessor } from "../apis/NodeV1Api";
export interface NodeV1ApiCreateRuntimeClassRequest {
    /**
     *
     * @type V1RuntimeClass
     * @memberof NodeV1ApicreateRuntimeClass
     */
    body: V1RuntimeClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1ApicreateRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1ApicreateRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NodeV1ApicreateRuntimeClass
     */
    fieldManager?: string;
}
export interface NodeV1ApiDeleteCollectionRuntimeClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NodeV1ApideleteCollectionRuntimeClass
     */
    body?: V1DeleteOptions;
}
export interface NodeV1ApiDeleteRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1ApideleteRuntimeClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1ApideleteRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1ApideleteRuntimeClass
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NodeV1ApideleteRuntimeClass
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NodeV1ApideleteRuntimeClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NodeV1ApideleteRuntimeClass
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NodeV1ApideleteRuntimeClass
     */
    body?: V1DeleteOptions;
}
export interface NodeV1ApiGetAPIResourcesRequest {
}
export interface NodeV1ApiListRuntimeClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1ApilistRuntimeClass
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NodeV1ApilistRuntimeClass
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NodeV1ApilistRuntimeClass
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NodeV1ApilistRuntimeClass
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NodeV1ApilistRuntimeClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NodeV1ApilistRuntimeClass
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1ApilistRuntimeClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1ApilistRuntimeClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NodeV1ApilistRuntimeClass
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NodeV1ApilistRuntimeClass
     */
    watch?: boolean;
}
export interface NodeV1ApiPatchRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1ApipatchRuntimeClass
     */
    name: string;
    /**
     *
     * @type any
     * @memberof NodeV1ApipatchRuntimeClass
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1ApipatchRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1ApipatchRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof NodeV1ApipatchRuntimeClass
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof NodeV1ApipatchRuntimeClass
     */
    force?: boolean;
}
export interface NodeV1ApiReadRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1ApireadRuntimeClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1ApireadRuntimeClass
     */
    pretty?: string;
}
export interface NodeV1ApiReplaceRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1ApireplaceRuntimeClass
     */
    name: string;
    /**
     *
     * @type V1RuntimeClass
     * @memberof NodeV1ApireplaceRuntimeClass
     */
    body: V1RuntimeClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1ApireplaceRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1ApireplaceRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NodeV1ApireplaceRuntimeClass
     */
    fieldManager?: string;
}
export declare class ObjectNodeV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: NodeV1ApiRequestFactory, responseProcessor?: NodeV1ApiResponseProcessor);
    /**
     * create a RuntimeClass
     * @param param the request object
     */
    createRuntimeClass(param: NodeV1ApiCreateRuntimeClassRequest, options?: Configuration): Promise<V1RuntimeClass>;
    /**
     * delete collection of RuntimeClass
     * @param param the request object
     */
    deleteCollectionRuntimeClass(param?: NodeV1ApiDeleteCollectionRuntimeClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a RuntimeClass
     * @param param the request object
     */
    deleteRuntimeClass(param: NodeV1ApiDeleteRuntimeClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: NodeV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind RuntimeClass
     * @param param the request object
     */
    listRuntimeClass(param?: NodeV1ApiListRuntimeClassRequest, options?: Configuration): Promise<V1RuntimeClassList>;
    /**
     * partially update the specified RuntimeClass
     * @param param the request object
     */
    patchRuntimeClass(param: NodeV1ApiPatchRuntimeClassRequest, options?: Configuration): Promise<V1RuntimeClass>;
    /**
     * read the specified RuntimeClass
     * @param param the request object
     */
    readRuntimeClass(param: NodeV1ApiReadRuntimeClassRequest, options?: Configuration): Promise<V1RuntimeClass>;
    /**
     * replace the specified RuntimeClass
     * @param param the request object
     */
    replaceRuntimeClass(param: NodeV1ApiReplaceRuntimeClassRequest, options?: Configuration): Promise<V1RuntimeClass>;
}
import { NodeV1alpha1ApiRequestFactory, NodeV1alpha1ApiResponseProcessor } from "../apis/NodeV1alpha1Api";
export interface NodeV1alpha1ApiCreateRuntimeClassRequest {
    /**
     *
     * @type V1alpha1RuntimeClass
     * @memberof NodeV1alpha1ApicreateRuntimeClass
     */
    body: V1alpha1RuntimeClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1alpha1ApicreateRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1alpha1ApicreateRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NodeV1alpha1ApicreateRuntimeClass
     */
    fieldManager?: string;
}
export interface NodeV1alpha1ApiDeleteCollectionRuntimeClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NodeV1alpha1ApideleteCollectionRuntimeClass
     */
    body?: V1DeleteOptions;
}
export interface NodeV1alpha1ApiDeleteRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1alpha1ApideleteRuntimeClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1alpha1ApideleteRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1alpha1ApideleteRuntimeClass
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NodeV1alpha1ApideleteRuntimeClass
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NodeV1alpha1ApideleteRuntimeClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NodeV1alpha1ApideleteRuntimeClass
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NodeV1alpha1ApideleteRuntimeClass
     */
    body?: V1DeleteOptions;
}
export interface NodeV1alpha1ApiGetAPIResourcesRequest {
}
export interface NodeV1alpha1ApiListRuntimeClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NodeV1alpha1ApilistRuntimeClass
     */
    watch?: boolean;
}
export interface NodeV1alpha1ApiPatchRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1alpha1ApipatchRuntimeClass
     */
    name: string;
    /**
     *
     * @type any
     * @memberof NodeV1alpha1ApipatchRuntimeClass
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1alpha1ApipatchRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1alpha1ApipatchRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof NodeV1alpha1ApipatchRuntimeClass
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof NodeV1alpha1ApipatchRuntimeClass
     */
    force?: boolean;
}
export interface NodeV1alpha1ApiReadRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1alpha1ApireadRuntimeClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1alpha1ApireadRuntimeClass
     */
    pretty?: string;
}
export interface NodeV1alpha1ApiReplaceRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1alpha1ApireplaceRuntimeClass
     */
    name: string;
    /**
     *
     * @type V1alpha1RuntimeClass
     * @memberof NodeV1alpha1ApireplaceRuntimeClass
     */
    body: V1alpha1RuntimeClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1alpha1ApireplaceRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1alpha1ApireplaceRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NodeV1alpha1ApireplaceRuntimeClass
     */
    fieldManager?: string;
}
export declare class ObjectNodeV1alpha1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: NodeV1alpha1ApiRequestFactory, responseProcessor?: NodeV1alpha1ApiResponseProcessor);
    /**
     * create a RuntimeClass
     * @param param the request object
     */
    createRuntimeClass(param: NodeV1alpha1ApiCreateRuntimeClassRequest, options?: Configuration): Promise<V1alpha1RuntimeClass>;
    /**
     * delete collection of RuntimeClass
     * @param param the request object
     */
    deleteCollectionRuntimeClass(param?: NodeV1alpha1ApiDeleteCollectionRuntimeClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a RuntimeClass
     * @param param the request object
     */
    deleteRuntimeClass(param: NodeV1alpha1ApiDeleteRuntimeClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: NodeV1alpha1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind RuntimeClass
     * @param param the request object
     */
    listRuntimeClass(param?: NodeV1alpha1ApiListRuntimeClassRequest, options?: Configuration): Promise<V1alpha1RuntimeClassList>;
    /**
     * partially update the specified RuntimeClass
     * @param param the request object
     */
    patchRuntimeClass(param: NodeV1alpha1ApiPatchRuntimeClassRequest, options?: Configuration): Promise<V1alpha1RuntimeClass>;
    /**
     * read the specified RuntimeClass
     * @param param the request object
     */
    readRuntimeClass(param: NodeV1alpha1ApiReadRuntimeClassRequest, options?: Configuration): Promise<V1alpha1RuntimeClass>;
    /**
     * replace the specified RuntimeClass
     * @param param the request object
     */
    replaceRuntimeClass(param: NodeV1alpha1ApiReplaceRuntimeClassRequest, options?: Configuration): Promise<V1alpha1RuntimeClass>;
}
import { NodeV1beta1ApiRequestFactory, NodeV1beta1ApiResponseProcessor } from "../apis/NodeV1beta1Api";
export interface NodeV1beta1ApiCreateRuntimeClassRequest {
    /**
     *
     * @type V1beta1RuntimeClass
     * @memberof NodeV1beta1ApicreateRuntimeClass
     */
    body: V1beta1RuntimeClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1beta1ApicreateRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1beta1ApicreateRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NodeV1beta1ApicreateRuntimeClass
     */
    fieldManager?: string;
}
export interface NodeV1beta1ApiDeleteCollectionRuntimeClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NodeV1beta1ApideleteCollectionRuntimeClass
     */
    body?: V1DeleteOptions;
}
export interface NodeV1beta1ApiDeleteRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1beta1ApideleteRuntimeClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1beta1ApideleteRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1beta1ApideleteRuntimeClass
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof NodeV1beta1ApideleteRuntimeClass
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof NodeV1beta1ApideleteRuntimeClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof NodeV1beta1ApideleteRuntimeClass
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof NodeV1beta1ApideleteRuntimeClass
     */
    body?: V1DeleteOptions;
}
export interface NodeV1beta1ApiGetAPIResourcesRequest {
}
export interface NodeV1beta1ApiListRuntimeClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof NodeV1beta1ApilistRuntimeClass
     */
    watch?: boolean;
}
export interface NodeV1beta1ApiPatchRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1beta1ApipatchRuntimeClass
     */
    name: string;
    /**
     *
     * @type any
     * @memberof NodeV1beta1ApipatchRuntimeClass
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1beta1ApipatchRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1beta1ApipatchRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof NodeV1beta1ApipatchRuntimeClass
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof NodeV1beta1ApipatchRuntimeClass
     */
    force?: boolean;
}
export interface NodeV1beta1ApiReadRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1beta1ApireadRuntimeClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1beta1ApireadRuntimeClass
     */
    pretty?: string;
}
export interface NodeV1beta1ApiReplaceRuntimeClassRequest {
    /**
     * name of the RuntimeClass
     * @type string
     * @memberof NodeV1beta1ApireplaceRuntimeClass
     */
    name: string;
    /**
     *
     * @type V1beta1RuntimeClass
     * @memberof NodeV1beta1ApireplaceRuntimeClass
     */
    body: V1beta1RuntimeClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof NodeV1beta1ApireplaceRuntimeClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof NodeV1beta1ApireplaceRuntimeClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof NodeV1beta1ApireplaceRuntimeClass
     */
    fieldManager?: string;
}
export declare class ObjectNodeV1beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: NodeV1beta1ApiRequestFactory, responseProcessor?: NodeV1beta1ApiResponseProcessor);
    /**
     * create a RuntimeClass
     * @param param the request object
     */
    createRuntimeClass(param: NodeV1beta1ApiCreateRuntimeClassRequest, options?: Configuration): Promise<V1beta1RuntimeClass>;
    /**
     * delete collection of RuntimeClass
     * @param param the request object
     */
    deleteCollectionRuntimeClass(param?: NodeV1beta1ApiDeleteCollectionRuntimeClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a RuntimeClass
     * @param param the request object
     */
    deleteRuntimeClass(param: NodeV1beta1ApiDeleteRuntimeClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: NodeV1beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind RuntimeClass
     * @param param the request object
     */
    listRuntimeClass(param?: NodeV1beta1ApiListRuntimeClassRequest, options?: Configuration): Promise<V1beta1RuntimeClassList>;
    /**
     * partially update the specified RuntimeClass
     * @param param the request object
     */
    patchRuntimeClass(param: NodeV1beta1ApiPatchRuntimeClassRequest, options?: Configuration): Promise<V1beta1RuntimeClass>;
    /**
     * read the specified RuntimeClass
     * @param param the request object
     */
    readRuntimeClass(param: NodeV1beta1ApiReadRuntimeClassRequest, options?: Configuration): Promise<V1beta1RuntimeClass>;
    /**
     * replace the specified RuntimeClass
     * @param param the request object
     */
    replaceRuntimeClass(param: NodeV1beta1ApiReplaceRuntimeClassRequest, options?: Configuration): Promise<V1beta1RuntimeClass>;
}
import { OpenidApiRequestFactory, OpenidApiResponseProcessor } from "../apis/OpenidApi";
export interface OpenidApiGetServiceAccountIssuerOpenIDKeysetRequest {
}
export declare class ObjectOpenidApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: OpenidApiRequestFactory, responseProcessor?: OpenidApiResponseProcessor);
    /**
     * get service account issuer OpenID JSON Web Key Set (contains public token verification keys)
     * @param param the request object
     */
    getServiceAccountIssuerOpenIDKeyset(param?: OpenidApiGetServiceAccountIssuerOpenIDKeysetRequest, options?: Configuration): Promise<string>;
}
import { PolicyApiRequestFactory, PolicyApiResponseProcessor } from "../apis/PolicyApi";
export interface PolicyApiGetAPIGroupRequest {
}
export declare class ObjectPolicyApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: PolicyApiRequestFactory, responseProcessor?: PolicyApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: PolicyApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { PolicyV1ApiRequestFactory, PolicyV1ApiResponseProcessor } from "../apis/PolicyV1Api";
export interface PolicyV1ApiCreateNamespacedPodDisruptionBudgetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApicreateNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     *
     * @type V1PodDisruptionBudget
     * @memberof PolicyV1ApicreateNamespacedPodDisruptionBudget
     */
    body: V1PodDisruptionBudget;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApicreateNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1ApicreateNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1ApicreateNamespacedPodDisruptionBudget
     */
    fieldManager?: string;
}
export interface PolicyV1ApiDeleteCollectionNamespacedPodDisruptionBudgetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof PolicyV1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    body?: V1DeleteOptions;
}
export interface PolicyV1ApiDeleteNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof PolicyV1ApideleteNamespacedPodDisruptionBudget
     */
    body?: V1DeleteOptions;
}
export interface PolicyV1ApiGetAPIResourcesRequest {
}
export interface PolicyV1ApiListNamespacedPodDisruptionBudgetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof PolicyV1ApilistNamespacedPodDisruptionBudget
     */
    watch?: boolean;
}
export interface PolicyV1ApiListPodDisruptionBudgetForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof PolicyV1ApilistPodDisruptionBudgetForAllNamespaces
     */
    watch?: boolean;
}
export interface PolicyV1ApiPatchNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudget
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudget
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudget
     */
    force?: boolean;
}
export interface PolicyV1ApiPatchNamespacedPodDisruptionBudgetStatusRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof PolicyV1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    force?: boolean;
}
export interface PolicyV1ApiReadNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1ApireadNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApireadNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApireadNamespacedPodDisruptionBudget
     */
    pretty?: string;
}
export interface PolicyV1ApiReadNamespacedPodDisruptionBudgetStatusRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1ApireadNamespacedPodDisruptionBudgetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApireadNamespacedPodDisruptionBudgetStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApireadNamespacedPodDisruptionBudgetStatus
     */
    pretty?: string;
}
export interface PolicyV1ApiReplaceNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     *
     * @type V1PodDisruptionBudget
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudget
     */
    body: V1PodDisruptionBudget;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudget
     */
    fieldManager?: string;
}
export interface PolicyV1ApiReplaceNamespacedPodDisruptionBudgetStatusRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    namespace: string;
    /**
     *
     * @type V1PodDisruptionBudget
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    body: V1PodDisruptionBudget;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    fieldManager?: string;
}
export declare class ObjectPolicyV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: PolicyV1ApiRequestFactory, responseProcessor?: PolicyV1ApiResponseProcessor);
    /**
     * create a PodDisruptionBudget
     * @param param the request object
     */
    createNamespacedPodDisruptionBudget(param: PolicyV1ApiCreateNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1PodDisruptionBudget>;
    /**
     * delete collection of PodDisruptionBudget
     * @param param the request object
     */
    deleteCollectionNamespacedPodDisruptionBudget(param: PolicyV1ApiDeleteCollectionNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PodDisruptionBudget
     * @param param the request object
     */
    deleteNamespacedPodDisruptionBudget(param: PolicyV1ApiDeleteNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: PolicyV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind PodDisruptionBudget
     * @param param the request object
     */
    listNamespacedPodDisruptionBudget(param: PolicyV1ApiListNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1PodDisruptionBudgetList>;
    /**
     * list or watch objects of kind PodDisruptionBudget
     * @param param the request object
     */
    listPodDisruptionBudgetForAllNamespaces(param?: PolicyV1ApiListPodDisruptionBudgetForAllNamespacesRequest, options?: Configuration): Promise<V1PodDisruptionBudgetList>;
    /**
     * partially update the specified PodDisruptionBudget
     * @param param the request object
     */
    patchNamespacedPodDisruptionBudget(param: PolicyV1ApiPatchNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1PodDisruptionBudget>;
    /**
     * partially update status of the specified PodDisruptionBudget
     * @param param the request object
     */
    patchNamespacedPodDisruptionBudgetStatus(param: PolicyV1ApiPatchNamespacedPodDisruptionBudgetStatusRequest, options?: Configuration): Promise<V1PodDisruptionBudget>;
    /**
     * read the specified PodDisruptionBudget
     * @param param the request object
     */
    readNamespacedPodDisruptionBudget(param: PolicyV1ApiReadNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1PodDisruptionBudget>;
    /**
     * read status of the specified PodDisruptionBudget
     * @param param the request object
     */
    readNamespacedPodDisruptionBudgetStatus(param: PolicyV1ApiReadNamespacedPodDisruptionBudgetStatusRequest, options?: Configuration): Promise<V1PodDisruptionBudget>;
    /**
     * replace the specified PodDisruptionBudget
     * @param param the request object
     */
    replaceNamespacedPodDisruptionBudget(param: PolicyV1ApiReplaceNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1PodDisruptionBudget>;
    /**
     * replace status of the specified PodDisruptionBudget
     * @param param the request object
     */
    replaceNamespacedPodDisruptionBudgetStatus(param: PolicyV1ApiReplaceNamespacedPodDisruptionBudgetStatusRequest, options?: Configuration): Promise<V1PodDisruptionBudget>;
}
import { PolicyV1beta1ApiRequestFactory, PolicyV1beta1ApiResponseProcessor } from "../apis/PolicyV1beta1Api";
export interface PolicyV1beta1ApiCreateNamespacedPodDisruptionBudgetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApicreateNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     *
     * @type V1beta1PodDisruptionBudget
     * @memberof PolicyV1beta1ApicreateNamespacedPodDisruptionBudget
     */
    body: V1beta1PodDisruptionBudget;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApicreateNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApicreateNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1beta1ApicreateNamespacedPodDisruptionBudget
     */
    fieldManager?: string;
}
export interface PolicyV1beta1ApiCreatePodSecurityPolicyRequest {
    /**
     *
     * @type V1beta1PodSecurityPolicy
     * @memberof PolicyV1beta1ApicreatePodSecurityPolicy
     */
    body: V1beta1PodSecurityPolicy;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApicreatePodSecurityPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApicreatePodSecurityPolicy
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1beta1ApicreatePodSecurityPolicy
     */
    fieldManager?: string;
}
export interface PolicyV1beta1ApiDeleteCollectionNamespacedPodDisruptionBudgetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof PolicyV1beta1ApideleteCollectionNamespacedPodDisruptionBudget
     */
    body?: V1DeleteOptions;
}
export interface PolicyV1beta1ApiDeleteCollectionPodSecurityPolicyRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof PolicyV1beta1ApideleteCollectionPodSecurityPolicy
     */
    body?: V1DeleteOptions;
}
export interface PolicyV1beta1ApiDeleteNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof PolicyV1beta1ApideleteNamespacedPodDisruptionBudget
     */
    body?: V1DeleteOptions;
}
export interface PolicyV1beta1ApiDeletePodSecurityPolicyRequest {
    /**
     * name of the PodSecurityPolicy
     * @type string
     * @memberof PolicyV1beta1ApideletePodSecurityPolicy
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApideletePodSecurityPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApideletePodSecurityPolicy
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof PolicyV1beta1ApideletePodSecurityPolicy
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof PolicyV1beta1ApideletePodSecurityPolicy
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof PolicyV1beta1ApideletePodSecurityPolicy
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof PolicyV1beta1ApideletePodSecurityPolicy
     */
    body?: V1DeleteOptions;
}
export interface PolicyV1beta1ApiGetAPIResourcesRequest {
}
export interface PolicyV1beta1ApiListNamespacedPodDisruptionBudgetRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof PolicyV1beta1ApilistNamespacedPodDisruptionBudget
     */
    watch?: boolean;
}
export interface PolicyV1beta1ApiListPodDisruptionBudgetForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof PolicyV1beta1ApilistPodDisruptionBudgetForAllNamespaces
     */
    watch?: boolean;
}
export interface PolicyV1beta1ApiListPodSecurityPolicyRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof PolicyV1beta1ApilistPodSecurityPolicy
     */
    watch?: boolean;
}
export interface PolicyV1beta1ApiPatchNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudget
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudget
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudget
     */
    force?: boolean;
}
export interface PolicyV1beta1ApiPatchNamespacedPodDisruptionBudgetStatusRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof PolicyV1beta1ApipatchNamespacedPodDisruptionBudgetStatus
     */
    force?: boolean;
}
export interface PolicyV1beta1ApiPatchPodSecurityPolicyRequest {
    /**
     * name of the PodSecurityPolicy
     * @type string
     * @memberof PolicyV1beta1ApipatchPodSecurityPolicy
     */
    name: string;
    /**
     *
     * @type any
     * @memberof PolicyV1beta1ApipatchPodSecurityPolicy
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApipatchPodSecurityPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApipatchPodSecurityPolicy
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof PolicyV1beta1ApipatchPodSecurityPolicy
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof PolicyV1beta1ApipatchPodSecurityPolicy
     */
    force?: boolean;
}
export interface PolicyV1beta1ApiReadNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1beta1ApireadNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApireadNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApireadNamespacedPodDisruptionBudget
     */
    pretty?: string;
}
export interface PolicyV1beta1ApiReadNamespacedPodDisruptionBudgetStatusRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1beta1ApireadNamespacedPodDisruptionBudgetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApireadNamespacedPodDisruptionBudgetStatus
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApireadNamespacedPodDisruptionBudgetStatus
     */
    pretty?: string;
}
export interface PolicyV1beta1ApiReadPodSecurityPolicyRequest {
    /**
     * name of the PodSecurityPolicy
     * @type string
     * @memberof PolicyV1beta1ApireadPodSecurityPolicy
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApireadPodSecurityPolicy
     */
    pretty?: string;
}
export interface PolicyV1beta1ApiReplaceNamespacedPodDisruptionBudgetRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudget
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudget
     */
    namespace: string;
    /**
     *
     * @type V1beta1PodDisruptionBudget
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudget
     */
    body: V1beta1PodDisruptionBudget;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudget
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudget
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudget
     */
    fieldManager?: string;
}
export interface PolicyV1beta1ApiReplaceNamespacedPodDisruptionBudgetStatusRequest {
    /**
     * name of the PodDisruptionBudget
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    namespace: string;
    /**
     *
     * @type V1beta1PodDisruptionBudget
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    body: V1beta1PodDisruptionBudget;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1beta1ApireplaceNamespacedPodDisruptionBudgetStatus
     */
    fieldManager?: string;
}
export interface PolicyV1beta1ApiReplacePodSecurityPolicyRequest {
    /**
     * name of the PodSecurityPolicy
     * @type string
     * @memberof PolicyV1beta1ApireplacePodSecurityPolicy
     */
    name: string;
    /**
     *
     * @type V1beta1PodSecurityPolicy
     * @memberof PolicyV1beta1ApireplacePodSecurityPolicy
     */
    body: V1beta1PodSecurityPolicy;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof PolicyV1beta1ApireplacePodSecurityPolicy
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof PolicyV1beta1ApireplacePodSecurityPolicy
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof PolicyV1beta1ApireplacePodSecurityPolicy
     */
    fieldManager?: string;
}
export declare class ObjectPolicyV1beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: PolicyV1beta1ApiRequestFactory, responseProcessor?: PolicyV1beta1ApiResponseProcessor);
    /**
     * create a PodDisruptionBudget
     * @param param the request object
     */
    createNamespacedPodDisruptionBudget(param: PolicyV1beta1ApiCreateNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudget>;
    /**
     * create a PodSecurityPolicy
     * @param param the request object
     */
    createPodSecurityPolicy(param: PolicyV1beta1ApiCreatePodSecurityPolicyRequest, options?: Configuration): Promise<V1beta1PodSecurityPolicy>;
    /**
     * delete collection of PodDisruptionBudget
     * @param param the request object
     */
    deleteCollectionNamespacedPodDisruptionBudget(param: PolicyV1beta1ApiDeleteCollectionNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of PodSecurityPolicy
     * @param param the request object
     */
    deleteCollectionPodSecurityPolicy(param?: PolicyV1beta1ApiDeleteCollectionPodSecurityPolicyRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PodDisruptionBudget
     * @param param the request object
     */
    deleteNamespacedPodDisruptionBudget(param: PolicyV1beta1ApiDeleteNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PodSecurityPolicy
     * @param param the request object
     */
    deletePodSecurityPolicy(param: PolicyV1beta1ApiDeletePodSecurityPolicyRequest, options?: Configuration): Promise<V1beta1PodSecurityPolicy>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: PolicyV1beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind PodDisruptionBudget
     * @param param the request object
     */
    listNamespacedPodDisruptionBudget(param: PolicyV1beta1ApiListNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudgetList>;
    /**
     * list or watch objects of kind PodDisruptionBudget
     * @param param the request object
     */
    listPodDisruptionBudgetForAllNamespaces(param?: PolicyV1beta1ApiListPodDisruptionBudgetForAllNamespacesRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudgetList>;
    /**
     * list or watch objects of kind PodSecurityPolicy
     * @param param the request object
     */
    listPodSecurityPolicy(param?: PolicyV1beta1ApiListPodSecurityPolicyRequest, options?: Configuration): Promise<V1beta1PodSecurityPolicyList>;
    /**
     * partially update the specified PodDisruptionBudget
     * @param param the request object
     */
    patchNamespacedPodDisruptionBudget(param: PolicyV1beta1ApiPatchNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudget>;
    /**
     * partially update status of the specified PodDisruptionBudget
     * @param param the request object
     */
    patchNamespacedPodDisruptionBudgetStatus(param: PolicyV1beta1ApiPatchNamespacedPodDisruptionBudgetStatusRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudget>;
    /**
     * partially update the specified PodSecurityPolicy
     * @param param the request object
     */
    patchPodSecurityPolicy(param: PolicyV1beta1ApiPatchPodSecurityPolicyRequest, options?: Configuration): Promise<V1beta1PodSecurityPolicy>;
    /**
     * read the specified PodDisruptionBudget
     * @param param the request object
     */
    readNamespacedPodDisruptionBudget(param: PolicyV1beta1ApiReadNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudget>;
    /**
     * read status of the specified PodDisruptionBudget
     * @param param the request object
     */
    readNamespacedPodDisruptionBudgetStatus(param: PolicyV1beta1ApiReadNamespacedPodDisruptionBudgetStatusRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudget>;
    /**
     * read the specified PodSecurityPolicy
     * @param param the request object
     */
    readPodSecurityPolicy(param: PolicyV1beta1ApiReadPodSecurityPolicyRequest, options?: Configuration): Promise<V1beta1PodSecurityPolicy>;
    /**
     * replace the specified PodDisruptionBudget
     * @param param the request object
     */
    replaceNamespacedPodDisruptionBudget(param: PolicyV1beta1ApiReplaceNamespacedPodDisruptionBudgetRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudget>;
    /**
     * replace status of the specified PodDisruptionBudget
     * @param param the request object
     */
    replaceNamespacedPodDisruptionBudgetStatus(param: PolicyV1beta1ApiReplaceNamespacedPodDisruptionBudgetStatusRequest, options?: Configuration): Promise<V1beta1PodDisruptionBudget>;
    /**
     * replace the specified PodSecurityPolicy
     * @param param the request object
     */
    replacePodSecurityPolicy(param: PolicyV1beta1ApiReplacePodSecurityPolicyRequest, options?: Configuration): Promise<V1beta1PodSecurityPolicy>;
}
import { RbacAuthorizationApiRequestFactory, RbacAuthorizationApiResponseProcessor } from "../apis/RbacAuthorizationApi";
export interface RbacAuthorizationApiGetAPIGroupRequest {
}
export declare class ObjectRbacAuthorizationApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: RbacAuthorizationApiRequestFactory, responseProcessor?: RbacAuthorizationApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: RbacAuthorizationApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { RbacAuthorizationV1ApiRequestFactory, RbacAuthorizationV1ApiResponseProcessor } from "../apis/RbacAuthorizationV1Api";
export interface RbacAuthorizationV1ApiCreateClusterRoleRequest {
    /**
     *
     * @type V1ClusterRole
     * @memberof RbacAuthorizationV1ApicreateClusterRole
     */
    body: V1ClusterRole;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApicreateClusterRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateClusterRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1ApiCreateClusterRoleBindingRequest {
    /**
     *
     * @type V1ClusterRoleBinding
     * @memberof RbacAuthorizationV1ApicreateClusterRoleBinding
     */
    body: V1ClusterRoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApicreateClusterRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateClusterRoleBinding
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1ApiCreateNamespacedRoleRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRole
     */
    namespace: string;
    /**
     *
     * @type V1Role
     * @memberof RbacAuthorizationV1ApicreateNamespacedRole
     */
    body: V1Role;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1ApiCreateNamespacedRoleBindingRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRoleBinding
     */
    namespace: string;
    /**
     *
     * @type V1RoleBinding
     * @memberof RbacAuthorizationV1ApicreateNamespacedRoleBinding
     */
    body: V1RoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApicreateNamespacedRoleBinding
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1ApiDeleteClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRole
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRole
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteClusterRole
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteClusterRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRole
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteClusterRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiDeleteClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRoleBinding
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRoleBinding
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteClusterRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteClusterRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteClusterRoleBinding
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteClusterRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiDeleteCollectionClusterRoleRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiDeleteCollectionClusterRoleBindingRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteCollectionClusterRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiDeleteCollectionNamespacedRoleRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiDeleteCollectionNamespacedRoleBindingRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteCollectionNamespacedRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiDeleteNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteNamespacedRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiDeleteNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1ApideleteNamespacedRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1ApiGetAPIResourcesRequest {
}
export interface RbacAuthorizationV1ApiListClusterRoleRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistClusterRole
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1ApiListClusterRoleBindingRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistClusterRoleBinding
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1ApiListNamespacedRoleRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistNamespacedRole
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1ApiListNamespacedRoleBindingRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistNamespacedRoleBinding
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1ApiListRoleBindingForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistRoleBindingForAllNamespaces
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1ApiListRoleForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1ApilistRoleForAllNamespaces
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1ApiPatchClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRole
     */
    name: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1ApipatchClusterRole
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRole
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1ApipatchClusterRole
     */
    force?: boolean;
}
export interface RbacAuthorizationV1ApiPatchClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRoleBinding
     */
    name: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1ApipatchClusterRoleBinding
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1ApipatchClusterRoleBinding
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1ApipatchClusterRoleBinding
     */
    force?: boolean;
}
export interface RbacAuthorizationV1ApiPatchNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRole
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1ApipatchNamespacedRole
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRole
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1ApipatchNamespacedRole
     */
    force?: boolean;
}
export interface RbacAuthorizationV1ApiPatchNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRoleBinding
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1ApipatchNamespacedRoleBinding
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1ApipatchNamespacedRoleBinding
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1ApipatchNamespacedRoleBinding
     */
    force?: boolean;
}
export interface RbacAuthorizationV1ApiReadClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1ApireadClusterRole
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireadClusterRole
     */
    pretty?: string;
}
export interface RbacAuthorizationV1ApiReadClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApireadClusterRoleBinding
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireadClusterRoleBinding
     */
    pretty?: string;
}
export interface RbacAuthorizationV1ApiReadNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1ApireadNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApireadNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireadNamespacedRole
     */
    pretty?: string;
}
export interface RbacAuthorizationV1ApiReadNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApireadNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApireadNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireadNamespacedRoleBinding
     */
    pretty?: string;
}
export interface RbacAuthorizationV1ApiReplaceClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRole
     */
    name: string;
    /**
     *
     * @type V1ClusterRole
     * @memberof RbacAuthorizationV1ApireplaceClusterRole
     */
    body: V1ClusterRole;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1ApiReplaceClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRoleBinding
     */
    name: string;
    /**
     *
     * @type V1ClusterRoleBinding
     * @memberof RbacAuthorizationV1ApireplaceClusterRoleBinding
     */
    body: V1ClusterRoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceClusterRoleBinding
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1ApiReplaceNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRole
     */
    namespace: string;
    /**
     *
     * @type V1Role
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRole
     */
    body: V1Role;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1ApiReplaceNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRoleBinding
     */
    namespace: string;
    /**
     *
     * @type V1RoleBinding
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRoleBinding
     */
    body: V1RoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1ApireplaceNamespacedRoleBinding
     */
    fieldManager?: string;
}
export declare class ObjectRbacAuthorizationV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: RbacAuthorizationV1ApiRequestFactory, responseProcessor?: RbacAuthorizationV1ApiResponseProcessor);
    /**
     * create a ClusterRole
     * @param param the request object
     */
    createClusterRole(param: RbacAuthorizationV1ApiCreateClusterRoleRequest, options?: Configuration): Promise<V1ClusterRole>;
    /**
     * create a ClusterRoleBinding
     * @param param the request object
     */
    createClusterRoleBinding(param: RbacAuthorizationV1ApiCreateClusterRoleBindingRequest, options?: Configuration): Promise<V1ClusterRoleBinding>;
    /**
     * create a Role
     * @param param the request object
     */
    createNamespacedRole(param: RbacAuthorizationV1ApiCreateNamespacedRoleRequest, options?: Configuration): Promise<V1Role>;
    /**
     * create a RoleBinding
     * @param param the request object
     */
    createNamespacedRoleBinding(param: RbacAuthorizationV1ApiCreateNamespacedRoleBindingRequest, options?: Configuration): Promise<V1RoleBinding>;
    /**
     * delete a ClusterRole
     * @param param the request object
     */
    deleteClusterRole(param: RbacAuthorizationV1ApiDeleteClusterRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ClusterRoleBinding
     * @param param the request object
     */
    deleteClusterRoleBinding(param: RbacAuthorizationV1ApiDeleteClusterRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ClusterRole
     * @param param the request object
     */
    deleteCollectionClusterRole(param?: RbacAuthorizationV1ApiDeleteCollectionClusterRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ClusterRoleBinding
     * @param param the request object
     */
    deleteCollectionClusterRoleBinding(param?: RbacAuthorizationV1ApiDeleteCollectionClusterRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Role
     * @param param the request object
     */
    deleteCollectionNamespacedRole(param: RbacAuthorizationV1ApiDeleteCollectionNamespacedRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of RoleBinding
     * @param param the request object
     */
    deleteCollectionNamespacedRoleBinding(param: RbacAuthorizationV1ApiDeleteCollectionNamespacedRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a Role
     * @param param the request object
     */
    deleteNamespacedRole(param: RbacAuthorizationV1ApiDeleteNamespacedRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a RoleBinding
     * @param param the request object
     */
    deleteNamespacedRoleBinding(param: RbacAuthorizationV1ApiDeleteNamespacedRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: RbacAuthorizationV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind ClusterRole
     * @param param the request object
     */
    listClusterRole(param?: RbacAuthorizationV1ApiListClusterRoleRequest, options?: Configuration): Promise<V1ClusterRoleList>;
    /**
     * list or watch objects of kind ClusterRoleBinding
     * @param param the request object
     */
    listClusterRoleBinding(param?: RbacAuthorizationV1ApiListClusterRoleBindingRequest, options?: Configuration): Promise<V1ClusterRoleBindingList>;
    /**
     * list or watch objects of kind Role
     * @param param the request object
     */
    listNamespacedRole(param: RbacAuthorizationV1ApiListNamespacedRoleRequest, options?: Configuration): Promise<V1RoleList>;
    /**
     * list or watch objects of kind RoleBinding
     * @param param the request object
     */
    listNamespacedRoleBinding(param: RbacAuthorizationV1ApiListNamespacedRoleBindingRequest, options?: Configuration): Promise<V1RoleBindingList>;
    /**
     * list or watch objects of kind RoleBinding
     * @param param the request object
     */
    listRoleBindingForAllNamespaces(param?: RbacAuthorizationV1ApiListRoleBindingForAllNamespacesRequest, options?: Configuration): Promise<V1RoleBindingList>;
    /**
     * list or watch objects of kind Role
     * @param param the request object
     */
    listRoleForAllNamespaces(param?: RbacAuthorizationV1ApiListRoleForAllNamespacesRequest, options?: Configuration): Promise<V1RoleList>;
    /**
     * partially update the specified ClusterRole
     * @param param the request object
     */
    patchClusterRole(param: RbacAuthorizationV1ApiPatchClusterRoleRequest, options?: Configuration): Promise<V1ClusterRole>;
    /**
     * partially update the specified ClusterRoleBinding
     * @param param the request object
     */
    patchClusterRoleBinding(param: RbacAuthorizationV1ApiPatchClusterRoleBindingRequest, options?: Configuration): Promise<V1ClusterRoleBinding>;
    /**
     * partially update the specified Role
     * @param param the request object
     */
    patchNamespacedRole(param: RbacAuthorizationV1ApiPatchNamespacedRoleRequest, options?: Configuration): Promise<V1Role>;
    /**
     * partially update the specified RoleBinding
     * @param param the request object
     */
    patchNamespacedRoleBinding(param: RbacAuthorizationV1ApiPatchNamespacedRoleBindingRequest, options?: Configuration): Promise<V1RoleBinding>;
    /**
     * read the specified ClusterRole
     * @param param the request object
     */
    readClusterRole(param: RbacAuthorizationV1ApiReadClusterRoleRequest, options?: Configuration): Promise<V1ClusterRole>;
    /**
     * read the specified ClusterRoleBinding
     * @param param the request object
     */
    readClusterRoleBinding(param: RbacAuthorizationV1ApiReadClusterRoleBindingRequest, options?: Configuration): Promise<V1ClusterRoleBinding>;
    /**
     * read the specified Role
     * @param param the request object
     */
    readNamespacedRole(param: RbacAuthorizationV1ApiReadNamespacedRoleRequest, options?: Configuration): Promise<V1Role>;
    /**
     * read the specified RoleBinding
     * @param param the request object
     */
    readNamespacedRoleBinding(param: RbacAuthorizationV1ApiReadNamespacedRoleBindingRequest, options?: Configuration): Promise<V1RoleBinding>;
    /**
     * replace the specified ClusterRole
     * @param param the request object
     */
    replaceClusterRole(param: RbacAuthorizationV1ApiReplaceClusterRoleRequest, options?: Configuration): Promise<V1ClusterRole>;
    /**
     * replace the specified ClusterRoleBinding
     * @param param the request object
     */
    replaceClusterRoleBinding(param: RbacAuthorizationV1ApiReplaceClusterRoleBindingRequest, options?: Configuration): Promise<V1ClusterRoleBinding>;
    /**
     * replace the specified Role
     * @param param the request object
     */
    replaceNamespacedRole(param: RbacAuthorizationV1ApiReplaceNamespacedRoleRequest, options?: Configuration): Promise<V1Role>;
    /**
     * replace the specified RoleBinding
     * @param param the request object
     */
    replaceNamespacedRoleBinding(param: RbacAuthorizationV1ApiReplaceNamespacedRoleBindingRequest, options?: Configuration): Promise<V1RoleBinding>;
}
import { RbacAuthorizationV1alpha1ApiRequestFactory, RbacAuthorizationV1alpha1ApiResponseProcessor } from "../apis/RbacAuthorizationV1alpha1Api";
export interface RbacAuthorizationV1alpha1ApiCreateClusterRoleRequest {
    /**
     *
     * @type V1alpha1ClusterRole
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRole
     */
    body: V1alpha1ClusterRole;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1alpha1ApiCreateClusterRoleBindingRequest {
    /**
     *
     * @type V1alpha1ClusterRoleBinding
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRoleBinding
     */
    body: V1alpha1ClusterRoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateClusterRoleBinding
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1alpha1ApiCreateNamespacedRoleRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRole
     */
    namespace: string;
    /**
     *
     * @type V1alpha1Role
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRole
     */
    body: V1alpha1Role;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1alpha1ApiCreateNamespacedRoleBindingRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRoleBinding
     */
    namespace: string;
    /**
     *
     * @type V1alpha1RoleBinding
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRoleBinding
     */
    body: V1alpha1RoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApicreateNamespacedRoleBinding
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1alpha1ApiDeleteClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRole
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRole
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRole
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRole
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiDeleteClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRoleBinding
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRoleBinding
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRoleBinding
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteClusterRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiDeleteCollectionClusterRoleRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiDeleteCollectionClusterRoleBindingRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionClusterRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiDeleteCollectionNamespacedRoleRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiDeleteCollectionNamespacedRoleBindingRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteCollectionNamespacedRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiDeleteNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRole
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiDeleteNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof RbacAuthorizationV1alpha1ApideleteNamespacedRoleBinding
     */
    body?: V1DeleteOptions;
}
export interface RbacAuthorizationV1alpha1ApiGetAPIResourcesRequest {
}
export interface RbacAuthorizationV1alpha1ApiListClusterRoleRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRole
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiListClusterRoleBindingRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistClusterRoleBinding
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiListNamespacedRoleRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRole
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiListNamespacedRoleBindingRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistNamespacedRoleBinding
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiListRoleBindingForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistRoleBindingForAllNamespaces
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiListRoleForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApilistRoleForAllNamespaces
     */
    watch?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiPatchClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRole
     */
    name: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRole
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRole
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRole
     */
    force?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiPatchClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRoleBinding
     */
    name: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRoleBinding
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRoleBinding
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApipatchClusterRoleBinding
     */
    force?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiPatchNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRole
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRole
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRole
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRole
     */
    force?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiPatchNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRoleBinding
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRoleBinding
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRoleBinding
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof RbacAuthorizationV1alpha1ApipatchNamespacedRoleBinding
     */
    force?: boolean;
}
export interface RbacAuthorizationV1alpha1ApiReadClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadClusterRole
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadClusterRole
     */
    pretty?: string;
}
export interface RbacAuthorizationV1alpha1ApiReadClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadClusterRoleBinding
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadClusterRoleBinding
     */
    pretty?: string;
}
export interface RbacAuthorizationV1alpha1ApiReadNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadNamespacedRole
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadNamespacedRole
     */
    pretty?: string;
}
export interface RbacAuthorizationV1alpha1ApiReadNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadNamespacedRoleBinding
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireadNamespacedRoleBinding
     */
    pretty?: string;
}
export interface RbacAuthorizationV1alpha1ApiReplaceClusterRoleRequest {
    /**
     * name of the ClusterRole
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRole
     */
    name: string;
    /**
     *
     * @type V1alpha1ClusterRole
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRole
     */
    body: V1alpha1ClusterRole;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1alpha1ApiReplaceClusterRoleBindingRequest {
    /**
     * name of the ClusterRoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRoleBinding
     */
    name: string;
    /**
     *
     * @type V1alpha1ClusterRoleBinding
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRoleBinding
     */
    body: V1alpha1ClusterRoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceClusterRoleBinding
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1alpha1ApiReplaceNamespacedRoleRequest {
    /**
     * name of the Role
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRole
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRole
     */
    namespace: string;
    /**
     *
     * @type V1alpha1Role
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRole
     */
    body: V1alpha1Role;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRole
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRole
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRole
     */
    fieldManager?: string;
}
export interface RbacAuthorizationV1alpha1ApiReplaceNamespacedRoleBindingRequest {
    /**
     * name of the RoleBinding
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRoleBinding
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRoleBinding
     */
    namespace: string;
    /**
     *
     * @type V1alpha1RoleBinding
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRoleBinding
     */
    body: V1alpha1RoleBinding;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRoleBinding
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRoleBinding
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof RbacAuthorizationV1alpha1ApireplaceNamespacedRoleBinding
     */
    fieldManager?: string;
}
export declare class ObjectRbacAuthorizationV1alpha1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: RbacAuthorizationV1alpha1ApiRequestFactory, responseProcessor?: RbacAuthorizationV1alpha1ApiResponseProcessor);
    /**
     * create a ClusterRole
     * @param param the request object
     */
    createClusterRole(param: RbacAuthorizationV1alpha1ApiCreateClusterRoleRequest, options?: Configuration): Promise<V1alpha1ClusterRole>;
    /**
     * create a ClusterRoleBinding
     * @param param the request object
     */
    createClusterRoleBinding(param: RbacAuthorizationV1alpha1ApiCreateClusterRoleBindingRequest, options?: Configuration): Promise<V1alpha1ClusterRoleBinding>;
    /**
     * create a Role
     * @param param the request object
     */
    createNamespacedRole(param: RbacAuthorizationV1alpha1ApiCreateNamespacedRoleRequest, options?: Configuration): Promise<V1alpha1Role>;
    /**
     * create a RoleBinding
     * @param param the request object
     */
    createNamespacedRoleBinding(param: RbacAuthorizationV1alpha1ApiCreateNamespacedRoleBindingRequest, options?: Configuration): Promise<V1alpha1RoleBinding>;
    /**
     * delete a ClusterRole
     * @param param the request object
     */
    deleteClusterRole(param: RbacAuthorizationV1alpha1ApiDeleteClusterRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a ClusterRoleBinding
     * @param param the request object
     */
    deleteClusterRoleBinding(param: RbacAuthorizationV1alpha1ApiDeleteClusterRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ClusterRole
     * @param param the request object
     */
    deleteCollectionClusterRole(param?: RbacAuthorizationV1alpha1ApiDeleteCollectionClusterRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of ClusterRoleBinding
     * @param param the request object
     */
    deleteCollectionClusterRoleBinding(param?: RbacAuthorizationV1alpha1ApiDeleteCollectionClusterRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of Role
     * @param param the request object
     */
    deleteCollectionNamespacedRole(param: RbacAuthorizationV1alpha1ApiDeleteCollectionNamespacedRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of RoleBinding
     * @param param the request object
     */
    deleteCollectionNamespacedRoleBinding(param: RbacAuthorizationV1alpha1ApiDeleteCollectionNamespacedRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a Role
     * @param param the request object
     */
    deleteNamespacedRole(param: RbacAuthorizationV1alpha1ApiDeleteNamespacedRoleRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a RoleBinding
     * @param param the request object
     */
    deleteNamespacedRoleBinding(param: RbacAuthorizationV1alpha1ApiDeleteNamespacedRoleBindingRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: RbacAuthorizationV1alpha1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind ClusterRole
     * @param param the request object
     */
    listClusterRole(param?: RbacAuthorizationV1alpha1ApiListClusterRoleRequest, options?: Configuration): Promise<V1alpha1ClusterRoleList>;
    /**
     * list or watch objects of kind ClusterRoleBinding
     * @param param the request object
     */
    listClusterRoleBinding(param?: RbacAuthorizationV1alpha1ApiListClusterRoleBindingRequest, options?: Configuration): Promise<V1alpha1ClusterRoleBindingList>;
    /**
     * list or watch objects of kind Role
     * @param param the request object
     */
    listNamespacedRole(param: RbacAuthorizationV1alpha1ApiListNamespacedRoleRequest, options?: Configuration): Promise<V1alpha1RoleList>;
    /**
     * list or watch objects of kind RoleBinding
     * @param param the request object
     */
    listNamespacedRoleBinding(param: RbacAuthorizationV1alpha1ApiListNamespacedRoleBindingRequest, options?: Configuration): Promise<V1alpha1RoleBindingList>;
    /**
     * list or watch objects of kind RoleBinding
     * @param param the request object
     */
    listRoleBindingForAllNamespaces(param?: RbacAuthorizationV1alpha1ApiListRoleBindingForAllNamespacesRequest, options?: Configuration): Promise<V1alpha1RoleBindingList>;
    /**
     * list or watch objects of kind Role
     * @param param the request object
     */
    listRoleForAllNamespaces(param?: RbacAuthorizationV1alpha1ApiListRoleForAllNamespacesRequest, options?: Configuration): Promise<V1alpha1RoleList>;
    /**
     * partially update the specified ClusterRole
     * @param param the request object
     */
    patchClusterRole(param: RbacAuthorizationV1alpha1ApiPatchClusterRoleRequest, options?: Configuration): Promise<V1alpha1ClusterRole>;
    /**
     * partially update the specified ClusterRoleBinding
     * @param param the request object
     */
    patchClusterRoleBinding(param: RbacAuthorizationV1alpha1ApiPatchClusterRoleBindingRequest, options?: Configuration): Promise<V1alpha1ClusterRoleBinding>;
    /**
     * partially update the specified Role
     * @param param the request object
     */
    patchNamespacedRole(param: RbacAuthorizationV1alpha1ApiPatchNamespacedRoleRequest, options?: Configuration): Promise<V1alpha1Role>;
    /**
     * partially update the specified RoleBinding
     * @param param the request object
     */
    patchNamespacedRoleBinding(param: RbacAuthorizationV1alpha1ApiPatchNamespacedRoleBindingRequest, options?: Configuration): Promise<V1alpha1RoleBinding>;
    /**
     * read the specified ClusterRole
     * @param param the request object
     */
    readClusterRole(param: RbacAuthorizationV1alpha1ApiReadClusterRoleRequest, options?: Configuration): Promise<V1alpha1ClusterRole>;
    /**
     * read the specified ClusterRoleBinding
     * @param param the request object
     */
    readClusterRoleBinding(param: RbacAuthorizationV1alpha1ApiReadClusterRoleBindingRequest, options?: Configuration): Promise<V1alpha1ClusterRoleBinding>;
    /**
     * read the specified Role
     * @param param the request object
     */
    readNamespacedRole(param: RbacAuthorizationV1alpha1ApiReadNamespacedRoleRequest, options?: Configuration): Promise<V1alpha1Role>;
    /**
     * read the specified RoleBinding
     * @param param the request object
     */
    readNamespacedRoleBinding(param: RbacAuthorizationV1alpha1ApiReadNamespacedRoleBindingRequest, options?: Configuration): Promise<V1alpha1RoleBinding>;
    /**
     * replace the specified ClusterRole
     * @param param the request object
     */
    replaceClusterRole(param: RbacAuthorizationV1alpha1ApiReplaceClusterRoleRequest, options?: Configuration): Promise<V1alpha1ClusterRole>;
    /**
     * replace the specified ClusterRoleBinding
     * @param param the request object
     */
    replaceClusterRoleBinding(param: RbacAuthorizationV1alpha1ApiReplaceClusterRoleBindingRequest, options?: Configuration): Promise<V1alpha1ClusterRoleBinding>;
    /**
     * replace the specified Role
     * @param param the request object
     */
    replaceNamespacedRole(param: RbacAuthorizationV1alpha1ApiReplaceNamespacedRoleRequest, options?: Configuration): Promise<V1alpha1Role>;
    /**
     * replace the specified RoleBinding
     * @param param the request object
     */
    replaceNamespacedRoleBinding(param: RbacAuthorizationV1alpha1ApiReplaceNamespacedRoleBindingRequest, options?: Configuration): Promise<V1alpha1RoleBinding>;
}
import { SchedulingApiRequestFactory, SchedulingApiResponseProcessor } from "../apis/SchedulingApi";
export interface SchedulingApiGetAPIGroupRequest {
}
export declare class ObjectSchedulingApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: SchedulingApiRequestFactory, responseProcessor?: SchedulingApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: SchedulingApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { SchedulingV1ApiRequestFactory, SchedulingV1ApiResponseProcessor } from "../apis/SchedulingV1Api";
export interface SchedulingV1ApiCreatePriorityClassRequest {
    /**
     *
     * @type V1PriorityClass
     * @memberof SchedulingV1ApicreatePriorityClass
     */
    body: V1PriorityClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1ApicreatePriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1ApicreatePriorityClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof SchedulingV1ApicreatePriorityClass
     */
    fieldManager?: string;
}
export interface SchedulingV1ApiDeleteCollectionPriorityClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof SchedulingV1ApideleteCollectionPriorityClass
     */
    body?: V1DeleteOptions;
}
export interface SchedulingV1ApiDeletePriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1ApideletePriorityClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1ApideletePriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1ApideletePriorityClass
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof SchedulingV1ApideletePriorityClass
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof SchedulingV1ApideletePriorityClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof SchedulingV1ApideletePriorityClass
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof SchedulingV1ApideletePriorityClass
     */
    body?: V1DeleteOptions;
}
export interface SchedulingV1ApiGetAPIResourcesRequest {
}
export interface SchedulingV1ApiListPriorityClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1ApilistPriorityClass
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof SchedulingV1ApilistPriorityClass
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof SchedulingV1ApilistPriorityClass
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof SchedulingV1ApilistPriorityClass
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof SchedulingV1ApilistPriorityClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof SchedulingV1ApilistPriorityClass
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1ApilistPriorityClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1ApilistPriorityClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof SchedulingV1ApilistPriorityClass
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof SchedulingV1ApilistPriorityClass
     */
    watch?: boolean;
}
export interface SchedulingV1ApiPatchPriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1ApipatchPriorityClass
     */
    name: string;
    /**
     *
     * @type any
     * @memberof SchedulingV1ApipatchPriorityClass
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1ApipatchPriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1ApipatchPriorityClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof SchedulingV1ApipatchPriorityClass
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof SchedulingV1ApipatchPriorityClass
     */
    force?: boolean;
}
export interface SchedulingV1ApiReadPriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1ApireadPriorityClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1ApireadPriorityClass
     */
    pretty?: string;
}
export interface SchedulingV1ApiReplacePriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1ApireplacePriorityClass
     */
    name: string;
    /**
     *
     * @type V1PriorityClass
     * @memberof SchedulingV1ApireplacePriorityClass
     */
    body: V1PriorityClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1ApireplacePriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1ApireplacePriorityClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof SchedulingV1ApireplacePriorityClass
     */
    fieldManager?: string;
}
export declare class ObjectSchedulingV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: SchedulingV1ApiRequestFactory, responseProcessor?: SchedulingV1ApiResponseProcessor);
    /**
     * create a PriorityClass
     * @param param the request object
     */
    createPriorityClass(param: SchedulingV1ApiCreatePriorityClassRequest, options?: Configuration): Promise<V1PriorityClass>;
    /**
     * delete collection of PriorityClass
     * @param param the request object
     */
    deleteCollectionPriorityClass(param?: SchedulingV1ApiDeleteCollectionPriorityClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PriorityClass
     * @param param the request object
     */
    deletePriorityClass(param: SchedulingV1ApiDeletePriorityClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: SchedulingV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind PriorityClass
     * @param param the request object
     */
    listPriorityClass(param?: SchedulingV1ApiListPriorityClassRequest, options?: Configuration): Promise<V1PriorityClassList>;
    /**
     * partially update the specified PriorityClass
     * @param param the request object
     */
    patchPriorityClass(param: SchedulingV1ApiPatchPriorityClassRequest, options?: Configuration): Promise<V1PriorityClass>;
    /**
     * read the specified PriorityClass
     * @param param the request object
     */
    readPriorityClass(param: SchedulingV1ApiReadPriorityClassRequest, options?: Configuration): Promise<V1PriorityClass>;
    /**
     * replace the specified PriorityClass
     * @param param the request object
     */
    replacePriorityClass(param: SchedulingV1ApiReplacePriorityClassRequest, options?: Configuration): Promise<V1PriorityClass>;
}
import { SchedulingV1alpha1ApiRequestFactory, SchedulingV1alpha1ApiResponseProcessor } from "../apis/SchedulingV1alpha1Api";
export interface SchedulingV1alpha1ApiCreatePriorityClassRequest {
    /**
     *
     * @type V1alpha1PriorityClass
     * @memberof SchedulingV1alpha1ApicreatePriorityClass
     */
    body: V1alpha1PriorityClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1alpha1ApicreatePriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1alpha1ApicreatePriorityClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof SchedulingV1alpha1ApicreatePriorityClass
     */
    fieldManager?: string;
}
export interface SchedulingV1alpha1ApiDeleteCollectionPriorityClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof SchedulingV1alpha1ApideleteCollectionPriorityClass
     */
    body?: V1DeleteOptions;
}
export interface SchedulingV1alpha1ApiDeletePriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1alpha1ApideletePriorityClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1alpha1ApideletePriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1alpha1ApideletePriorityClass
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof SchedulingV1alpha1ApideletePriorityClass
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof SchedulingV1alpha1ApideletePriorityClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof SchedulingV1alpha1ApideletePriorityClass
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof SchedulingV1alpha1ApideletePriorityClass
     */
    body?: V1DeleteOptions;
}
export interface SchedulingV1alpha1ApiGetAPIResourcesRequest {
}
export interface SchedulingV1alpha1ApiListPriorityClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof SchedulingV1alpha1ApilistPriorityClass
     */
    watch?: boolean;
}
export interface SchedulingV1alpha1ApiPatchPriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1alpha1ApipatchPriorityClass
     */
    name: string;
    /**
     *
     * @type any
     * @memberof SchedulingV1alpha1ApipatchPriorityClass
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1alpha1ApipatchPriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1alpha1ApipatchPriorityClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof SchedulingV1alpha1ApipatchPriorityClass
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof SchedulingV1alpha1ApipatchPriorityClass
     */
    force?: boolean;
}
export interface SchedulingV1alpha1ApiReadPriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1alpha1ApireadPriorityClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1alpha1ApireadPriorityClass
     */
    pretty?: string;
}
export interface SchedulingV1alpha1ApiReplacePriorityClassRequest {
    /**
     * name of the PriorityClass
     * @type string
     * @memberof SchedulingV1alpha1ApireplacePriorityClass
     */
    name: string;
    /**
     *
     * @type V1alpha1PriorityClass
     * @memberof SchedulingV1alpha1ApireplacePriorityClass
     */
    body: V1alpha1PriorityClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof SchedulingV1alpha1ApireplacePriorityClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof SchedulingV1alpha1ApireplacePriorityClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof SchedulingV1alpha1ApireplacePriorityClass
     */
    fieldManager?: string;
}
export declare class ObjectSchedulingV1alpha1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: SchedulingV1alpha1ApiRequestFactory, responseProcessor?: SchedulingV1alpha1ApiResponseProcessor);
    /**
     * create a PriorityClass
     * @param param the request object
     */
    createPriorityClass(param: SchedulingV1alpha1ApiCreatePriorityClassRequest, options?: Configuration): Promise<V1alpha1PriorityClass>;
    /**
     * delete collection of PriorityClass
     * @param param the request object
     */
    deleteCollectionPriorityClass(param?: SchedulingV1alpha1ApiDeleteCollectionPriorityClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a PriorityClass
     * @param param the request object
     */
    deletePriorityClass(param: SchedulingV1alpha1ApiDeletePriorityClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: SchedulingV1alpha1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind PriorityClass
     * @param param the request object
     */
    listPriorityClass(param?: SchedulingV1alpha1ApiListPriorityClassRequest, options?: Configuration): Promise<V1alpha1PriorityClassList>;
    /**
     * partially update the specified PriorityClass
     * @param param the request object
     */
    patchPriorityClass(param: SchedulingV1alpha1ApiPatchPriorityClassRequest, options?: Configuration): Promise<V1alpha1PriorityClass>;
    /**
     * read the specified PriorityClass
     * @param param the request object
     */
    readPriorityClass(param: SchedulingV1alpha1ApiReadPriorityClassRequest, options?: Configuration): Promise<V1alpha1PriorityClass>;
    /**
     * replace the specified PriorityClass
     * @param param the request object
     */
    replacePriorityClass(param: SchedulingV1alpha1ApiReplacePriorityClassRequest, options?: Configuration): Promise<V1alpha1PriorityClass>;
}
import { StorageApiRequestFactory, StorageApiResponseProcessor } from "../apis/StorageApi";
export interface StorageApiGetAPIGroupRequest {
}
export declare class ObjectStorageApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: StorageApiRequestFactory, responseProcessor?: StorageApiResponseProcessor);
    /**
     * get information of a group
     * @param param the request object
     */
    getAPIGroup(param?: StorageApiGetAPIGroupRequest, options?: Configuration): Promise<V1APIGroup>;
}
import { StorageV1ApiRequestFactory, StorageV1ApiResponseProcessor } from "../apis/StorageV1Api";
export interface StorageV1ApiCreateCSIDriverRequest {
    /**
     *
     * @type V1CSIDriver
     * @memberof StorageV1ApicreateCSIDriver
     */
    body: V1CSIDriver;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApicreateCSIDriver
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApicreateCSIDriver
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApicreateCSIDriver
     */
    fieldManager?: string;
}
export interface StorageV1ApiCreateCSINodeRequest {
    /**
     *
     * @type V1CSINode
     * @memberof StorageV1ApicreateCSINode
     */
    body: V1CSINode;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApicreateCSINode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApicreateCSINode
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApicreateCSINode
     */
    fieldManager?: string;
}
export interface StorageV1ApiCreateStorageClassRequest {
    /**
     *
     * @type V1StorageClass
     * @memberof StorageV1ApicreateStorageClass
     */
    body: V1StorageClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApicreateStorageClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApicreateStorageClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApicreateStorageClass
     */
    fieldManager?: string;
}
export interface StorageV1ApiCreateVolumeAttachmentRequest {
    /**
     *
     * @type V1VolumeAttachment
     * @memberof StorageV1ApicreateVolumeAttachment
     */
    body: V1VolumeAttachment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApicreateVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApicreateVolumeAttachment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApicreateVolumeAttachment
     */
    fieldManager?: string;
}
export interface StorageV1ApiDeleteCSIDriverRequest {
    /**
     * name of the CSIDriver
     * @type string
     * @memberof StorageV1ApideleteCSIDriver
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteCSIDriver
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteCSIDriver
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteCSIDriver
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteCSIDriver
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteCSIDriver
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteCSIDriver
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiDeleteCSINodeRequest {
    /**
     * name of the CSINode
     * @type string
     * @memberof StorageV1ApideleteCSINode
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteCSINode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteCSINode
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteCSINode
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteCSINode
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteCSINode
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteCSINode
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiDeleteCollectionCSIDriverRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteCollectionCSIDriver
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiDeleteCollectionCSINodeRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteCollectionCSINode
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiDeleteCollectionStorageClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteCollectionStorageClass
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiDeleteCollectionVolumeAttachmentRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteCollectionVolumeAttachment
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiDeleteStorageClassRequest {
    /**
     * name of the StorageClass
     * @type string
     * @memberof StorageV1ApideleteStorageClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteStorageClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteStorageClass
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteStorageClass
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteStorageClass
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteStorageClass
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteStorageClass
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiDeleteVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1ApideleteVolumeAttachment
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApideleteVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApideleteVolumeAttachment
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1ApideleteVolumeAttachment
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1ApideleteVolumeAttachment
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1ApideleteVolumeAttachment
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1ApideleteVolumeAttachment
     */
    body?: V1DeleteOptions;
}
export interface StorageV1ApiGetAPIResourcesRequest {
}
export interface StorageV1ApiListCSIDriverRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApilistCSIDriver
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1ApilistCSIDriver
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApilistCSIDriver
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistCSIDriver
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistCSIDriver
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApilistCSIDriver
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistCSIDriver
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistCSIDriver
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApilistCSIDriver
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1ApilistCSIDriver
     */
    watch?: boolean;
}
export interface StorageV1ApiListCSINodeRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApilistCSINode
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1ApilistCSINode
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApilistCSINode
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistCSINode
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistCSINode
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApilistCSINode
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistCSINode
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistCSINode
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApilistCSINode
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1ApilistCSINode
     */
    watch?: boolean;
}
export interface StorageV1ApiListStorageClassRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApilistStorageClass
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1ApilistStorageClass
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApilistStorageClass
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistStorageClass
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistStorageClass
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApilistStorageClass
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistStorageClass
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistStorageClass
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApilistStorageClass
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1ApilistStorageClass
     */
    watch?: boolean;
}
export interface StorageV1ApiListVolumeAttachmentRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApilistVolumeAttachment
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1ApilistVolumeAttachment
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1ApilistVolumeAttachment
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistVolumeAttachment
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1ApilistVolumeAttachment
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1ApilistVolumeAttachment
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistVolumeAttachment
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1ApilistVolumeAttachment
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1ApilistVolumeAttachment
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1ApilistVolumeAttachment
     */
    watch?: boolean;
}
export interface StorageV1ApiPatchCSIDriverRequest {
    /**
     * name of the CSIDriver
     * @type string
     * @memberof StorageV1ApipatchCSIDriver
     */
    name: string;
    /**
     *
     * @type any
     * @memberof StorageV1ApipatchCSIDriver
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApipatchCSIDriver
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApipatchCSIDriver
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1ApipatchCSIDriver
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1ApipatchCSIDriver
     */
    force?: boolean;
}
export interface StorageV1ApiPatchCSINodeRequest {
    /**
     * name of the CSINode
     * @type string
     * @memberof StorageV1ApipatchCSINode
     */
    name: string;
    /**
     *
     * @type any
     * @memberof StorageV1ApipatchCSINode
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApipatchCSINode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApipatchCSINode
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1ApipatchCSINode
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1ApipatchCSINode
     */
    force?: boolean;
}
export interface StorageV1ApiPatchStorageClassRequest {
    /**
     * name of the StorageClass
     * @type string
     * @memberof StorageV1ApipatchStorageClass
     */
    name: string;
    /**
     *
     * @type any
     * @memberof StorageV1ApipatchStorageClass
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApipatchStorageClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApipatchStorageClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1ApipatchStorageClass
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1ApipatchStorageClass
     */
    force?: boolean;
}
export interface StorageV1ApiPatchVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachment
     */
    name: string;
    /**
     *
     * @type any
     * @memberof StorageV1ApipatchVolumeAttachment
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachment
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1ApipatchVolumeAttachment
     */
    force?: boolean;
}
export interface StorageV1ApiPatchVolumeAttachmentStatusRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachmentStatus
     */
    name: string;
    /**
     *
     * @type any
     * @memberof StorageV1ApipatchVolumeAttachmentStatus
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachmentStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachmentStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1ApipatchVolumeAttachmentStatus
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1ApipatchVolumeAttachmentStatus
     */
    force?: boolean;
}
export interface StorageV1ApiReadCSIDriverRequest {
    /**
     * name of the CSIDriver
     * @type string
     * @memberof StorageV1ApireadCSIDriver
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireadCSIDriver
     */
    pretty?: string;
}
export interface StorageV1ApiReadCSINodeRequest {
    /**
     * name of the CSINode
     * @type string
     * @memberof StorageV1ApireadCSINode
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireadCSINode
     */
    pretty?: string;
}
export interface StorageV1ApiReadStorageClassRequest {
    /**
     * name of the StorageClass
     * @type string
     * @memberof StorageV1ApireadStorageClass
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireadStorageClass
     */
    pretty?: string;
}
export interface StorageV1ApiReadVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1ApireadVolumeAttachment
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireadVolumeAttachment
     */
    pretty?: string;
}
export interface StorageV1ApiReadVolumeAttachmentStatusRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1ApireadVolumeAttachmentStatus
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireadVolumeAttachmentStatus
     */
    pretty?: string;
}
export interface StorageV1ApiReplaceCSIDriverRequest {
    /**
     * name of the CSIDriver
     * @type string
     * @memberof StorageV1ApireplaceCSIDriver
     */
    name: string;
    /**
     *
     * @type V1CSIDriver
     * @memberof StorageV1ApireplaceCSIDriver
     */
    body: V1CSIDriver;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireplaceCSIDriver
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApireplaceCSIDriver
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApireplaceCSIDriver
     */
    fieldManager?: string;
}
export interface StorageV1ApiReplaceCSINodeRequest {
    /**
     * name of the CSINode
     * @type string
     * @memberof StorageV1ApireplaceCSINode
     */
    name: string;
    /**
     *
     * @type V1CSINode
     * @memberof StorageV1ApireplaceCSINode
     */
    body: V1CSINode;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireplaceCSINode
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApireplaceCSINode
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApireplaceCSINode
     */
    fieldManager?: string;
}
export interface StorageV1ApiReplaceStorageClassRequest {
    /**
     * name of the StorageClass
     * @type string
     * @memberof StorageV1ApireplaceStorageClass
     */
    name: string;
    /**
     *
     * @type V1StorageClass
     * @memberof StorageV1ApireplaceStorageClass
     */
    body: V1StorageClass;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireplaceStorageClass
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApireplaceStorageClass
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApireplaceStorageClass
     */
    fieldManager?: string;
}
export interface StorageV1ApiReplaceVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachment
     */
    name: string;
    /**
     *
     * @type V1VolumeAttachment
     * @memberof StorageV1ApireplaceVolumeAttachment
     */
    body: V1VolumeAttachment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachment
     */
    fieldManager?: string;
}
export interface StorageV1ApiReplaceVolumeAttachmentStatusRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachmentStatus
     */
    name: string;
    /**
     *
     * @type V1VolumeAttachment
     * @memberof StorageV1ApireplaceVolumeAttachmentStatus
     */
    body: V1VolumeAttachment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachmentStatus
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachmentStatus
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1ApireplaceVolumeAttachmentStatus
     */
    fieldManager?: string;
}
export declare class ObjectStorageV1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: StorageV1ApiRequestFactory, responseProcessor?: StorageV1ApiResponseProcessor);
    /**
     * create a CSIDriver
     * @param param the request object
     */
    createCSIDriver(param: StorageV1ApiCreateCSIDriverRequest, options?: Configuration): Promise<V1CSIDriver>;
    /**
     * create a CSINode
     * @param param the request object
     */
    createCSINode(param: StorageV1ApiCreateCSINodeRequest, options?: Configuration): Promise<V1CSINode>;
    /**
     * create a StorageClass
     * @param param the request object
     */
    createStorageClass(param: StorageV1ApiCreateStorageClassRequest, options?: Configuration): Promise<V1StorageClass>;
    /**
     * create a VolumeAttachment
     * @param param the request object
     */
    createVolumeAttachment(param: StorageV1ApiCreateVolumeAttachmentRequest, options?: Configuration): Promise<V1VolumeAttachment>;
    /**
     * delete a CSIDriver
     * @param param the request object
     */
    deleteCSIDriver(param: StorageV1ApiDeleteCSIDriverRequest, options?: Configuration): Promise<V1CSIDriver>;
    /**
     * delete a CSINode
     * @param param the request object
     */
    deleteCSINode(param: StorageV1ApiDeleteCSINodeRequest, options?: Configuration): Promise<V1CSINode>;
    /**
     * delete collection of CSIDriver
     * @param param the request object
     */
    deleteCollectionCSIDriver(param?: StorageV1ApiDeleteCollectionCSIDriverRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of CSINode
     * @param param the request object
     */
    deleteCollectionCSINode(param?: StorageV1ApiDeleteCollectionCSINodeRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of StorageClass
     * @param param the request object
     */
    deleteCollectionStorageClass(param?: StorageV1ApiDeleteCollectionStorageClassRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of VolumeAttachment
     * @param param the request object
     */
    deleteCollectionVolumeAttachment(param?: StorageV1ApiDeleteCollectionVolumeAttachmentRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a StorageClass
     * @param param the request object
     */
    deleteStorageClass(param: StorageV1ApiDeleteStorageClassRequest, options?: Configuration): Promise<V1StorageClass>;
    /**
     * delete a VolumeAttachment
     * @param param the request object
     */
    deleteVolumeAttachment(param: StorageV1ApiDeleteVolumeAttachmentRequest, options?: Configuration): Promise<V1VolumeAttachment>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: StorageV1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind CSIDriver
     * @param param the request object
     */
    listCSIDriver(param?: StorageV1ApiListCSIDriverRequest, options?: Configuration): Promise<V1CSIDriverList>;
    /**
     * list or watch objects of kind CSINode
     * @param param the request object
     */
    listCSINode(param?: StorageV1ApiListCSINodeRequest, options?: Configuration): Promise<V1CSINodeList>;
    /**
     * list or watch objects of kind StorageClass
     * @param param the request object
     */
    listStorageClass(param?: StorageV1ApiListStorageClassRequest, options?: Configuration): Promise<V1StorageClassList>;
    /**
     * list or watch objects of kind VolumeAttachment
     * @param param the request object
     */
    listVolumeAttachment(param?: StorageV1ApiListVolumeAttachmentRequest, options?: Configuration): Promise<V1VolumeAttachmentList>;
    /**
     * partially update the specified CSIDriver
     * @param param the request object
     */
    patchCSIDriver(param: StorageV1ApiPatchCSIDriverRequest, options?: Configuration): Promise<V1CSIDriver>;
    /**
     * partially update the specified CSINode
     * @param param the request object
     */
    patchCSINode(param: StorageV1ApiPatchCSINodeRequest, options?: Configuration): Promise<V1CSINode>;
    /**
     * partially update the specified StorageClass
     * @param param the request object
     */
    patchStorageClass(param: StorageV1ApiPatchStorageClassRequest, options?: Configuration): Promise<V1StorageClass>;
    /**
     * partially update the specified VolumeAttachment
     * @param param the request object
     */
    patchVolumeAttachment(param: StorageV1ApiPatchVolumeAttachmentRequest, options?: Configuration): Promise<V1VolumeAttachment>;
    /**
     * partially update status of the specified VolumeAttachment
     * @param param the request object
     */
    patchVolumeAttachmentStatus(param: StorageV1ApiPatchVolumeAttachmentStatusRequest, options?: Configuration): Promise<V1VolumeAttachment>;
    /**
     * read the specified CSIDriver
     * @param param the request object
     */
    readCSIDriver(param: StorageV1ApiReadCSIDriverRequest, options?: Configuration): Promise<V1CSIDriver>;
    /**
     * read the specified CSINode
     * @param param the request object
     */
    readCSINode(param: StorageV1ApiReadCSINodeRequest, options?: Configuration): Promise<V1CSINode>;
    /**
     * read the specified StorageClass
     * @param param the request object
     */
    readStorageClass(param: StorageV1ApiReadStorageClassRequest, options?: Configuration): Promise<V1StorageClass>;
    /**
     * read the specified VolumeAttachment
     * @param param the request object
     */
    readVolumeAttachment(param: StorageV1ApiReadVolumeAttachmentRequest, options?: Configuration): Promise<V1VolumeAttachment>;
    /**
     * read status of the specified VolumeAttachment
     * @param param the request object
     */
    readVolumeAttachmentStatus(param: StorageV1ApiReadVolumeAttachmentStatusRequest, options?: Configuration): Promise<V1VolumeAttachment>;
    /**
     * replace the specified CSIDriver
     * @param param the request object
     */
    replaceCSIDriver(param: StorageV1ApiReplaceCSIDriverRequest, options?: Configuration): Promise<V1CSIDriver>;
    /**
     * replace the specified CSINode
     * @param param the request object
     */
    replaceCSINode(param: StorageV1ApiReplaceCSINodeRequest, options?: Configuration): Promise<V1CSINode>;
    /**
     * replace the specified StorageClass
     * @param param the request object
     */
    replaceStorageClass(param: StorageV1ApiReplaceStorageClassRequest, options?: Configuration): Promise<V1StorageClass>;
    /**
     * replace the specified VolumeAttachment
     * @param param the request object
     */
    replaceVolumeAttachment(param: StorageV1ApiReplaceVolumeAttachmentRequest, options?: Configuration): Promise<V1VolumeAttachment>;
    /**
     * replace status of the specified VolumeAttachment
     * @param param the request object
     */
    replaceVolumeAttachmentStatus(param: StorageV1ApiReplaceVolumeAttachmentStatusRequest, options?: Configuration): Promise<V1VolumeAttachment>;
}
import { StorageV1alpha1ApiRequestFactory, StorageV1alpha1ApiResponseProcessor } from "../apis/StorageV1alpha1Api";
export interface StorageV1alpha1ApiCreateNamespacedCSIStorageCapacityRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1alpha1ApicreateNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     *
     * @type V1alpha1CSIStorageCapacity
     * @memberof StorageV1alpha1ApicreateNamespacedCSIStorageCapacity
     */
    body: V1alpha1CSIStorageCapacity;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApicreateNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApicreateNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1alpha1ApicreateNamespacedCSIStorageCapacity
     */
    fieldManager?: string;
}
export interface StorageV1alpha1ApiCreateVolumeAttachmentRequest {
    /**
     *
     * @type V1alpha1VolumeAttachment
     * @memberof StorageV1alpha1ApicreateVolumeAttachment
     */
    body: V1alpha1VolumeAttachment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApicreateVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApicreateVolumeAttachment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1alpha1ApicreateVolumeAttachment
     */
    fieldManager?: string;
}
export interface StorageV1alpha1ApiDeleteCollectionNamespacedCSIStorageCapacityRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1alpha1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    body?: V1DeleteOptions;
}
export interface StorageV1alpha1ApiDeleteCollectionVolumeAttachmentRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1alpha1ApideleteCollectionVolumeAttachment
     */
    body?: V1DeleteOptions;
}
export interface StorageV1alpha1ApiDeleteNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1alpha1ApideleteNamespacedCSIStorageCapacity
     */
    body?: V1DeleteOptions;
}
export interface StorageV1alpha1ApiDeleteVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1alpha1ApideleteVolumeAttachment
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApideleteVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApideleteVolumeAttachment
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1alpha1ApideleteVolumeAttachment
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1alpha1ApideleteVolumeAttachment
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1alpha1ApideleteVolumeAttachment
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1alpha1ApideleteVolumeAttachment
     */
    body?: V1DeleteOptions;
}
export interface StorageV1alpha1ApiGetAPIResourcesRequest {
}
export interface StorageV1alpha1ApiListCSIStorageCapacityForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1alpha1ApilistCSIStorageCapacityForAllNamespaces
     */
    watch?: boolean;
}
export interface StorageV1alpha1ApiListNamespacedCSIStorageCapacityRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1alpha1ApilistNamespacedCSIStorageCapacity
     */
    watch?: boolean;
}
export interface StorageV1alpha1ApiListVolumeAttachmentRequest {
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1alpha1ApilistVolumeAttachment
     */
    watch?: boolean;
}
export interface StorageV1alpha1ApiPatchNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1alpha1ApipatchNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1alpha1ApipatchNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof StorageV1alpha1ApipatchNamespacedCSIStorageCapacity
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApipatchNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApipatchNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1alpha1ApipatchNamespacedCSIStorageCapacity
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1alpha1ApipatchNamespacedCSIStorageCapacity
     */
    force?: boolean;
}
export interface StorageV1alpha1ApiPatchVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1alpha1ApipatchVolumeAttachment
     */
    name: string;
    /**
     *
     * @type any
     * @memberof StorageV1alpha1ApipatchVolumeAttachment
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApipatchVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApipatchVolumeAttachment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1alpha1ApipatchVolumeAttachment
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1alpha1ApipatchVolumeAttachment
     */
    force?: boolean;
}
export interface StorageV1alpha1ApiReadNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1alpha1ApireadNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1alpha1ApireadNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApireadNamespacedCSIStorageCapacity
     */
    pretty?: string;
}
export interface StorageV1alpha1ApiReadVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1alpha1ApireadVolumeAttachment
     */
    name: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApireadVolumeAttachment
     */
    pretty?: string;
}
export interface StorageV1alpha1ApiReplaceNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1alpha1ApireplaceNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1alpha1ApireplaceNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     *
     * @type V1alpha1CSIStorageCapacity
     * @memberof StorageV1alpha1ApireplaceNamespacedCSIStorageCapacity
     */
    body: V1alpha1CSIStorageCapacity;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApireplaceNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApireplaceNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1alpha1ApireplaceNamespacedCSIStorageCapacity
     */
    fieldManager?: string;
}
export interface StorageV1alpha1ApiReplaceVolumeAttachmentRequest {
    /**
     * name of the VolumeAttachment
     * @type string
     * @memberof StorageV1alpha1ApireplaceVolumeAttachment
     */
    name: string;
    /**
     *
     * @type V1alpha1VolumeAttachment
     * @memberof StorageV1alpha1ApireplaceVolumeAttachment
     */
    body: V1alpha1VolumeAttachment;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1alpha1ApireplaceVolumeAttachment
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1alpha1ApireplaceVolumeAttachment
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1alpha1ApireplaceVolumeAttachment
     */
    fieldManager?: string;
}
export declare class ObjectStorageV1alpha1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: StorageV1alpha1ApiRequestFactory, responseProcessor?: StorageV1alpha1ApiResponseProcessor);
    /**
     * create a CSIStorageCapacity
     * @param param the request object
     */
    createNamespacedCSIStorageCapacity(param: StorageV1alpha1ApiCreateNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1alpha1CSIStorageCapacity>;
    /**
     * create a VolumeAttachment
     * @param param the request object
     */
    createVolumeAttachment(param: StorageV1alpha1ApiCreateVolumeAttachmentRequest, options?: Configuration): Promise<V1alpha1VolumeAttachment>;
    /**
     * delete collection of CSIStorageCapacity
     * @param param the request object
     */
    deleteCollectionNamespacedCSIStorageCapacity(param: StorageV1alpha1ApiDeleteCollectionNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete collection of VolumeAttachment
     * @param param the request object
     */
    deleteCollectionVolumeAttachment(param?: StorageV1alpha1ApiDeleteCollectionVolumeAttachmentRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a CSIStorageCapacity
     * @param param the request object
     */
    deleteNamespacedCSIStorageCapacity(param: StorageV1alpha1ApiDeleteNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a VolumeAttachment
     * @param param the request object
     */
    deleteVolumeAttachment(param: StorageV1alpha1ApiDeleteVolumeAttachmentRequest, options?: Configuration): Promise<V1alpha1VolumeAttachment>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: StorageV1alpha1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind CSIStorageCapacity
     * @param param the request object
     */
    listCSIStorageCapacityForAllNamespaces(param?: StorageV1alpha1ApiListCSIStorageCapacityForAllNamespacesRequest, options?: Configuration): Promise<V1alpha1CSIStorageCapacityList>;
    /**
     * list or watch objects of kind CSIStorageCapacity
     * @param param the request object
     */
    listNamespacedCSIStorageCapacity(param: StorageV1alpha1ApiListNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1alpha1CSIStorageCapacityList>;
    /**
     * list or watch objects of kind VolumeAttachment
     * @param param the request object
     */
    listVolumeAttachment(param?: StorageV1alpha1ApiListVolumeAttachmentRequest, options?: Configuration): Promise<V1alpha1VolumeAttachmentList>;
    /**
     * partially update the specified CSIStorageCapacity
     * @param param the request object
     */
    patchNamespacedCSIStorageCapacity(param: StorageV1alpha1ApiPatchNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1alpha1CSIStorageCapacity>;
    /**
     * partially update the specified VolumeAttachment
     * @param param the request object
     */
    patchVolumeAttachment(param: StorageV1alpha1ApiPatchVolumeAttachmentRequest, options?: Configuration): Promise<V1alpha1VolumeAttachment>;
    /**
     * read the specified CSIStorageCapacity
     * @param param the request object
     */
    readNamespacedCSIStorageCapacity(param: StorageV1alpha1ApiReadNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1alpha1CSIStorageCapacity>;
    /**
     * read the specified VolumeAttachment
     * @param param the request object
     */
    readVolumeAttachment(param: StorageV1alpha1ApiReadVolumeAttachmentRequest, options?: Configuration): Promise<V1alpha1VolumeAttachment>;
    /**
     * replace the specified CSIStorageCapacity
     * @param param the request object
     */
    replaceNamespacedCSIStorageCapacity(param: StorageV1alpha1ApiReplaceNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1alpha1CSIStorageCapacity>;
    /**
     * replace the specified VolumeAttachment
     * @param param the request object
     */
    replaceVolumeAttachment(param: StorageV1alpha1ApiReplaceVolumeAttachmentRequest, options?: Configuration): Promise<V1alpha1VolumeAttachment>;
}
import { StorageV1beta1ApiRequestFactory, StorageV1beta1ApiResponseProcessor } from "../apis/StorageV1beta1Api";
export interface StorageV1beta1ApiCreateNamespacedCSIStorageCapacityRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1beta1ApicreateNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     *
     * @type V1beta1CSIStorageCapacity
     * @memberof StorageV1beta1ApicreateNamespacedCSIStorageCapacity
     */
    body: V1beta1CSIStorageCapacity;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApicreateNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1beta1ApicreateNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1beta1ApicreateNamespacedCSIStorageCapacity
     */
    fieldManager?: string;
}
export interface StorageV1beta1ApiDeleteCollectionNamespacedCSIStorageCapacityRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    _continue?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    fieldSelector?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    gracePeriodSeconds?: number;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    limit?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    propagationPolicy?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    timeoutSeconds?: number;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1beta1ApideleteCollectionNamespacedCSIStorageCapacity
     */
    body?: V1DeleteOptions;
}
export interface StorageV1beta1ApiDeleteNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
     * @type number
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    gracePeriodSeconds?: number;
    /**
     * Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object\&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
     * @type boolean
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    orphanDependents?: boolean;
    /**
     * Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: \&#39;Orphan\&#39; - orphan the dependents; \&#39;Background\&#39; - allow the garbage collector to delete the dependents in the background; \&#39;Foreground\&#39; - a cascading policy that deletes all dependents in the foreground.
     * @type string
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    propagationPolicy?: string;
    /**
     *
     * @type V1DeleteOptions
     * @memberof StorageV1beta1ApideleteNamespacedCSIStorageCapacity
     */
    body?: V1DeleteOptions;
}
export interface StorageV1beta1ApiGetAPIResourcesRequest {
}
export interface StorageV1beta1ApiListCSIStorageCapacityForAllNamespacesRequest {
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    limit?: number;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    pretty?: string;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1beta1ApilistCSIStorageCapacityForAllNamespaces
     */
    watch?: boolean;
}
export interface StorageV1beta1ApiListNamespacedCSIStorageCapacityRequest {
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * allowWatchBookmarks requests watch events with type \&quot;BOOKMARK\&quot;. Servers that do not implement bookmarks may ignore this flag and bookmarks are sent at the server\&#39;s discretion. Clients should not assume bookmarks are returned at any specific interval, nor may they assume the server will send any BOOKMARK event during a session. If this is not a watch, this field is ignored.
     * @type boolean
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    allowWatchBookmarks?: boolean;
    /**
     * The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server, the server will respond with a 410 ResourceExpired error together with a continue token. If the client needs a consistent list, it must restart their list without the continue field. Otherwise, the client may send another list request with the token received with the 410 error, the server will respond with a list starting from the next key, but from the latest snapshot, which is inconsistent from the previous list results - objects that are created, modified, or deleted after the first list request will be included in the response, as long as their keys are after the \&quot;next key\&quot;.  This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
     * @type string
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    _continue?: string;
    /**
     * A selector to restrict the list of returned objects by their fields. Defaults to everything.
     * @type string
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    fieldSelector?: string;
    /**
     * A selector to restrict the list of returned objects by their labels. Defaults to everything.
     * @type string
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    labelSelector?: string;
    /**
     * limit is a maximum number of responses to return for a list call. If more items exist, the server will set the &#x60;continue&#x60; field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.  The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
     * @type number
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    limit?: number;
    /**
     * resourceVersion sets a constraint on what resource versions a request may be served from. See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    resourceVersion?: string;
    /**
     * resourceVersionMatch determines how resourceVersion is applied to list calls. It is highly recommended that resourceVersionMatch be set for list calls where resourceVersion is set See https://kubernetes.io/docs/reference/using-api/api-concepts/#resource-versions for details.  Defaults to unset
     * @type string
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    resourceVersionMatch?: string;
    /**
     * Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
     * @type number
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    timeoutSeconds?: number;
    /**
     * Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
     * @type boolean
     * @memberof StorageV1beta1ApilistNamespacedCSIStorageCapacity
     */
    watch?: boolean;
}
export interface StorageV1beta1ApiPatchNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1beta1ApipatchNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1beta1ApipatchNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     *
     * @type any
     * @memberof StorageV1beta1ApipatchNamespacedCSIStorageCapacity
     */
    body: any;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApipatchNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1beta1ApipatchNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint. This field is required for apply requests (application/apply-patch) but optional for non-apply patch types (JsonPatch, MergePatch, StrategicMergePatch).
     * @type string
     * @memberof StorageV1beta1ApipatchNamespacedCSIStorageCapacity
     */
    fieldManager?: string;
    /**
     * Force is going to \&quot;force\&quot; Apply requests. It means user will re-acquire conflicting fields owned by other people. Force flag must be unset for non-apply patch requests.
     * @type boolean
     * @memberof StorageV1beta1ApipatchNamespacedCSIStorageCapacity
     */
    force?: boolean;
}
export interface StorageV1beta1ApiReadNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1beta1ApireadNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1beta1ApireadNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApireadNamespacedCSIStorageCapacity
     */
    pretty?: string;
}
export interface StorageV1beta1ApiReplaceNamespacedCSIStorageCapacityRequest {
    /**
     * name of the CSIStorageCapacity
     * @type string
     * @memberof StorageV1beta1ApireplaceNamespacedCSIStorageCapacity
     */
    name: string;
    /**
     * object name and auth scope, such as for teams and projects
     * @type string
     * @memberof StorageV1beta1ApireplaceNamespacedCSIStorageCapacity
     */
    namespace: string;
    /**
     *
     * @type V1beta1CSIStorageCapacity
     * @memberof StorageV1beta1ApireplaceNamespacedCSIStorageCapacity
     */
    body: V1beta1CSIStorageCapacity;
    /**
     * If \&#39;true\&#39;, then the output is pretty printed.
     * @type string
     * @memberof StorageV1beta1ApireplaceNamespacedCSIStorageCapacity
     */
    pretty?: string;
    /**
     * When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
     * @type string
     * @memberof StorageV1beta1ApireplaceNamespacedCSIStorageCapacity
     */
    dryRun?: string;
    /**
     * fieldManager is a name associated with the actor or entity that is making these changes. The value must be less than or 128 characters long, and only contain printable characters, as defined by https://golang.org/pkg/unicode/#IsPrint.
     * @type string
     * @memberof StorageV1beta1ApireplaceNamespacedCSIStorageCapacity
     */
    fieldManager?: string;
}
export declare class ObjectStorageV1beta1Api {
    private api;
    constructor(configuration: Configuration, requestFactory?: StorageV1beta1ApiRequestFactory, responseProcessor?: StorageV1beta1ApiResponseProcessor);
    /**
     * create a CSIStorageCapacity
     * @param param the request object
     */
    createNamespacedCSIStorageCapacity(param: StorageV1beta1ApiCreateNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1beta1CSIStorageCapacity>;
    /**
     * delete collection of CSIStorageCapacity
     * @param param the request object
     */
    deleteCollectionNamespacedCSIStorageCapacity(param: StorageV1beta1ApiDeleteCollectionNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1Status>;
    /**
     * delete a CSIStorageCapacity
     * @param param the request object
     */
    deleteNamespacedCSIStorageCapacity(param: StorageV1beta1ApiDeleteNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1Status>;
    /**
     * get available resources
     * @param param the request object
     */
    getAPIResources(param?: StorageV1beta1ApiGetAPIResourcesRequest, options?: Configuration): Promise<V1APIResourceList>;
    /**
     * list or watch objects of kind CSIStorageCapacity
     * @param param the request object
     */
    listCSIStorageCapacityForAllNamespaces(param?: StorageV1beta1ApiListCSIStorageCapacityForAllNamespacesRequest, options?: Configuration): Promise<V1beta1CSIStorageCapacityList>;
    /**
     * list or watch objects of kind CSIStorageCapacity
     * @param param the request object
     */
    listNamespacedCSIStorageCapacity(param: StorageV1beta1ApiListNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1beta1CSIStorageCapacityList>;
    /**
     * partially update the specified CSIStorageCapacity
     * @param param the request object
     */
    patchNamespacedCSIStorageCapacity(param: StorageV1beta1ApiPatchNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1beta1CSIStorageCapacity>;
    /**
     * read the specified CSIStorageCapacity
     * @param param the request object
     */
    readNamespacedCSIStorageCapacity(param: StorageV1beta1ApiReadNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1beta1CSIStorageCapacity>;
    /**
     * replace the specified CSIStorageCapacity
     * @param param the request object
     */
    replaceNamespacedCSIStorageCapacity(param: StorageV1beta1ApiReplaceNamespacedCSIStorageCapacityRequest, options?: Configuration): Promise<V1beta1CSIStorageCapacity>;
}
import { VersionApiRequestFactory, VersionApiResponseProcessor } from "../apis/VersionApi";
export interface VersionApiGetCodeRequest {
}
export declare class ObjectVersionApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: VersionApiRequestFactory, responseProcessor?: VersionApiResponseProcessor);
    /**
     * get the code version
     * @param param the request object
     */
    getCode(param?: VersionApiGetCodeRequest, options?: Configuration): Promise<VersionInfo>;
}
import { WellKnownApiRequestFactory, WellKnownApiResponseProcessor } from "../apis/WellKnownApi";
export interface WellKnownApiGetServiceAccountIssuerOpenIDConfigurationRequest {
}
export declare class ObjectWellKnownApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: WellKnownApiRequestFactory, responseProcessor?: WellKnownApiResponseProcessor);
    /**
     * get service account issuer OpenID configuration, also known as the \'OIDC discovery doc\'
     * @param param the request object
     */
    getServiceAccountIssuerOpenIDConfiguration(param?: WellKnownApiGetServiceAccountIssuerOpenIDConfigurationRequest, options?: Configuration): Promise<string>;
}
